diff -pruN 9.2-1/ChangeLog 10.0-1/ChangeLog
--- 9.2-1/ChangeLog	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/ChangeLog	2018-09-09 17:18:14.000000000 +0000
@@ -1,3 +1,147 @@
+2018-09-09 - v10.0
+
+This release of pgBadger is a major release that adds some new
+features and fix all issues reported by users since last release.
+
+  * Add support of pgbouncer syslog log file format.
+  * Add support to all auto_explain format (text, xml, json and yaml).
+  * Add support to %q placeholder in log_line_prefix.
+  * Add jsonlog format of Michael Paquier extension, with -f jsonlog
+    pgbadger will be able to parse the log.
+  * Replace the SQL formatter/beautify with v3.0 of pgFormatter.
+
+There is some new command line option:
+
+  - Add --prettify-json command line option to prettify JSON output.
+  - Add --log-timezone  +/-XX  command line option to set the number
+    of hours from GMT of the timezone that must be used to adjust
+    date/time read from log file before beeing parsed. Note that you
+    might still need to adjust the graph timezone using -Z when the
+    client has not the same timezone.
+  - Add --include-time option to add the ability to choose times that
+    you want to see, instead of excluding all the times you do not
+    want to see (--exclude-time).
+
+The pgBadger project and copyrights has been transfered from Dalibo
+to the author and official maintainer of the project. Please update
+your links:
+
+  - Web site: http://pgbadger.darold.net/
+  - Source code: https://github.com/darold/pgbadger
+
+I want to thanks the great guys at Dalibo for all their investments
+into pgBadger during these years and especially Damien Clochard and
+Jean-paul argudo for their help to promote pgBadger.
+
+
+  - Fix checkpoint distance and estimate not reported in incremental
+    mode. Thanks to aleszeleny for the report.
+  - Fix title of pgbouncer simultaneous session report. Thansks to
+    Jehan Guillaume De Rorthais for the report.
+  - Add support of pgbouncer syslog log file format. Thanks to djester
+    for the feature request.
+  - Fix error when a remote log is empty. Thanks to Parasit Hendersson
+    for the report.
+  - Fix test with binary format. Binary file must be generated as it
+    is dependent of the plateform. Thanks to Michal Nowak for the
+    report.
+  - Fix case where an empty explain plan is generated.
+  - Fix parsing of autodetected default format with a prefix in
+    command line.
+  - Remove dependency of git command in Makefile.PL.
+  - Update documentation about options changes and remove of the
+    [%l-1] part of the mandatory prefix.
+  - Fix parsing of vacuum / analyze system usage for PostgreSQL 10.
+    Thanks to Achilleas Mantzios for the patch.
+  - Fix Temporary File Activity table.
+  - Remove dependency to git during install.
+  - Add --log-timezone  +/-XX  command line option to set the number
+    of hours from GMT of the timezone that must be used to adjust
+    date/time read from log file before beeing parsed. Using this
+    option make more difficult log search with a date/time because the
+    time will not be the same in the log. Note that you might still
+    need to adjust the graph timezone using -Z when the client has not
+    the same timezone. Thanks to xdexter for the feature request and
+    Julien Tachoire for the patch.
+  - Add support to auto_explain json output format. Thanks to dmius
+    for the report.
+  - Fix auto_explain parser and queries that was counted twice.
+    Thanks to zam6ak for the report.
+  - Fix checkpoint regex to match PostgreSQL 10 log messages. Thanks
+    to Edmund Horner for the patch.
+  - Update description of -f | --format option by adding information
+    about jsonlog format.
+  - Fix query normalisation to not duplicate with bind queries.
+    Normalisation of values are now tranformed into a single ? and no
+    more 0 for numbers, two single quote for string. Thanks to vadv
+    for the report.
+  - Fix log level count. Thanks to Jean-Christophe Arnu for the report
+  - Make pgbadger more compliant with B::Lint bare sub name.
+  - Made perlcritic happy.
+  - Add --prettify-json command line option to prettify JSON output.
+    Default output is all in single line.
+  - Fix Events distribution report.
+  - Fix bug with --prefix when log_line_prefix contain multiple %%.
+    Thanks to svb007 for the report.
+  - Add --log-timezone  +/-XX  command line option to set the number
+    of hours from GMT of the timezone that must be used to adjust
+    date/time read from log file before beeing parsed. Using this
+    option make more difficult log search with a date/time because the
+    time will not be the same in the log. Note that you might still
+    need to adjust the graph timezone using -Z when the client has not
+    the same timezone. Thanks to xdexter for the feature request.
+  - Remove INDEXES from the keyword list and add BUFFERS to this list.
+  - Fix normalization of query using cursors.
+  - Remove Dockerfile and documentation about docker run. pgBadger
+    comes as a single Perl script without any dependence and it can
+    be used on any plateform. It is a non sens to use docker to run
+    pgbadger, if you don't want to install anything, just copy the
+    file pgbadger where you want and execute it.
+  - Fix broken grid when no temp files activity. Thanks to Pierre
+    Giraud for the patch
+  - Add doc warning about log_in_duration_statement vs log_duration +
+    log_statement. Thanks to Julien Tachoire for the patch.
+  - Apply timezone offset to bar charts. Thanks to Julien Tachoire
+    for the patch.
+  - Delete current temp file info if we meet an error for the same PID
+    Thanks to Julien Tachoire for the patch.
+  - Consistently use app= in examples, and support appname=
+    Some of the usage examples used appname= in the prefix, but the
+    code didn't recognize that token. Use app= in all examples, and
+    add appname= to the prefix parser. Thanks to Christoph Berg for
+    the patch
+  - Fix wrong long name for option -J that should be --Jobs intead
+    of --job_per_file. Thanks to Chad Trabant for the report and
+    Etienne Bersac for the patch.
+  - Ignore blib files. Thanks to Etienne Bersac for the patch.
+  - Add consistency tests. Thanks to damien clochard for the patch.
+  - doc update : stderr is not a default for -f. Thanks to Christophe
+    Courtois for the patch.
+  - Always update pod and README. Thanks to Etienne Bersac for
+    the patch.
+  - Add some regression tests. Thanks to Etienne Bersac for the patch.
+  - Add editorconfig configuration. Thanks to Etienne Bersac for the
+    patch.
+  - Drop vi temp files from gitignore. Thanks to Etienne Bersac for
+    the patch.
+  - Add --include-time option to add the ability to choose times that
+    you want to see, instead of excluding all the times you do not
+    want to see. This is handy when wanting to view only one or two
+    days from a week's worth of logs (simplifies down from multiple
+    --exlucde-time options to one --include-time). Thanks to Wesley
+    Bowman for the patch.
+  - Check pod syntax. Thanks to Etienne Bersac for the patch.
+  - Add HACKING to document tests. Thanks to Etienne Bersac for the
+    patch.
+  - Drop obsolete --bar-graph option. Thanks to Etienne Bersac for
+    the patch.
+  - Drop misleading .perltidyrc. This file date from 2012 and
+    pgbadger code is far from compliant. perltidy unified diff is
+    10k lines. Let's drop this. Thanks to Etienne Bersac for the
+    patch.
+  - Fix use of uninitialized value in SQL formatting. Thanks to John
+    Krugger for the report and Jean-paul Argudo for the report.
+
 2017-07-27 - v9.2
 
 This release of pgBadger is a maintenance release that adds some new
diff -pruN 9.2-1/.circleci/config.yml 10.0-1/.circleci/config.yml
--- 9.2-1/.circleci/config.yml	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/.circleci/config.yml	2018-09-09 17:18:14.000000000 +0000
@@ -0,0 +1,40 @@
+version: 2
+
+jobs:
+  test:
+    # Use same version as debian stretch to use packaged dependencies.
+    docker: [{image: "perl:5.24-threaded"}]
+    working_directory: /tmp/pgbadger
+    steps:
+    - run:
+        name: Install debian packages
+        command: >
+          apt update -y &&
+          apt install -y --no-install-recommends bats git jq libjson-xs-perl openssh-client
+    - checkout
+    - run:
+        name: Executing tests
+        environment:
+          # Inject APT packaged dependencies.
+          PERL5LIB: /usr/lib/x86_64-linux-gnu/perl5/5.24:/usr/share/perl5
+        command: prove --verbose
+
+  doc:
+    docker: [{image: "perl:5.26"}]
+    working_directory: /tmp/pgbadger
+    steps:
+    - checkout
+    - run:
+        name: Check README is up to date with pod
+        command: |
+          perl Makefile.PL
+          touch --no-create pgbadger
+          make README
+          git diff --exit-code README doc/pgBadger.pod
+
+workflows:
+  version: 2
+  pipeline:
+    jobs:
+    - test
+    - doc
diff -pruN 9.2-1/CONTRIBUTING.md 10.0-1/CONTRIBUTING.md
--- 9.2-1/CONTRIBUTING.md	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/CONTRIBUTING.md	2018-09-09 17:18:14.000000000 +0000
@@ -4,6 +4,23 @@
 
 1. Upgrade to the latest version of pgBadger and see if the problem remains
 
-2. Look at the [closed issues](https://github.com/dalibo/pgbadger/issues?state=closed), we may have already answered a similar problem
+2. Look at the [closed issues](https://github.com/darold/pgbadger/issues?state=closed), we may have already answered a similar problem
 
-3. [Read the doc](http://dalibo.github.com/pgbadger/). It is short and useful.
+3. [Read the doc](http://darold.github.com/pgbadger/). It is short and useful.
+
+
+## Coding style
+
+pgBadger project provides a [.editorconfig](http://editorconfig.org/) file to
+setup consistent spacing in files. Please follow it!
+
+
+## Keep Documentation Updated
+
+The first pgBadger documentation is `pgbadger --help`. `--help` fills the
+SYNOPSIS section in `doc/pgBadger.pod`. The DESCRIPTION section *must* be
+written directly in `doc/pgBadger.pod`. `README` is the text formatting of
+`doc/pgBadger.pod`. Update `README` and `doc/pgBadger.pod` with `make README`
+and commit changes when contributing.
+
+A job in CI ensure all versionned documentations are consistent.
diff -pruN 9.2-1/debian/changelog 10.0-1/debian/changelog
--- 9.2-1/debian/changelog	2018-09-10 16:12:50.000000000 +0000
+++ 10.0-1/debian/changelog	2018-09-10 10:04:01.000000000 +0000
@@ -1,3 +1,20 @@
+pgbadger (10.0-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/watch: Package moved to https://github.com/darold/pgbadger.
+  * debian/copyright: Update, include resources/LICENSE.
+  * Mark as Multi-Arch: foreign.
+  * Move packaging repository to salsa.debian.org
+  * Move maintainer address to team+postgresql@tracker.debian.org.
+  * Promote libtext-csv-xs-perl and libjson-xs-perl to Depends.
+  * Add bats and jq to Build-Depends.
+  * Don't install tools/updt_embedded_rsc.pl, not needed at run-time.
+  * Use source format 3.0 (quilt).
+  * Fix perl path in /usr/bin/pgbadger.
+  * Add simple autopkgtest.
+
+ -- Christoph Berg <christoph.berg@credativ.de>  Mon, 10 Sep 2018 12:04:01 +0200
+
 pgbadger (9.2-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 9.2-1/debian/control 10.0-1/debian/control
--- 9.2-1/debian/control	2018-09-10 16:12:50.000000000 +0000
+++ 10.0-1/debian/control	2018-09-10 10:04:01.000000000 +0000
@@ -1,20 +1,21 @@
 Source: pgbadger
 Section: database
 Priority: optional
-Maintainer: Debian PostgreSQL Maintainers <pkg-postgresql-public@lists.alioth.debian.org>
-Uploaders: Cyril Bouthors <cyb@debian.org>,
+Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
+Uploaders:
+ Cyril Bouthors <cyb@debian.org>,
  Christoph Berg <myon@debian.org>,
- Adrian Vondendriesch <adrian.vondendriesch@credativ.de>
-Build-Depends: debhelper (>= 9)
+ Adrian Vondendriesch <adrian.vondendriesch@credativ.de>,
+Build-Depends: bats, debhelper (>= 9), jq, libjson-xs-perl
 Standards-Version: 4.0.0
 Homepage: https://dalibo.github.io/pgbadger/
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-postgresql/pgbadger.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-postgresql/pgbadger.git
+Vcs-Browser: https://salsa.debian.org/postgresql/pgbadger
+Vcs-Git: https://salsa.debian.org/postgresql/pgbadger.git
 
 Package: pgbadger
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}
-Suggests: libtext-csv-xs-perl, libjson-xs-perl
+Multi-Arch: foreign
+Depends: libjson-xs-perl, libtext-csv-xs-perl, ${misc:Depends}, ${perl:Depends}
 Description: Fast PostgreSQL log analysis report
  pgBadger is a PostgreSQL log analyzer built for speed with fully detailed
  reports from your PostgreSQL log file. It's a single and small Perl script
diff -pruN 9.2-1/debian/copyright 10.0-1/debian/copyright
--- 9.2-1/debian/copyright	2018-09-10 16:12:50.000000000 +0000
+++ 10.0-1/debian/copyright	2018-09-10 10:03:32.000000000 +0000
@@ -1,32 +1,192 @@
 This package was debianized by Cyril Bouthors <cyril@bouthors.org> on
 Sun Jan 27 02:09:25 CET 2013
 
-It was downloaded from <http://www.bouthors.org>
+Upstream Author: Gilles Darold <gilles@darold.net>
 
-Upstream Author:
-
-    Gilles Darold <gilles@darold.net>
-
-Copyright:
-
-    <Copyright (C) 2013 Cyril Bouthors>
-
-License:
-
-Copyright (c) 2012-2016, Dalibo
+Copyright (c) 2012-2018, Gilles Darold
 
 Permission to use, copy, modify, and distribute this software and its
 documentation for any purpose, without fee, and without a written agreement
 is hereby granted, provided that the above copyright notice and this
 paragraph and the following two paragraphs appear in all copies.
 
-IN NO EVENT SHALL Dalibo BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
+IN NO EVENT SHALL Darold BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
 SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
 ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
-Dalibo HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+Darold HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-Dalibo SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
+Darold SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
 TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
-PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND Dalibo
+PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND Darold
 HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 OR MODIFICATIONS.
+
+Licenses
+--------
+
+bean.js:
+  copyright (c) Jacob Thornton 2011-2012
+  * https://github.com/fat/bean
+  * MIT license
+
+bootstrap.*:
+  Copyright 2011-2016 Twitter, Inc.
+  * Licensed under the MIT license
+
+fontawesome.*:
+   *  - The Font Awesome font is licensed under SIL OFL 1.1 -
+   *    http://scripts.sil.org/OFL
+   *  - Font Awesome CSS, LESS, and SASS files are licensed under MIT License -
+   *    http://opensource.org/licenses/mit-license.html
+   *  - Attribution is no longer required in Font Awesome 3.0, but much appreciated:
+   *    "Font Awesome by Dave Gandy - http://fontawesome.io"
+
+jqplot.*:
+  Copyright (c) 2009-2013 Chris Leonello
+  * jqPlot is currently available for use in all personal or commercial projects
+  * under both the MIT (http://www.opensource.org/licenses/mit-license.php) and GPL
+  * version 2.0 (http://www.gnu.org/licenses/gpl-2.0.html) licenses. This means that you can
+  * choose the license that best suits your project and use it accordingly.
+  *
+  * Although not required, the author would appreciate an email letting him
+  * know of any substantial use of jqPlot.  You can reach the author at:
+  * chris at jqplot dot com or see http://www.jqplot.com/info.php .
+  *
+  * If you are feeling kind and generous, consider supporting the project by
+  * making a donation at: http://www.jqplot.com/donate.php .
+
+jquery.jqplot.*:
+  Copyright (c) 2009-2013 Chris Leonello
+  * jqPlot is currently available for use in all personal or commercial projects
+  * under both the MIT and GPL version 2.0 licenses. This means that you can
+  * choose the license that best suits your project and use it accordingly.
+  *
+  * See <GPL Version 2> and <MIT License> contained within this distribution for further information.
+  *
+  * The author would appreciate an email letting him know of any substantial
+  * use of jqPlot.  You can reach the author at: chris at jqplot dot com
+  * or see http://www.jqplot.com/info.php.  This is, of course, not required.
+  *
+  * If you are feeling kind and generous, consider supporting the project by
+  * making a donation at: http://www.jqplot.com/donate.php.
+
+jquery.*:
+  Copyright 2005, 2012 jQuery Foundation, Inc. and other contributors
+  * Released under the MIT license
+  * http://jquery.org/license
+
+underscore.js:
+  (c) 2009-2015 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
+  //     Underscore may be freely distributed under the MIT license.
+
+
+The MIT License (MIT)
+---------------------
+
+Permission is hereby granted, free of charge, to any person obtaining a copy of
+this software and associated documentation files (the "Software"), to deal in
+the Software without restriction, including without limitation the rights to
+use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
+of the Software, and to permit persons to whom the Software is furnished to do
+so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all
+copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+SOFTWARE.
+
+
+SIL OPEN FONT LICENSE Version 1.1 - 26 February 2007
+----------------------------------------------------
+
+PREAMBLE
+The goals of the Open Font License (OFL) are to stimulate worldwide
+development of collaborative font projects, to support the font creation
+efforts of academic and linguistic communities, and to provide a free and
+open framework in which fonts may be shared and improved in partnership
+with others.
+
+The OFL allows the licensed fonts to be used, studied, modified and
+redistributed freely as long as they are not sold by themselves. The
+fonts, including any derivative works, can be bundled, embedded, 
+redistributed and/or sold with any software provided that any reserved
+names are not used by derivative works. The fonts and derivatives,
+however, cannot be released under any other type of license. The
+requirement for fonts to remain under this license does not apply
+to any document created using the fonts or their derivatives.
+
+DEFINITIONS
+"Font Software" refers to the set of files released by the Copyright
+Holder(s) under this license and clearly marked as such. This may
+include source files, build scripts and documentation.
+
+"Reserved Font Name" refers to any names specified as such after the
+copyright statement(s).
+
+"Original Version" refers to the collection of Font Software components as
+distributed by the Copyright Holder(s).
+
+"Modified Version" refers to any derivative made by adding to, deleting,
+or substituting -- in part or in whole -- any of the components of the
+Original Version, by changing formats or by porting the Font Software to a
+new environment.
+
+"Author" refers to any designer, engineer, programmer, technical
+writer or other person who contributed to the Font Software.
+
+PERMISSION & CONDITIONS
+Permission is hereby granted, free of charge, to any person obtaining
+a copy of the Font Software, to use, study, copy, merge, embed, modify,
+redistribute, and sell modified and unmodified copies of the Font
+Software, subject to the following conditions:
+
+1) Neither the Font Software nor any of its individual components,
+in Original or Modified Versions, may be sold by itself.
+
+2) Original or Modified Versions of the Font Software may be bundled,
+redistributed and/or sold with any software, provided that each copy
+contains the above copyright notice and this license. These can be
+included either as stand-alone text files, human-readable headers or
+in the appropriate machine-readable metadata fields within text or
+binary files as long as those fields can be easily viewed by the user.
+
+3) No Modified Version of the Font Software may use the Reserved Font
+Name(s) unless explicit written permission is granted by the corresponding
+Copyright Holder. This restriction only applies to the primary font name as
+presented to the users.
+
+4) The name(s) of the Copyright Holder(s) or the Author(s) of the Font
+Software shall not be used to promote, endorse or advertise any
+Modified Version, except to acknowledge the contribution(s) of the
+Copyright Holder(s) and the Author(s) or with their explicit written
+permission.
+
+5) The Font Software, modified or unmodified, in part or in whole,
+must be distributed entirely under this license, and must not be
+distributed under any other license. The requirement for fonts to
+remain under this license does not apply to any document created
+using the Font Software.
+
+TERMINATION
+This license becomes null and void if any of the above conditions are
+not met.
+
+DISCLAIMER
+THE FONT SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OF
+MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
+OF COPYRIGHT, PATENT, TRADEMARK, OR OTHER RIGHT. IN NO EVENT SHALL THE
+COPYRIGHT HOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+INCLUDING ANY GENERAL, SPECIAL, INDIRECT, INCIDENTAL, OR CONSEQUENTIAL
+DAMAGES, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+FROM, OUT OF THE USE OR INABILITY TO USE THE FONT SOFTWARE OR FROM
+OTHER DEALINGS IN THE FONT SOFTWARE.
+
+
+On Debian systems, the GPL Version 2 is available in /usr/share/common-licenses/GPL-2.
diff -pruN 9.2-1/debian/patches/perl-path 10.0-1/debian/patches/perl-path
--- 9.2-1/debian/patches/perl-path	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/debian/patches/perl-path	2018-09-10 10:03:32.000000000 +0000
@@ -0,0 +1,8 @@
+--- a/pgbadger
++++ b/pgbadger
+@@ -1,4 +1,4 @@
+-#!/usr/bin/env perl
++#!/usr/bin/perl
+ #------------------------------------------------------------------------------
+ #
+ # pgBadger - Advanced PostgreSQL log analyzer
diff -pruN 9.2-1/debian/patches/series 10.0-1/debian/patches/series
--- 9.2-1/debian/patches/series	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/debian/patches/series	2018-09-10 10:03:32.000000000 +0000
@@ -0,0 +1 @@
+perl-path
diff -pruN 9.2-1/debian/pgbadger.examples 10.0-1/debian/pgbadger.examples
--- 9.2-1/debian/pgbadger.examples	2018-09-10 16:12:50.000000000 +0000
+++ 10.0-1/debian/pgbadger.examples	2018-09-10 10:03:32.000000000 +0000
@@ -1 +1 @@
-tools/*
+tools/*pgbadger_tools*
diff -pruN 9.2-1/debian/source/format 10.0-1/debian/source/format
--- 9.2-1/debian/source/format	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/debian/source/format	2018-09-10 10:03:32.000000000 +0000
@@ -0,0 +1 @@
+3.0 (quilt)
diff -pruN 9.2-1/debian/source/lintian-overrides 10.0-1/debian/source/lintian-overrides
--- 9.2-1/debian/source/lintian-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/debian/source/lintian-overrides	2018-09-10 10:04:01.000000000 +0000
@@ -0,0 +1,3 @@
+# don't bug people uploading from @work
+source: changelog-should-mention-nmu
+source: source-nmu-has-incorrect-version-number
diff -pruN 9.2-1/debian/tests/control 10.0-1/debian/tests/control
--- 9.2-1/debian/tests/control	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/debian/tests/control	2018-09-10 10:04:01.000000000 +0000
@@ -0,0 +1,3 @@
+Depends: @
+Tests: run
+Restrictions: allow-stderr
diff -pruN 9.2-1/debian/tests/run 10.0-1/debian/tests/run
--- 9.2-1/debian/tests/run	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/debian/tests/run	2018-09-10 10:04:01.000000000 +0000
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+trap "rm -f out.html" 0 2 3 15
+
+set -eux
+
+pgbadger t/fixtures/light.postgres.log.bz2
+grep -q pgbench_accounts out.html
diff -pruN 9.2-1/debian/watch 10.0-1/debian/watch
--- 9.2-1/debian/watch	2018-09-10 16:12:50.000000000 +0000
+++ 10.0-1/debian/watch	2018-09-10 08:52:00.000000000 +0000
@@ -1,2 +1,2 @@
 version=3
-https://github.com/dalibo/pgbadger/releases /dalibo/pgbadger/archive/v([0-9.]+).tar.gz
+https://github.com/darold/pgbadger/releases /darold/pgbadger/archive/v([0-9.]+).tar.gz
diff -pruN 9.2-1/doc/pgBadger.pod 10.0-1/doc/pgBadger.pod
--- 9.2-1/doc/pgBadger.pod	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/doc/pgBadger.pod	2018-09-09 17:18:14.000000000 +0000
@@ -16,21 +16,20 @@ Arguments:
 
 Options:
 
-    -a | --average N       : number of minutes to build the average graphs
-                             of queries and connections. Default 5 minutes.
-    -A | --histo-average N : number of minutes to build the histogram graphs
+    -a | --average minutes : number of minutes to build the average graphs of
+                             queries and connections. Default 5 minutes.
+    -A | --histo-average min: number of minutes to build the histogram graphs
                              of queries. Default 60 minutes.
     -b | --begin datetime  : start date/time for the data to be parsed in log.
-    -B | --bar-graph       : use bar graph instead of line by default.
     -c | --dbclient host   : only report on entries for the given client host.
     -C | --nocomment       : remove comments like /* ... */ from queries.
     -d | --dbname database : only report on entries for the given database.
     -D | --dns-resolv      : client ip addresses are replaced by their DNS name.
                              Be warned that this can really slow down pgBadger.
     -e | --end datetime    : end date/time for the data to be parsed in log.
-    -f | --format logtype  : possible values: syslog, syslog2, stderr, csv and
-                             pgbouncer. Use this option when pgBadger is not
-                             able to auto-detect the log format Default: stderr.
+    -f | --format logtype  : possible values: syslog, syslog2, stderr, jsonlog,
+			     cvs and pgbouncer. Use this option when pgBadger
+                             is not able to auto-detect the log format.
     -G | --nograph         : disable graphs on HTML output. Enabled by default.
     -h | --help            : show this message and exit.
     -i | --ident name      : programname used as syslog ident. Default: postgres
@@ -44,7 +43,7 @@ Options:
                              last datetime and line parsed. Useful if you want
                              to watch errors since last run or if you want one
                              report per day with a log rotated each week.
-    -L | logfile-list file : file containing a list of log file to parse.
+    -L | --logfile-list file:file containing a list of log file to parse.
     -m | --maxlength size  : maximum length of a query, it will be restricted to
                              the given size. Default: no truncate
     -M | --no-multiline    : do not collect multiline statement to avoid garbage
@@ -122,6 +121,9 @@ Options:
     --exclude-time  regex  : any timestamp matching the given regex will be
 			     excluded from the report. Example: "2013-04-12 .*"
                              You can use this option multiple times.
+    --include-time  regex  : only timestamps matching the given regex will be
+			     included in the report. Example: "2013-04-12 .*"
+                             You can use this option multiple times.
     --exclude-appname name : exclude entries for the specified application name
 			     from report. Example: "pg_dump".
     --exclude-line regex   : pgBadger will start to exclude any log entry that
@@ -137,16 +139,21 @@ Options:
     --journalctl command   : command to use to replace PostgreSQL logfile by
 			     a call to journalctl. Basically it might be:
 				journalctl -u postgresql-9.5
-    --pid-dir dirpath      : set the path of the directory where the pid file
-                             will be written to be able to run two pgBadger at
-                             the same time.
+    --pid-dir path         : set the path where the pid file must be stored.
+                              Default /tmp
+    --pid-file file        : set the name of the pid file to manage concurrent
+			     execution of pgBadger. Default: pgbadger.pid
     --rebuild              : used to rebuild all html reports in incremental
                              output directories where there is binary data files.
     --pgbouncer-only       : only show PgBouncer related menu in the header.
-    --start-monday         : in incremental mode, weeks start on sunday. Use
-                             this option to start on monday.
+    --start-monday         : in incremental mode, calendar's weeks start on
+                             sunday. Use this option to start on monday.
     --normalized-only      : only dump all normalized query to out.txt
-
+    --log-timezone +/-XX   : Set the number of hours from GMT of the timezone
+                             that must be used to adjust date/time read from
+                             log file before beeing parsed. Using this option
+                             make more difficult log search with a date/time.
+    --prettify-json        : use it if you want json output to be prettified.
 
 pgBadger is able to parse a remote log file using a passwordless ssh connection.
 Use the -r or --remote-host to set the host ip address or hostname. There's also
@@ -172,19 +179,19 @@ Examples:
 		       /var/log/postgresql.log
 	cat /var/log/postgres.log | pgbadger -
 	# Log prefix with stderr log output
-	pgbadger --prefix '%t [%p]: [%l-1] user=%u,db=%d,client=%h' 
+	perl pgbadger --prefix '%t [%p]: user=%u,database=%d,client=%h' 
 			/pglog/postgresql-2012-08-21*
-	pgbadger --prefix '%m %u@%d %p %r %a : ' /pglog/postgresql.log
+	perl pgbadger --prefix '%m %u@%d %p %r %a : ' /pglog/postgresql.log
 	# Log line prefix with syslog log output
-	pgbadger --prefix 'user=%u,db=%d,client=%h,appname=%a' 
+	perl pgbadger --prefix 'user=%u,db=%d,client=%h,appname=%a' 
 			/pglog/postgresql-2012-08-21*
 	# Use my 8 CPUs to parse my 10GB file faster, much faster
-	pgbadger -j 8 /pglog/postgresql-9.1-main.log
+	perl pgbadger -j 8 /pglog/postgresql-9.1-main.log
 
 
 Generate Tsung sessions XML file with select queries only:
 
-    pgbadger -S -o sessions.tsung --prefix '%t [%p]: [%l-1] user=%u,db=%d ' /pglog/postgresql-9.1.log
+    perl pgbadger -S -o sessions.tsung --prefix '%t [%p]: user=%u,db=%d ' /pglog/postgresql-9.1.log
 
 Reporting errors every week by cron job:
 
@@ -227,8 +234,8 @@ or worst, call it from a remote host:
 
     pgbadger -r 192.168.1.159 --journalctl 'journalctl -u postgresql-9.5'
 
-you don't need to specify any log file at command line, but if you have others
-PostgreSQL log files to parse, you can add them as usual.
+you don't need to specify any log file at command line, but if you have other
+PostgreSQL log file to parse, you can add them as usual.
 
 To rebuild all incremental html reports after, proceed as follow:
 
@@ -250,11 +257,11 @@ other packages. Furthermore, this librar
 as zooming. pgBadger also uses the Bootstrap JavaScript library and
 the FontAwesome webfont for better design. Everything is embedded.
 
-pgBadger is able to autodetect your log file format (syslog, stderr or csvlog).
-It is designed to parse huge log files as well as gzip compressed files. See a
-complete list of features below. Supported compressed format are gzip, bzip2
-and xz. For the xz format you must have an xz version upper than 5.05 that
-supports the --robot option.
+pgBadger is able to autodetect your log file format (syslog, stderr, csvlog
+or jsonlog) if the file is long enough. It is designed to parse huge log
+files as well as compressed files. Supported compressed format are gzip,
+bzip2 and xz.  For the xz format you must have an xz version upper than 5.05
+that supports the --robot option. For the complete list of features see below.
 
 All charts are zoomable and can be saved as PNG images.
 
@@ -421,22 +428,26 @@ this value to only log queries with a lo
 log_statement set to 'all' nothing will be logged through the log_min_duration_statement
 directive. See the next chapter for more information.
 
-With 'stderr' log format, log_line_prefix must be at least:
+pgBadger supports any custom format set into the log_line_prefix directive of
+your postgresql.conf file as long as it at least specify a time escape sequence
+(%t, %m or %n) and the process related escape sequence (%p or %c).
+
+For example, with 'stderr' log format, log_line_prefix must be at least:
 
-        log_line_prefix = '%t [%p]: [%l-1] '
+	log_line_prefix = '%t [%p]: '
 
 Log line prefix could add user, database name, application name and client ip
 address as follows:
 
-        log_line_prefix = '%t [%p]: [%l-1] user=%u,db=%d,app=%a,client=%h '
+        log_line_prefix = '%t [%p]: user=%u,db=%d,app=%a,client=%h '
 
 or for syslog log file format:
 
-        log_line_prefix = 'user=%u,db=%d,app=%aclient=%h '
+        log_line_prefix = 'user=%u,db=%d,app=%a,client=%h '
 
 Log line prefix for stderr output could also be:
 
-        log_line_prefix = '%t [%p]: [%l-1] db=%d,user=%u,app=%a,client=%h '
+        log_line_prefix = '%t [%p]: db=%d,user=%u,app=%a,client=%h '
 
 or for syslog output:
 
@@ -460,11 +471,6 @@ Of course your log messages should be in
 
 but this is not only recommended by pgBadger.
 
-Note: the session line [%l-1] is just used to match the default prefix for "stderr".
-The -1 has no real purpose and basically is not used in pgBadger statistics / graphs.
-You can safely remove them from the log_line_prefix but you will need to set the
---prefix command line option accordingly.
-
 =head1 log_min_duration_statement, log_duration and log_statement
 
 If you want the query statistics to include the actual query strings,
@@ -480,6 +486,10 @@ Enabling log_min_duration_statement will
 queries that took up the most time. Take care that if you have log_statement
 set to 'all' nothing will be logged with log_line_prefix.
 
+Warning: Do not enable both log_min_duration_statement, log_duration and
+log_statement, this will result in wrong counter values. Note that this will
+also increase drastically the size of your log. log_min_duration_statement
+should always be preferred.
 
 =head1 PARALLEL PROCESSING
 
@@ -604,13 +614,13 @@ or Graphite.
 
 pgBadger is an original work from Gilles Darold.
 
-The pgBadger logo is an original creation of Damien Clochard.
+The pgBadger logo is an original creation of Damien Cazeils.
 
 The pgBadger v4.x design comes from the "Art is code" company.
 
 This web site is a work of Gilles Darold.
 
-pgBadger is maintained by Gilles Darold, the good folks at Dalibo, and every one who wants to contribute.
+pgBadger is maintained by Gilles Darold and every one who wants to contribute.
 
 Many people have contributed to pgBadger, they are all quoted in the Changelog file.
 
@@ -618,9 +628,8 @@ Many people have contributed to pgBadger
 
 pgBadger is free software distributed under the PostgreSQL Licence.
 
-Copyright (c) 2012-2017, Dalibo
+Copyright (c) 2012-2018, Gilles Darold
 
 A modified version of the SQL::Beautify Perl Module is embedded in pgBadger
 with copyright (C) 2009 by Jonas Kramer and is published under the terms of
 the Artistic License 2.0.
-
diff -pruN 9.2-1/.editorconfig 10.0-1/.editorconfig
--- 9.2-1/.editorconfig	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/.editorconfig	2018-09-09 17:18:14.000000000 +0000
@@ -0,0 +1,16 @@
+root = true
+
+[*]
+charset = utf-8
+indent_style = tab
+indent_size = 8
+# Unix-style newlines
+end_of_line = lf
+# Remove any whitespace characters preceding newline characters
+trim_trailing_whitespace = true
+# Newline ending every file
+insert_final_newline = true
+
+[*.yml]
+indent_style = space
+indent_size = 2
diff -pruN 9.2-1/.gitignore 10.0-1/.gitignore
--- 9.2-1/.gitignore	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/.gitignore	2018-09-09 17:18:14.000000000 +0000
@@ -1,2 +1,5 @@
-# Swap files
-*.swp
+blib/
+Makefile
+MYMETA.json
+MYMETA.yml
+pm_to_blib
diff -pruN 9.2-1/HACKING.md 10.0-1/HACKING.md
--- 9.2-1/HACKING.md	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/HACKING.md	2018-09-09 17:18:14.000000000 +0000
@@ -0,0 +1,18 @@
+# Contributing on pgBadger
+
+Thanks for your attention on pgBadger !
+
+pgBadger has a TAP compatible test suite executed by `prove(1)` on CI. You can
+write tests in many language including perl and bash.
+
+    $ apt install bats
+    ...
+    $ prove
+    t/basics.t .. ok 
+    t/syntax.t .. ok 
+    All tests successful.
+    Files=2, Tests=4,  2 wallclock secs ( 0.02 usr  0.00 sys +  2.38 cusr  0.04 csys =  2.44 CPU)
+    Result: PASS
+    $
+
+Please contribute a regression test when you fix a bug or add a feature. Thanks!
diff -pruN 9.2-1/LICENSE 10.0-1/LICENSE
--- 9.2-1/LICENSE	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/LICENSE	2018-09-09 17:18:14.000000000 +0000
@@ -1,17 +1,17 @@
-Copyright (c) 2012-2017, Dalibo
+Copyright (c) 2012-2018, Gilles Darold
 
 Permission to use, copy, modify, and distribute this software and its
 documentation for any purpose, without fee, and without a written agreement
 is hereby granted, provided that the above copyright notice and this
 paragraph and the following two paragraphs appear in all copies.
 
-IN NO EVENT SHALL Dalibo BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
+IN NO EVENT SHALL Darold BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
 SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
 ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
-Dalibo HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+Darold HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-Dalibo SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
+Darold SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
 TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
-PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND Dalibo
+PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND Darold
 HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 OR MODIFICATIONS.
diff -pruN 9.2-1/Makefile.PL 10.0-1/Makefile.PL
--- 9.2-1/Makefile.PL	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/Makefile.PL	2018-09-09 17:18:14.000000000 +0000
@@ -24,17 +24,36 @@ if ($ExtUtils::MakeMaker::VERSION >= 6.4
 	%merge_compat = (
 		'META_MERGE'   => {
 			resources  => {
-				homepage => 'http://projects.dalibo.org/pgbadger',
+				homepage => 'http://pgbadger.darold.net/',
 				repository  => {
 					type => 'git',
-					git => 'git@github.com:dalibo/pgbadger.git',
-					web => 'https://github.com/dalibo/pgbadger',
+					git => 'git@github.com:darold/pgbadger.git',
+					web => 'https://github.com/darold/pgbadger',
 				},
 			},
 		}
 	);
 }
 
+sub MY::postamble {
+    return <<'EOMAKE';
+README: doc/pgBadger.pod
+	pod2text $^ > $@
+
+.INTERMEDIATE: doc/synopsis.pod
+doc/synopsis.pod: Makefile pgbadger
+	echo "=head1 SYNOPSIS" > $@
+	./pgbadger --help >> $@
+	echo "=head1 DESCRIPTION" >> $@
+	sed -i 's/ +$$//g' $@
+
+.PHONY: doc/pgBadger.pod
+doc/pgBadger.pod: doc/synopsis.pod Makefile
+	sed -i '/^=head1 SYNOPSIS/,/^=head1 DESCRIPTION/d' $@
+	sed -i '4r $<' $@
+EOMAKE
+}
+
 WriteMakefile(
 	'DISTNAME'	=> 'pgbadger',
 	'NAME'		=> 'pgBadger',
@@ -52,4 +71,3 @@ WriteMakefile(
 	'clean'	       => {},
 	%merge_compat
 );
-
diff -pruN 9.2-1/META.yml 10.0-1/META.yml
--- 9.2-1/META.yml	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/META.yml	2018-09-09 17:18:14.000000000 +0000
@@ -1,7 +1,5 @@
-# http://module-build.sourceforge.net/META-spec.html
-#XXXXXXX This is a prototype!!!  It will change in the future!!! XXXXX#
 name:         pgBadger
-version:      8.1
+version:      10.0
 version_from: pgbadger
 installdirs:  site
 recommends:
diff -pruN 9.2-1/.perltidyrc 10.0-1/.perltidyrc
--- 9.2-1/.perltidyrc	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/.perltidyrc	1970-01-01 00:00:00.000000000 +0000
@@ -1,19 +0,0 @@
---backup-and-modify-in-place
---backup-file-extension=beforeTidy
---block-brace-tightness=2
---brace-tightness=2
---closing-token-indentation=1
---continuation-indentation=4
---indent-columns=4
---maximum-line-length=134
---cuddled-else
---opening-sub-brace-on-new-line
---noopening-brace-on-new-line
---nooutdent-labels
---paren-tightness=2
---square-bracket-tightness=2
---vertical-tightness=0
---vertical-tightness-closing=0
---break-at-old-comma-breakpoints
---entab-leading-whitespace=4
---tabs
diff -pruN 9.2-1/pgbadger 10.0-1/pgbadger
--- 9.2-1/pgbadger	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/pgbadger	2018-09-09 17:18:14.000000000 +0000
@@ -11,14 +11,14 @@
 #
 # You should enable SQL query logging with log_min_duration_statement >= 0
 # With stderr output
-#  Log line prefix should be: log_line_prefix = '%t [%p]: [%l-1] '
-#  Log line prefix should be: log_line_prefix = '%t [%p]: [%l-1] user=%u,db=%d '
-#  Log line prefix should be: log_line_prefix = '%t [%p]: [%l-1] db=%d,user=%u '
+#  Log line prefix should be: log_line_prefix = '%t [%p]: '
+#  Log line prefix should be: log_line_prefix = '%t [%p]: user=%u,db=%d '
+#  Log line prefix should be: log_line_prefix = '%t [%p]: db=%d,user=%u '
 # If you need report per client Ip adresses you can add client=%h or remote=%h
 # pgbadger will also recognized the following form:
-#     log_line_prefix = '%t [%p]: [%l-1] db=%d,user=%u,client=%h '
+#     log_line_prefix = '%t [%p]: db=%d,user=%u,client=%h '
 # or
-#     log_line_prefix = '%t [%p]: [%l-1] user=%u,db=%d,remote=%h '
+#     log_line_prefix = '%t [%p]: user=%u,db=%d,remote=%h '
 # With syslog output
 #  Log line prefix should be: log_line_prefix = 'db=%d,user=%u '
 #
@@ -39,7 +39,7 @@ use IO::File;
 use Benchmark;
 use File::Basename;
 use Storable qw(store_fd fd_retrieve);
-use Time::Local 'timegm_nocheck';
+use Time::Local qw(timegm_nocheck timelocal_nocheck);
 use POSIX qw(locale_h sys_wait_h _exit strftime);
 setlocale(LC_NUMERIC, '');
 setlocale(LC_ALL,     'C');
@@ -51,7 +51,7 @@ use FileHandle;
 use Socket;
 use constant EBCDIC => "\t" ne "\011";
 
-$VERSION = '9.2';
+$VERSION = '10.0';
 
 $SIG{'CHLD'} = 'DEFAULT';
 
@@ -71,6 +71,7 @@ my %CACHE_DNS = ();
 my $DNSLookupTimeout = 1; # (in seconds)
 my $EXPLAIN_URL = 'http://explain.depesz.com/?is_public=0&is_anon=0&plan=';
 my $PID_DIR = $TMP_DIR;
+my $PID_FILE = undef;
 
 my @E2A = (
    0,  1,  2,  3,156,  9,134,127,151,141,142, 11, 12, 13, 14, 15,
@@ -276,6 +277,7 @@ my $progress                = 1;
 my $error_only              = 0;
 my @exclude_query           = ();
 my @exclude_time            = ();
+my @include_time            = ();
 my $exclude_file            = '';
 my @include_query           = ();
 my $include_file            = '';
@@ -295,7 +297,7 @@ my $last_parsed             = '';
 my $report_title            = '';
 my $log_line_prefix         = '';
 my $compiled_prefix         = '';
-my $project_url             = 'http://dalibo.github.com/pgbadger/';
+my $project_url             = 'http://pgbadger.darold.net/';
 my $t_min                   = 0;
 my $t_max                   = 0;
 my $remove_comment          = 0;
@@ -312,7 +314,6 @@ my $last_incr_date          = '';
 my $anonymize               = 0;
 my $noclean                 = 0;
 my $retention               = 0;
-my $bar_graph               = 0;
 my $dns_resolv              = 0;
 my $nomultiline             = 0;
 my $noreport                = 0;
@@ -325,6 +326,8 @@ my $rebuild                 = 0;
 my $week_start_monday       = 0;
 my $use_sessionid_as_pid    = 0;
 my $dump_normalized_only    = 0;
+my $log_timezone            = 0;
+my $json_prettify           = 0;
 
 my $NUMPROGRESS = 10000;
 my @DIMENSIONS  = (800, 300);
@@ -332,6 +335,8 @@ my $RESRC_URL   = '';
 my $img_format  = 'png';
 my @log_files   = ();
 my %prefix_vars = ();
+my $q_prefix    = '';
+my @prefix_q_params = ();
 
 my $remote_host = '';
 my $ssh_command = '';
@@ -391,8 +396,8 @@ sub wait_child
 	if ($last_parsed && -e "$last_parsed.tmp") {
 		unlink("$last_parsed.tmp");
 	}
-	if (-e "$PID_DIR/pgbadger.pid") {
-		unlink("$PID_DIR/pgbadger.pid");
+	if (-e "$PID_FILE") {
+		unlink("$PID_FILE");
 	}
 	_exit(0);
 }
@@ -407,7 +412,6 @@ my $result = GetOptions(
 	"a|average=i"              => \$avg_minutes,
 	"A|histo-average=i"        => \$histo_avg_minutes,
 	"b|begin=s"                => \$from,
-	"B|bar-graph!"             => \$bar_graph,
 	"c|dbclient=s"             => \@dbclient,
 	"C|nocomment!"             => \$remove_comment,
 	"d|dbname=s"               => \@dbname,
@@ -419,7 +423,7 @@ my $result = GetOptions(
 	"i|ident=s"                => \$ident,
 	"I|incremental!"           => \$incremental,
 	"j|jobs=i"                 => \$queue_size,
-	"J|job_per_file=i"         => \$job_per_file,
+	"J|Jobs=i"                 => \$job_per_file,
 	"l|last-parsed=s"          => \$last_parsed,
 	"L|logfile-list=s"         => \$logfile_list,
 	"m|maxlength=i"            => \$maxlength,
@@ -466,6 +470,7 @@ my $result = GetOptions(
 	"disable-autovacuum!"      => \$disable_autovacuum,
 	"charset=s"                => \$charset,
 	"csv-separator=s"          => \$csv_sep_char,
+	"include-time=s"           => \@include_time,
 	"exclude-time=s"           => \@exclude_time,
         'ssh-command=s'            => \$ssh_command,
         'ssh-program=s'            => \$ssh_bin,
@@ -480,10 +485,13 @@ my $result = GetOptions(
 	'enable-checksum!'         => \$enable_checksum,
 	'journalctl=s'             => \$journalctl_cmd,
 	'pid-dir=s'		   => \$PID_DIR,
+	'pid-file=s'		   => \$PID_FILE,
 	'rebuild!'                 => \$rebuild,
 	'pgbouncer-only!'          => \$pgbouncer_only,
 	'start-monday!'            => \$week_start_monday,
 	'normalized-only!'         => \$dump_normalized_only,
+	'log-timezone=i'           => \$log_timezone,
+	'prettify-json!'           => \$json_prettify,
 );
 die "FATAL: use pgbadger --help\n" if (not $result);
 
@@ -505,26 +513,31 @@ if ($enable_checksum) {
 }
 
 # Check if an other process is already running
-if (-e "$PID_DIR/pgbadger.pid") {
+unless ($PID_FILE) {
+  $PID_FILE = $PID_DIR . '/pgbadger.pid';
+}
+
+if (-e "$PID_FILE") {
 	my $is_running = 2;
 	if ($^O !~ /MSWin32|dos/i) {
 		eval { $is_running = `ps auwx | grep pgbadger | grep -v grep | wc -l`; chomp($is_running); };
 	}
 	if (!$@ && ($is_running <= 1)) {
-		unlink("$PID_DIR/pgbadger.pid");
+		unlink("$PID_FILE");
 	} else {
-		print "FATAL: an other process is already started or remove the file, see $PID_DIR/pgbadger.pid\n";
+		print "FATAL: an other process is already started or remove the file, see $PID_FILE\n";
 		exit 3;
 	}
 }
 
 # Create pid file
-unless(open(OUT, ">$PID_DIR/pgbadger.pid")) {
-	print "FATAL: can't create pid file $PID_DIR/pgbadger.pid, $!\n";
+if (open(my $out, '>', $PID_FILE)) {
+	print $out $$;
+	close($out);
+} else {
+	print "FATAL: can't create pid file $PID_FILE, $!\n";
 	exit 3;
 }
-print OUT $$;
-close(OUT);
 
 # Rewrite some command line arguments as lists
 &compute_arg_list();
@@ -594,11 +607,12 @@ if ($logfile_list) {
 	if (!-e $logfile_list) {
 		localdie("FATAL: logfile list $logfile_list must exist!\n");
 	}
-	if (not open(IN, $logfile_list)) {
+	my $in = undef;
+	if (not open($in, "<", $logfile_list)) {
 		localdie("FATAL: can not read logfile list $logfile_list, $!.\n");
 	}
-	my @files = <IN>;
-	close(IN);
+	my @files = <$in>;
+	close($in);
 	foreach my $file (@files) {
 		chomp($file);
 		$file =~ s/\r//;
@@ -631,7 +645,7 @@ if ($logfile_list) {
 # Do not warn if all log files are empty
 if (!$rebuild && $empty_files) {
 	&logmsg('DEBUG', "All log files are empty, exiting...");
-	unlink("$PID_DIR/pgbadger.pid");
+	unlink("$PID_FILE");
 	exit 0;
 }
 
@@ -640,7 +654,7 @@ if ( !$rebuild && ($#log_files < 0) && !
 	if (!$quiet) {
 		localdie("FATAL: you must give a log file at command line parameter.\n\n");
 	} else {
-		unlink("$PID_DIR/pgbadger.pid");
+		unlink("$PID_FILE");
 		exit 4;
 	}
 }
@@ -717,6 +731,7 @@ $top ||= 20;
 
 # Set timezone
 $timezone = ((0-$timezone)*3600);
+$log_timezone = ((0-$log_timezone)*3600);
 
 # Set the default extension and output format
 if (!$extension) {
@@ -866,12 +881,12 @@ my $action_regex = qr/^[\s\(]*(DELETE|IN
 
 # Loading excluded query from file if any
 if ($exclude_file) {
-	open(IN, "$exclude_file") or localdie("FATAL: can't read file $exclude_file: $!\n");
-	my @exclq = <IN>;
-	close(IN);
+	open(my $in, '<', $exclude_file) or localdie("FATAL: can't read file $exclude_file: $!\n");
+	my @exclq = <$in>;
+	close($in);
 	chomp(@exclq);
-	map {s/\r//;} @exclq;
 	foreach my $r (@exclq) {
+		$r =~ s/\r//;
 		&check_regex($r, '--exclude-file');
 	}
 	push(@exclude_query, @exclq);
@@ -890,15 +905,22 @@ if ($#exclude_time >= 0) {
 		&check_regex($r, '--exclude-time');
 	}
 }
+#
+# Testing regex syntax
+if ($#include_time >= 0) {
+	foreach my $r (@include_time) {
+		&check_regex($r, '--include-time');
+	}
+}
 
 # Loading included query from file if any
 if ($include_file) {
-	open(IN, "$include_file") or localdie("FATAL: can't read file $include_file: $!\n");
-	my @exclq = <IN>;
-	close(IN);
+	open(my $in, '<', $include_file) or localdie("FATAL: can't read file $include_file: $!\n");
+	my @exclq = <$in>;
+	close($in);
 	chomp(@exclq);
-	map {s/\r//;} @exclq;
 	foreach my $r (@exclq) {
+		$r =~ s/\r//;
 		&check_regex($r, '--include-file');
 	}
 	push(@include_query, @exclq);
@@ -950,100 +972,6 @@ my %abbr_month = (
 	'07' => 'Jul', '08' => 'Aug', '09' => 'Sep', '10' => 'Oct', '11' => 'Nov', '12' => 'Dec'
 );
 
-# Keywords variable
-my @pg_keywords = qw(
-        ALL ANALYSE ANALYZE AND ANY ARRAY AS ASC ASYMMETRIC AUTHORIZATION BERNOULLI BINARY BOTH CASE
-        CAST CHECK COLLATE COLLATION COLUMN CONCURRENTLY CONSTRAINT CREATE CROSS CUBE
-        CURRENT_DATE CURRENT_ROLE CURRENT_TIME CURRENT_TIMESTAMP CURRENT_USER
-        DEFAULT DEFERRABLE DESC DISTINCT DO ELSE END EXCEPT FALSE FETCH FOR FOREIGN FREEZE FROM
-        FULL GRANT GROUP GROUPING HAVING ILIKE IN INITIALLY INNER INTERSECT INTO IS ISNULL JOIN LEADING
-        LEFT LIKE LIMIT LOCALTIME LOCALTIMESTAMP LOCKED LOGGED NATURAL NOT NOTNULL NULL ON ONLY OPEN OR
-        ORDER OUTER OVER OVERLAPS PLACING POLICY PRIMARY REFERENCES RETURNING RIGHT ROLLUP SELECT SESSION_USER
-        SETS SKIP SIMILAR SOME SYMMETRIC TABLE TABLESAMPLE THEN TO TRAILING TRUE UNION UNIQUE USER USING VARIADIC
-        VERBOSE WHEN WHERE WINDOW WITH
-);
-
-my @redshift_keywords =  qw(
-	AES128 AES256 ALLOWOVERWRITE BACKUP BLANKSASNULL BYTEDICT BZIP2 CREDENTIALS CURRENT_USER_ID
-	DEFLATE DEFRAG DELTA DELTA32K DISABLE DISTKEY EMPTYASNULL ENABLE ENCODE ENCRYPT ENCRYPTION EXPLICIT
-	GLOBALDICT256 GLOBALDICT64K GZIP INTERLEAVED LUN LUNS LZO LZOP MINUS MOSTLY13 MOSTLY32 MOSTLY8 NEW
-	OFFLINE OFFSET OID OLD PARALLEL PERCENT PERMISSIONS RAW READRATIO RECOVER RESPECT REJECTLOG
-	RESORT RESTORE SORTKEY SYSDATE TAG TDES TEXT255 TEXT32K TIMESTAMP TOP TRUNCATECOLUMNS WALLET
-);
-
-my @beautify_pg_keywords = qw(
-        ANALYSE ANALYZE CONCURRENTLY FREEZE ILIKE ISNULL LIKE NOTNULL PLACING RETURNING VARIADIC
-);
-
-
-# Highlight variables
-my @KEYWORDS1 = qw(
-        ALTER ADD AUTO_INCREMENT BETWEEN BY BOOLEAN BEGIN CHANGE COLUMNS COMMIT COALESCE CLUSTER
-        COPY DATABASES DATABASE DATA DELAYED DESCRIBE DELETE DROP ENCLOSED ESCAPED EXISTS EXPLAIN
-        FIELDS FIELD FLUSH FUNCTION GREATEST IGNORE INDEX INFILE INSERT IDENTIFIED IF INHERIT
-        KEYS KILL KEY LINES LOAD LOCAL LOCK LOW_PRIORITY LANGUAGE LEAST LOGIN MODIFY
-        NULLIF NOSUPERUSER NOCREATEDB NOCREATEROLE OPTIMIZE OPTION OPTIONALLY OUTFILE OWNER PROCEDURE
-        PROCEDURAL READ REGEXP RENAME RETURN REVOKE RLIKE ROLE ROLLBACK SHOW SONAME STATUS
-        STRAIGHT_JOIN SET SEQUENCE TABLES TEMINATED TRUNCATE TEMPORARY TRIGGER TRUSTED UN$filenumLOCK
-        USE UPDATE UNSIGNED VALUES VARIABLES VIEW VACUUM WRITE ZEROFILL XOR
-        ABORT ABSOLUTE ACCESS ACTION ADMIN AFTER AGGREGATE ALSO ALWAYS ASSERTION ASSIGNMENT AT ATTRIBUTE
-        BACKWARD BEFORE BIGINT CACHE CALLED CASCADE CASCADED CATALOG CHAIN CHARACTER CHARACTERISTICS
-        CHECKPOINT CLOSE COMMENT COMMENTS COMMITTED CONFIGURATION CONNECTION CONSTRAINTS CONTENT
-        CONTINUE CONVERSION COST CSV CURRENT CURSOR CYCLE DAY DEALLOCATE DEC DECIMAL DECLARE DEFAULTS
-        DEFERRED DEFINER DELIMITER DELIMITERS DICTIONARY DISABLE DISCARD DOCUMENT DOMAIN DOUBLE EACH
-        ENABLE ENCODING ENCRYPTED ENUM ESCAPE EXCLUDE EXCLUDING EXCLUSIVE EXECUTE EXTENSION EXTERNAL
-        FIRST FLOAT FOLLOWING FORCE FORWARD FUNCTIONS GLOBAL GRANTED HANDLER HEADER HOLD
-        HOUR IDENTITY IMMEDIATE IMMUTABLE IMPLICIT INCLUDING INCREMENT INDEXES INHERITS INLINE INOUT INPUT
-        INSENSITIVE INSTEAD INT INTEGER INVOKER ISOLATION LABEL LARGE LAST LC_COLLATE LC_CTYPE
-        LEAKPROOF LEVEL LISTEN LOCATION LOOP MAPPING MATCH MAXVALUE MINUTE MINVALUE MODE MONTH MOVE NAMES
-        NATIONAL NCHAR NEXT NO NONE NOTHING NOTIFY NOWAIT NULLS OBJECT OF OFF OIDS OPERATOR OPTIONS
-        OUT OWNED PARSER PARTIAL PARTITION PASSING PASSWORD PLANS PRECEDING PRECISION PREPARE
-        PREPARED PRESERVE PRIOR PRIVILEGES QUOTE RANGE REAL REASSIGN RECHECK RECURSIVE REF REINDEX RELATIVE
-        RELEASE REPEATABLE REPLICA RESET RESTART RESTRICT RETURNS ROW ROWS RULE SAVEPOINT SCHEMA SCROLL SEARCH
-        SECOND SECURITY SEQUENCES SERIALIZABLE SERVER SESSION SETOF SHARE SIMPLE SMALLINT SNAPSHOT STABLE
-        STANDALONE START STATEMENT STATISTICS STORAGE STRICT SYSID SYSTEM TABLESPACE TEMP
-        TEMPLATE TRANSACTION TREAT TYPE TYPES UNBOUNDED UNCOMMITTED UNENCRYPTED
-        UNKNOWN UNLISTEN UNLOGGED UNTIL VALID VALIDATE VALIDATOR VALUE VARYING VOLATILE
-        WHITESPACE WITHOUT WORK WRAPPER XMLATTRIBUTES XMLCONCAT XMLELEMENT XMLEXISTS XMLFOREST XMLPARSE
-        XMLPI XMLROOT XMLSERIALIZE YEAR YES ZONE
-);
-
-foreach my $k (@pg_keywords) {
-        push(@KEYWORDS1, $k) if (!grep(/^$k$/i, @KEYWORDS1));
-}
-
-foreach my $k (@redshift_keywords) {
-        push(@KEYWORDS1, $k) if (!grep(/^$k$/i, @KEYWORDS1));
-}
-
-my @KEYWORDS2 = (
-	'ascii',      'age',
-	'bit_length', 'btrim',
-	'char_length', 'character_length', 'convert', 'chr', 'current_date', 'current_time', 'current_timestamp', 'count',
-	'decode',      'date_part',        'date_trunc',
-	'encode',      'extract',
-	'get_byte',    'get_bit',
-	'initcap',       'isfinite', 'interval',
-	'justify_hours', 'justify_days',
-	'lower', 'length', 'lpad', 'ltrim', 'localtime', 'localtimestamp',
-	'md5',
-	'now',
-	'octet_length', 'overlay',
-	'position',     'pg_client_encoding',
-	'quote_ident',  'quote_literal',
-	'repeat', 'replace', 'rpad', 'rtrim',
-	'substring', 'split_part', 'strpos', 'substr', 'set_byte', 'set_bit',
-	'trim', 'to_ascii', 'to_hex', 'translate', 'to_char', 'to_date', 'to_timestamp', 'to_number', 'timeofday',
-	'upper',
-);
-my @KEYWORDS3 = ('STDIN', 'STDOUT');
-my %SYMBOLS = (
-	'='  => '=', '<'  => '&lt;', '>' => '&gt;', '\|' => '|', ',' => ',', '\.' => '.', '\+' => '+', '\-' => '-', '\*' => '*',
-	'\/' => '/', '!=' => '!='
-);
-my @BRACKETS = ('(', ')');
-map {$_ = quotemeta($_)} @BRACKETS;
-
 # Inbounds of query times histogram
 my @histogram_query_time = (0, 1, 5, 10, 25, 50, 100, 500, 1000, 10000);
 
@@ -1169,7 +1097,7 @@ if ($incremental) {
 		&logmsg('DEBUG', "rebuilding reports took: " . timestr($td));
 
 		# Remove pidfile
-		unlink("$PID_DIR/pgbadger.pid");
+		unlink("$PID_FILE");
 
 		exit 0;
 	}
@@ -1183,9 +1111,9 @@ if ($incremental) {
 
 # Reading last line parsed
 if ($last_parsed && -e $last_parsed) {
-	if (open(IN, "$last_parsed")) {
-		my @content = <IN>;
-		close(IN);
+	if (open(my $in, '<', $last_parsed)) {
+		my @content = <$in>;
+		close($in);
 		foreach my $line (@content) {
 			chomp($line);
 			next if (!$line);
@@ -1596,8 +1524,8 @@ if ( ($#given_log_files >= 0) && (($queu
 
 # Get last line parsed from all process
 if ($last_parsed) {
-	if (open(IN, "$tmp_last_parsed") ) {
-		while (my $line = <IN>) {
+	if (open(my $in, '<', $tmp_last_parsed) ) {
+		while (my $line = <$in>) {
 			chomp($line);
 			$line =~ s/\r//;
 			my ($d, $p, $l, @o) = split(/\t/, $line);
@@ -1618,36 +1546,36 @@ if ($last_parsed) {
 				}
 			}
 		}
-		close(IN);
+		close($in);
 	}
 	unlink("$tmp_last_parsed");
 }
 
 # Save last line parsed
 if ($last_parsed && ($last_line{datetime} || $pgb_last_line{datetime}) && ($last_line{orig} || $pgb_last_line{orig}) ) {
-	if (open(OUT, ">$last_parsed")) {
+	if (open(my $out, '>', $last_parsed)) {
 		if ($last_line{datetime}) {
 			$last_line{current_pos} ||= 0;
-			print OUT "$last_line{datetime}\t$last_line{current_pos}\t$last_line{orig}\n";
+			print $out "$last_line{datetime}\t$last_line{current_pos}\t$last_line{orig}\n";
 		} elsif ($saved_last_line{datetime}) {
 			$saved_last_line{current_pos} ||= 0;
-			print OUT "$saved_last_line{datetime}\t$saved_last_line{current_pos}\t$saved_last_line{orig}\n";
+			print $out "$saved_last_line{datetime}\t$saved_last_line{current_pos}\t$saved_last_line{orig}\n";
 		}
 		if ($pgb_last_line{datetime}) {
 			$pgb_last_line{current_pos} ||= 0;
-			print OUT "pgbouncer\t$pgb_last_line{datetime}\t$pgb_last_line{current_pos}\t$pgb_last_line{orig}\n";
+			print $out "pgbouncer\t$pgb_last_line{datetime}\t$pgb_last_line{current_pos}\t$pgb_last_line{orig}\n";
 		} elsif ($pgb_saved_last_line{datetime}) {
 			$pgb_saved_last_line{current_pos} ||= 0;
-			print OUT "pgbouncer\t$pgb_saved_last_line{datetime}\t$pgb_saved_last_line{current_pos}\t$pgb_saved_last_line{orig}\n";
+			print $out "pgbouncer\t$pgb_saved_last_line{datetime}\t$pgb_saved_last_line{current_pos}\t$pgb_saved_last_line{orig}\n";
 		}
-		close(OUT);
+		close($out);
 	} else {
 		&logmsg('ERROR', "can't save last parsed line into $last_parsed, $!");
 	}
 }
 
 if ($terminate) {
-	unlink("$PID_DIR/pgbadger.pid");
+	unlink("$PID_FILE");
 	exit 2;
 }
 
@@ -1659,6 +1587,10 @@ if (!$incremental && ($#given_log_files
 
 	&logmsg('LOG', "Ok, generating $extension report...");
 
+	# Some message have been temporary stored as ERROR but
+	# they are LOGestore them to the right log level.
+	&restore_log_type_count();
+
 	if ($extension ne 'tsung') {
 		$fh = new IO::File ">$outfile";
 		if (not defined $fh) {
@@ -1681,7 +1613,7 @@ if (!$incremental && ($#given_log_files
 		} else {
 			# Create instance to prettify SQL query
 			if (!$noprettify) {
-				$sql_prettified = SQL::Beautify->new(keywords => \@beautify_pg_keywords);
+				$sql_prettified = pgFormatter::Beautify->new();
 			}
 			&dump_as_html('.');
 		}
@@ -1702,13 +1634,13 @@ if (!$incremental && ($#given_log_files
 	# Look for directory where report must be generated
 	my @build_directories = ();
 	if (-e "$last_parsed.tmp") {
-		if (open(IN, "$last_parsed.tmp")) {
-			while (my $l = <IN>) {
+		if (open(my $in, '<', "$last_parsed.tmp")) {
+			while (my $l = <$in>) {
 				chomp($l);
 				$l =~ s/\r//;
 				push(@build_directories, $l) if (!grep(/^$l$/, @build_directories));
 			}
-			close(IN);
+			close($in);
 			unlink("$last_parsed.tmp");
 		} else {
 			&logmsg('ERROR', "can't read file $last_parsed.tmp, $!");
@@ -1727,7 +1659,7 @@ $td = timediff($t2, $t0);
 &logmsg('DEBUG', "the total execution time took: " . timestr($td));
 
 # Remove pidfile and temporary file
-unlink("$PID_DIR/pgbadger.pid");
+unlink("$PID_FILE");
 unlink("$last_parsed.tmp") if (-e "$last_parsed.tmp");
 
 exit 0;
@@ -1755,16 +1687,15 @@ Options:
     -A | --histo-average min: number of minutes to build the histogram graphs
                              of queries. Default 60 minutes.
     -b | --begin datetime  : start date/time for the data to be parsed in log.
-    -B | --bar-graph       : use bar graph instead of line by default.
     -c | --dbclient host   : only report on entries for the given client host.
     -C | --nocomment       : remove comments like /* ... */ from queries.
     -d | --dbname database : only report on entries for the given database.
     -D | --dns-resolv      : client ip addresses are replaced by their DNS name.
                              Be warned that this can really slow down pgBadger.
     -e | --end datetime    : end date/time for the data to be parsed in log.
-    -f | --format logtype  : possible values: syslog, syslog2, stderr, csv and
-			     pgbouncer. Use this option when pgBadger is not
-                             able to auto-detect the log format Default: stderr.
+    -f | --format logtype  : possible values: syslog, syslog2, stderr, jsonlog,
+			     cvs and pgbouncer. Use this option when pgBadger is
+                             not able to auto-detect the log format.
     -G | --nograph         : disable graphs on HTML output. Enabled by default.
     -h | --help            : show this message and exit.
     -i | --ident name      : programname used as syslog ident. Default: postgres
@@ -1856,6 +1787,9 @@ Options:
     --exclude-time  regex  : any timestamp matching the given regex will be
 			     excluded from the report. Example: "2013-04-12 .*"
                              You can use this option multiple times.
+    --include-time  regex  : only timestamps matching the given regex will be
+			     included in the report. Example: "2013-04-12 .*"
+                             You can use this option multiple times.
     --exclude-appname name : exclude entries for the specified application name
 			     from report. Example: "pg_dump".
     --exclude-line regex   : pgBadger will start to exclude any log entry that
@@ -1871,15 +1805,22 @@ Options:
     --journalctl command   : command to use to replace PostgreSQL logfile by
 			     a call to journalctl. Basically it might be:
 				journalctl -u postgresql-9.5
-    --pid-dir dirpath      : set the path of the directory where the pid file
-                             will be written to be able to run two pgBadger at
-			     the same time.
+    --pid-dir path         : set the path where the pid file must be stored.
+                             Default /tmp
+    --pid-file file        : set the name of the pid file to manage concurrent
+                             execution of pgBadger. Default: pgbadger.pid
     --rebuild              : used to rebuild all html reports in incremental
                              output directories where there is binary data files.
     --pgbouncer-only       : only show PgBouncer related menu in the header.
     --start-monday         : in incremental mode, calendar's weeks start on
                              sunday. Use this option to start on monday.
     --normalized-only      : only dump all normalized query to out.txt
+    --log-timezone  +/-XX  : Set the number of hours from GMT of the timezone
+                             that must be used to adjust date/time read from
+                             log file before beeing parsed. Using this option
+                             make more difficult log search with a date/time.
+    --prettify-json        : use it if you want json output to be prettified.
+
 
 pgBadger is able to parse a remote log file using a passwordless ssh connection.
 Use the -r or --remote-host to set the host ip address or hostname. There's also
@@ -1994,22 +1935,48 @@ sub set_parser_regex
 	my $fmt = shift;
 
 	@prefix_params = ();
+	@prefix_q_params = ();
 
 	if ($fmt eq 'pgbouncer') {
 
-		$pgbouncer_log_format = qr/^(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2})\.\d+(?: [A-Z\+\-\d]{3,6})? (\d+) ([^\s]+) (.\-0x[0-9a-f\.]*): ([0-9a-zA-Z\_\[\]\-\.]*)\/([0-9a-zA-Z\_\[\]\-\.]*)\@([a-zA-Z0-9\-\.]+|\[local\]|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9a-fA-F:]+)?[:\d]* (.*)/;
+		$pgbouncer_log_format = qr/^(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2})\.\d+(?: [A-Z\+\-\d]{3,6})? (\d+) ([^\s]+) (.\-0x[0-9a-f\.]*): ([0-9a-zA-Z\_\[\]\-\.]*)\/([0-9a-zA-Z\_\[\]\-\.]*)\@([a-zA-Z0-9\-\.]+|\[local\]|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9a-fA-F:]+)(?:\(\d+\))??[:\d]* (.*)/;
 		@pgb_prefix_params = ('t_timestamp', 't_pid', 't_loglevel', 't_session_id', 't_dbname', 't_dbuser', 't_client', 't_query');
 
 		$pgbouncer_log_parse1 = qr/^(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2})\.\d+(?: [A-Z\+\-\d]{3,6})? (\d+) ([^\s]+) (.*)/;
 		@pgb_prefix_parse1 = ('t_timestamp', 't_pid', 't_loglevel', 't_query');
-		$pgbouncer_log_parse2 = qr/^(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2})\.\d+(?: [A-Z\+\-\d]{3,6})? (\d+) ([^\s]+) (.\-0x[0-9a-f\.]*): ([0-9a-zA-Z\_\[\]\-\.]*)\/([0-9a-zA-Z\_\[\]\-\.]*)\@([a-zA-Z0-9\-\.]+|\[local\]|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9a-fA-F:]+)?[:\d]* (.*)/;
-		@pgb_prefix_parse2 = ('t_timestamp', 't_pid', 't_loglevel', 't_session_id', 't_dbname', 't_dbuser', 't_client', 't_query');
+		$pgbouncer_log_parse2 = qr/^\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}\.\d+(?: [A-Z\+\-\d]{3,6})? \d+ [^\s]+ .\-0x[0-9a-f\.]*: ([0-9a-zA-Z\_\[\]\-\.]*)\/([0-9a-zA-Z\_\[\]\-\.]*)\@([a-zA-Z0-9\-\.]+|\[local\]|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9a-fA-F:]+)?(?:\(\d+\))?(?:\(\d+\))?[:\d]* (.*)/;
+		@pgb_prefix_parse2 = ('t_dbname', 't_dbuser', 't_client', 't_query');
+
+	} elsif ($fmt eq 'pgbouncer1') {
+
+		$fmt = 'pgbouncer';
+		$pgbouncer_log_format = qr/^(...)\s+(\d+)\s(\d+):(\d+):(\d+)(?:\s[^\s]+)?\s([^\s]+)\s([^\s\[]+)\[(\d+)\]: (.\-0x[0-9a-f\.]*): ([0-9a-zA-Z\_\[\]\-\.]*)\/([0-9a-zA-Z\_\[\]\-\.]*)\@([a-zA-Z0-9\-\.]+|\[local\]|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9a-fA-F:]+)?(?:\(\d+\))?[:\d]* (.*)/;
+		@pgb_prefix_params = ('t_year', 't_month', 't_day', 't_hour', 't_min', 't_sec', 't_host', 't_ident', 't_pid', 't_session_id', 't_dbname', 't_dbuser', 't_client', 't_query');
+
+		$pgbouncer_log_parse1 = qr/^(...)\s+(\d+)\s(\d+):(\d+):(\d+)(?:\s[^\s]+)?\s([^\s]+)\s([^\s\[]+)\[(\d+)\]: (.\-0x[0-9a-f\.]*): (.*)/;
+		@pgb_prefix_parse1 = ('t_month', 't_day', 't_hour', 't_min', 't_sec', 't_host', 't_ident', 't_pid', 't_query');
+		$pgbouncer_log_parse2 = qr/^...\s+\d+\s\d+:\d+:\d+(?:\s[^\s]+)?\s[^\s]+\s[^\s\[]+\[\d+\]: .\-0x[0-9a-f\.]*: ([0-9a-zA-Z\_\[\]\-\.]*)\/([0-9a-zA-Z\_\[\]\-\.]*)\@([a-zA-Z0-9\-\.]+|\[local\]|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9a-fA-F:]+)?(?:\(\d+\))?[:\d]* (.*)/;
+		@pgb_prefix_parse2 = ('t_dbname', 't_dbuser', 't_client', 't_query');
+
+	} elsif ($fmt eq 'pgbouncer2') {
+
+		$fmt = 'pgbouncer';
+		$pgbouncer_log_format = qr/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})(?:.[^\s]+)?\s([^\s]+)\s(?:[^\s]+\s)?(?:[^\s]+\s)?([^\s\[]+)\[(\d+)\]: (.\-0x[0-9a-f\.]*): ([0-9a-zA-Z\_\[\]\-\.]*)\/([0-9a-zA-Z\_\[\]\-\.]*)\@([a-zA-Z0-9\-\.]+|\[local\]|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9a-fA-F:]+)?(?:\(\d+\))?[:\d]* (.*)/;
+		@pgb_prefix_params = ('t_year', 't_month', 't_day', 't_hour', 't_min', 't_sec', 't_host', 't_ident', 't_pid', 't_session_id', 't_dbname', 't_dbuser', 't_client', 't_query');
+
+		$pgbouncer_log_parse1 = qr/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})(?:.[^\s]+)?\s([^\s]+)\s(?:[^\s]+\s)?(?:[^\s]+\s)?([^\s\[]+)\[(\d+)\]: (.\-0x[0-9a-f\.]*): (.*)/;
+		@pgb_prefix_parse1 = ('t_year', 't_month', 't_day', 't_hour', 't_min', 't_sec', 't_host', 't_ident', 't_pid', 't_query');
+		$pgbouncer_log_parse2 = qr/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(?:.[^\s]+)?\s[^\s]+\s(?:[^\s]+\s)?(?:[^\s]+\s)?[^\s\[]+\[\d+\]: .\-0x[0-9a-f\.]*: ([0-9a-zA-Z\_\[\]\-\.]*)\/([0-9a-zA-Z\_\[\]\-\.]*)\@([a-zA-Z0-9\-\.]+|\[local\]|\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[0-9a-fA-F:]+)?(?:\(\d+\))?[:\d]* (.*)/;
+		@pgb_prefix_parse2 = ('t_dbname', 't_dbuser', 't_client', 't_query');
 
 	} elsif ($log_line_prefix) {
 
 		# Build parameters name that will be extracted from the prefix regexp
-		my $llp = '';
-		($llp, @prefix_params) = &build_log_line_prefix_regex($log_line_prefix);
+		my %res = &build_log_line_prefix_regex($log_line_prefix);
+		my $llp = $res{'llp'};
+		@prefix_params = @{ $res{'param_list'} };
+		$q_prefix = $res{'q_prefix'};
+		@prefix_q_params = @{ $res{'q_param_list'} };
 
 		if ($fmt eq 'syslog') {
 			$llp =
@@ -2030,11 +1997,11 @@ sub set_parser_regex
 			unshift(@prefix_params, 't_year', 't_month', 't_day', 't_hour', 't_min', 't_sec', 't_host', 't_ident', 't_pid', 't_session_line');
 			push(@prefix_params, 't_loglevel', 't_query');
 			$other_syslog_line = qr/^(\d+-\d+)-(\d+)T(\d+):(\d+):(\d+)(?:.[^\s]+)?\s([^\s]+)\s(?:[^\s]+\s)?(?:[^\s]+\s)?([^\s\[]+)\[(\d+)\]:(?:\s\[[^\]]+\])?(?:\s\[(\d+)\-\d+\])?\s*(.*)/;
-		} elsif ($fmt eq 'stderr') {
+		} elsif ($fmt eq 'stderr' || $fmt eq 'default') {
+			$fmt = 'stderr';
 			$llp = '^' . $llp . '\s*(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT|LOCATION):\s+(?:[0-9A-Z]{5}:\s+)?(.*)';
 			$compiled_prefix = qr/$llp/;
 			push(@prefix_params, 't_loglevel', 't_query');
-
 		}
 
 	} elsif ($fmt eq 'syslog') {
@@ -2057,14 +2024,14 @@ sub set_parser_regex
 	} elsif ($fmt eq 'stderr') {
 
 		$compiled_prefix =
-	qr/^(\d{10}\.\d{3}|\d{4}-\d{2}-\d{2}\s\d{2}:\d{2}:\d{2})[\.\d]*(?: [A-Z\+\-\d]{3,6})?\s\[(\d+)\]:\s\[(\d+)\-\d+\]\s*(.*?)\s*(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT|LOCATION):\s+(?:[0-9A-Z]{5}:\s+)?(.*)/;
+	qr/^(\d{10}\.\d{3}|\d{4}-\d{2}-\d{2}\s\d{2}:\d{2}:\d{2})[\.\d]*(?: [A-Z\+\-\d]{3,6})?\s\[([0-9a-f\.]+)\]:\s\[(\d+)\-\d+\]\s*(.*?)\s*(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT|LOCATION):\s+(?:[0-9A-Z]{5}:\s+)?(.*)/;
 		push(@prefix_params, 't_timestamp', 't_pid', 't_session_line', 't_logprefix', 't_loglevel', 't_query');
 
 	} elsif ($fmt eq 'default') {
 
 		$fmt = 'stderr';
 		$compiled_prefix =
-	qr/^(\d{10}\.\d{3}|\d{4}-\d{2}-\d{2}\s\d{2}:\d{2}:\d{2})[\.\d]*(?: [A-Z\+\-\d]{3,6})?\s\[(\d+)\]\s(.*?)\s*(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT|LOCATION):\s+(?:[0-9A-Z]{5}:\s+)?(.*)/;
+	qr/^(\d{10}\.\d{3}|\d{4}-\d{2}-\d{2}\s\d{2}:\d{2}:\d{2})[\.\d]*(?: [A-Z\+\-\d]{3,6})?\s\[([0-9a-f\.]+)\][:]*\s(.*?)\s*(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT|LOCATION):\s+(?:[0-9A-Z]{5}:\s+)?(.*)/;
 		push(@prefix_params, 't_timestamp', 't_pid', 't_logprefix', 't_loglevel', 't_query');
 	}
 
@@ -2087,16 +2054,16 @@ sub build_incremental_reports
 	my @build_directories = @_;
 
 	my %weeks_directories = ();
-	foreach $incr_date (sort @build_directories) {
+	foreach my $bpath (sort @build_directories) {
 
-		$last_incr_date = $incr_date;
+		$incr_date = $bpath;
+		$last_incr_date = $bpath;
 
 		# Set the path to binary files
-		my $bpath = $incr_date;
 		$bpath =~ s/\-/\//g;
-		$incr_date =~ /^(\d+)-(\d+)\-(\d+)$/;
 
 		# Get the week number following the date
+		$incr_date =~ /^(\d+)-(\d+)\-(\d+)$/;
 		my $wn = &get_week_number($1, $2, $3);
 		$weeks_directories{$wn} = "$1-$2" if ($rebuild || !exists $weeks_directories{$wn});
 
@@ -2124,7 +2091,7 @@ sub build_incremental_reports
 		}
 		# Create instance to prettify SQL query
 		if (!$noprettify) {
-			$sql_prettified = SQL::Beautify->new(keywords => \@beautify_pg_keywords);
+			$sql_prettified = pgFormatter::Beautify->new();
 		}
 		&dump_as_html('../../..');
 		$fh->close;
@@ -2139,8 +2106,8 @@ sub build_incremental_reports
 		my $wdir = '';
 
 		# Load data per day
-		foreach $incr_date (@wdays) {
-			my $bpath = $incr_date;
+		foreach my $bpath (@wdays) {
+			$incr_date = $bpath;
 			$bpath =~ s/\-/\//g;
 			$incr_date =~ /^(\d+)\-(\d+)\-(\d+)$/;
 			$wdir = "$1/week-$wn";
@@ -2171,7 +2138,7 @@ sub build_incremental_reports
 		}
 		# Create instance to prettify SQL query
 		if (!$noprettify) {
-			$sql_prettified = SQL::Beautify->new(keywords => \@beautify_pg_keywords);
+			$sql_prettified = pgFormatter::Beautify->new();
 		}
 		&dump_as_html('../..');
 		$fh->close;
@@ -2186,7 +2153,9 @@ sub build_incremental_reports
 	}
 	my $date = localtime(time);
 	my @tmpjscode = @jscode;
-	map { s/EDIT_URI/\./; } @tmpjscode;
+	for (my $i = 0; $i <= $#tmpjscode; $i++) {
+		$tmpjscode[$i] =~ s/EDIT_URI/\./;
+	}
 	my $local_title = 'Global Index on incremental reports';
 	if ($report_title) {
 		$local_title = 'Global Index - ' . $report_title;
@@ -2487,8 +2456,8 @@ sub process_file
 		&logmsg('DEBUG', "Starting to parse remote log file: $remote_host:$logfile");
 	}
 
-	local $SIG{INT} = sub { print STDERR "Received SIGINT abort parsing...\n"; unlink("$PID_DIR/pgbadger.pid"); $terminate = 1; };
-	local $SIG{TERM} = sub { print STDERR "Received SIGTERM abort parsing...\n"; unlink("$PID_DIR/pgbadger.pid"); $terminate = 1; };
+	local $SIG{INT} = sub { print STDERR "Received SIGINT abort parsing...\n"; unlink("$PID_FILE"); $terminate = 1; };
+	local $SIG{TERM} = sub { print STDERR "Received SIGTERM abort parsing...\n"; unlink("$PID_FILE"); $terminate = 1; };
 
 	my $curdate = localtime(time);
 
@@ -2503,6 +2472,27 @@ sub process_file
 
 	# Get file handle and size of the file
 	my ($lfile, $totalsize) = &get_log_file($logfile);
+	if (!defined $lfile) {
+
+		if ($progress && ($getout != 1)) {
+			if (!$tmpoutfile) {
+				if ($totalsize) {
+					print STDERR &progress_bar($cursize, $stop_offset || $totalsize, 25, '=',$overall_stat{'queries_number'},($overall_stat{'errors_number'}+$pgb_overall_stat{'errors_number'}), $logfile);
+					print STDERR "\n";
+				}
+			} else {
+				$pipe->print("$cursize " . ($overall_stat{'queries_number'} - $old_queries_count) . " " . (($overall_stat{'errors_number'}+$pgb_overall_stat{'errors_number'}) - $old_errors_count) . "\n");
+			}
+		}
+		if ($tmpoutfile) {
+
+			&dump_as_binary($tmpoutfile);
+			$tmpoutfile->close();
+
+		}
+
+	}
+
 	# Reset the start position if file is smaller that the current start offset
 	if ($start_offset > $totalsize) {
 		&logmsg('DEBUG', "Starting offset $start_offset is greater than total size $totalsize for file $logfile");
@@ -2533,9 +2523,6 @@ sub process_file
 
 	my $current_offset = $start_offset || 0;
 
-	# Forward the progress bar to the starting point in MP mode
-	#$cursize = $start_offset if ($chunk_pos == 0);
-
 	if (!$remote_host) {
 		&logmsg('DEBUG', "Starting reading file $logfile...");
 	} else {
@@ -2589,10 +2576,27 @@ sub process_file
 				for (my $i = 0 ; $i <= $#pgb_prefix_parse1 ; $i++) {
 					$prefix_vars{$pgb_prefix_parse1[$i]} = $matches[$i];
 				}
+				# Get detailled information from timestamp
+				if (!$prefix_vars{'t_month'}) {
+					($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'},
+						$prefix_vars{'t_min'}, $prefix_vars{'t_sec'}) = ($prefix_vars{'t_timestamp'} =~ $time_pattern);
+				} else {
 
-				# Get time detailed information
-				($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'},
-					$prefix_vars{'t_min'}, $prefix_vars{'t_sec'}) = ($prefix_vars{'t_timestamp'} =~ $time_pattern);
+					# Standard syslog format does not have year information, months are
+					# three letters and days are not always with 2 digits.
+					if ($prefix_vars{'t_month'} !~ /\d/) {
+						$prefix_vars{'t_year'}  = $gyear;
+						$prefix_vars{'t_day'}   = sprintf("%02d", $prefix_vars{'t_day'});
+						$prefix_vars{'t_month'} = $month_abbr{$prefix_vars{'t_month'}};
+						# Take care of year overlapping
+						if ("$prefix_vars{'t_year'}$prefix_vars{'t_month'}$prefix_vars{'t_day'}" > $CURRENT_DATE) {
+							$prefix_vars{'t_year'} = substr($CURRENT_DATE, 0, 4) - 1;
+						}
+					}
+					$prefix_vars{'t_timestamp'} =
+"$prefix_vars{'t_year'}-$prefix_vars{'t_month'}-$prefix_vars{'t_day'} $prefix_vars{'t_hour'}:$prefix_vars{'t_min'}:$prefix_vars{'t_sec'}";
+				}
+				$prefix_vars{'t_loglevel'} = 'LOG';
 
 				# Skip unwanted lines
 				my $res = &skip_unwanted_line();
@@ -2606,6 +2610,15 @@ sub process_file
 				# Jump to the last line parsed if required
 				next if (!&check_incremental_position($fmt, $prefix_vars{'t_timestamp'}, $line));
 
+				# Store the current timestamp of the log line
+				&store_current_timestamp($prefix_vars{'t_timestamp'});
+
+				# Override timestamp when we have to adjust datetime to the log timezone
+				if ($log_timezone) {
+					($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'}) = change_timezone($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'});
+					$prefix_vars{'t_timestamp'} = "$prefix_vars{'t_year'}-$prefix_vars{'t_month'}-$prefix_vars{'t_day'} $prefix_vars{'t_hour'}:$prefix_vars{'t_min'}:$prefix_vars{'t_sec'}";
+				}
+
 				# Extract other information from the line
 				@matches = ($line =~ $pgbouncer_log_parse2);
 				if ($#matches >= 0) {
@@ -2615,7 +2628,7 @@ sub process_file
 					$prefix_vars{'t_client'} = _gethostbyaddr($prefix_vars{'t_client'}) if ($dns_resolv && $prefix_vars{'t_client'});
 				} else {
 					# pgBouncer Statistics appears each minutes in the log
-					if ($prefix_vars{'t_query'} =~ /Stats: (\d+) req\/s, in (\d+) b\/s, out (\d+) b\/s,query (\d+) us/) {
+					if ($prefix_vars{'t_query'} =~ /[Ss]tats: (\d+) req\/s, in (\d+) b\/s, out (\d+) b\/s,query (\d+) us/) {
 						$prefix_vars{'t_loglevel'} = 'STATS';
 						$prefix_vars{'t_req/s'} = $1;
 						$prefix_vars{'t_inbytes/s'} = $2;
@@ -2624,9 +2637,6 @@ sub process_file
 					}
 				}
 
-				# Store the current timestamp of the log line
-				&store_current_timestamp($prefix_vars{'t_timestamp'});
-
 				# Check if the log line should be excluded from the report
 				if (&validate_log_line($prefix_vars{'t_pid'})) {
 					$prefix_vars{'t_host'} = 'stderr'; # this unused variable is used to store format information when log format is not syslog
@@ -2681,12 +2691,19 @@ sub process_file
 				# Extract the date
 				if ($row->[0] =~ m/^(\d+)-(\d+)-(\d+)\s+(\d+):(\d+):(\d+)\.(\d+)/) {
 
-					# Remove newline characters from queries
-					map { s/[\r\n]+/ /gs; } @$row;
-
+					$prefix_vars{'t_year'} = $1;
+					$prefix_vars{'t_month'} = $2;
+					$prefix_vars{'t_day'} = $3;
+					$prefix_vars{'t_hour'} = $4;
+					$prefix_vars{'t_min'} = $5;
+					$prefix_vars{'t_sec'} = $6;
 					my $milli = $7 || 0;
-					($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'}) = ($1, $2, $3, $4, $5, $6);
-					$prefix_vars{'t_timestamp'} = "$1-$2-$3 $4:$5:$6";
+					$prefix_vars{'t_timestamp'} = "$prefix_vars{'t_year'}-$prefix_vars{'t_month'}-$prefix_vars{'t_day'} $prefix_vars{'t_hour'}:$prefix_vars{'t_min'}:$prefix_vars{'t_sec'}";
+
+					# Remove newline characters from queries
+					for (my $i = 0; $i <= $#$row; $i++) {
+						$row->[$i] =~ s/[\r\n]+/ /gs;
+					}
 
 					# Skip unwanted lines
 					my $res = &skip_unwanted_line();
@@ -2703,6 +2720,12 @@ sub process_file
 					# Store the current timestamp of the log line
 					&store_current_timestamp($prefix_vars{'t_timestamp'});
 
+					# Update current timestamp with the timezone wanted
+					if ($log_timezone) {
+						($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'}) = change_timezone($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'});
+						$prefix_vars{'t_timestamp'} = "$prefix_vars{'t_year'}-$prefix_vars{'t_month'}-$prefix_vars{'t_day'} $prefix_vars{'t_hour'}:$prefix_vars{'t_min'}:$prefix_vars{'t_sec'}";
+					}
+
 					# Set query parameters as global variables
 					$prefix_vars{'t_dbuser'}  = $row->[1] || '';
 					$prefix_vars{'t_dbname'}  = $row->[2] || '';
@@ -2743,7 +2766,9 @@ sub process_file
 		}
 
 	}
+
 	elsif ($fmt eq 'binary') {
+
 		&load_stats($lfile);
 	}
 	else { # Format is not CSV.
@@ -2788,15 +2813,59 @@ sub process_file
 
 			%prefix_vars = ();
 
+			# Parse jsonlog lines
+			if ($fmt =~ /jsonlog/) {
+
+				%prefix_vars = parse_jsonlog_input($line);
+
+				# Skip unwanted lines
+				my $res = &skip_unwanted_line();
+				next if ($res == 1);
+
+				# Jump to the last line parsed if required
+				next if (!&check_incremental_position($fmt, $prefix_vars{'t_timestamp'}, $line));
+
+				# Store the current timestamp of the log line
+				&store_current_timestamp($prefix_vars{'t_timestamp'});
+
+				# Update current timestamp with the timezone wanted
+				if ($log_timezone) {
+					($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'}) = change_timezone($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'});
+					$prefix_vars{'t_timestamp'} = "$prefix_vars{'t_year'}-$prefix_vars{'t_month'}-$prefix_vars{'t_day'} $prefix_vars{'t_hour'}:$prefix_vars{'t_min'}:$prefix_vars{'t_sec'}";
+				}
+
+				# Check if the log line should be excluded from the report
+				if (&validate_log_line($prefix_vars{'t_pid'})) {
+
+					# Parse the query now
+					&parse_query($fmt);
+
+					# The information can be saved immediately with csvlog
+					&store_queries($prefix_vars{'t_pid'});
+					delete $cur_info{$prefix_vars{'t_pid'}};
+				}
+
 			# Parse syslog lines
-			if ($fmt =~ /syslog/) {
+			} elsif ($fmt =~ /syslog/) {
 
 				@matches = ($line =~ $compiled_prefix);
 
+				my $q_match = 0;
+				if ($#matches < 0 && $q_prefix) {
+					@matches = ($line =~ $q_prefix);
+					$q_match = 1;
+				}
+
 				if ($#matches >= 0) {
 
-					for (my $i = 0 ; $i <= $#prefix_params ; $i++) {
-						$prefix_vars{$prefix_params[$i]} = $matches[$i];
+					if (!$q_match) {
+						for (my $i = 0 ; $i <= $#prefix_params ; $i++) {
+							$prefix_vars{$prefix_params[$i]} = $matches[$i];
+						}
+					} else {
+						for (my $i = 0 ; $i <= $#prefix_q_params ; $i++) {
+							$prefix_vars{$prefix_q_params[$i]} = $matches[$i];
+						}
 					}
 
 					# skip non postgresql lines
@@ -2818,7 +2887,6 @@ sub process_file
 					}
 					$prefix_vars{'t_timestamp'} =
 "$prefix_vars{'t_year'}-$prefix_vars{'t_month'}-$prefix_vars{'t_day'} $prefix_vars{'t_hour'}:$prefix_vars{'t_min'}:$prefix_vars{'t_sec'}";
-
 					if ($prefix_vars{'t_hostport'} && !$prefix_vars{'t_client'}) {
 						$prefix_vars{'t_client'} = $prefix_vars{'t_hostport'};
 						# Remove the port part
@@ -2842,6 +2910,12 @@ sub process_file
 					# Store the current timestamp of the log line
 					&store_current_timestamp($prefix_vars{'t_timestamp'});
 
+					# Update current timestamp with the timezone wanted
+					if ($log_timezone) {
+						($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'}) = change_timezone($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'});
+						$prefix_vars{'t_timestamp'} = "$prefix_vars{'t_year'}-$prefix_vars{'t_month'}-$prefix_vars{'t_day'} $prefix_vars{'t_hour'}:$prefix_vars{'t_min'}:$prefix_vars{'t_sec'}";
+					}
+
 					# Extract information from log line prefix
 					if (!$log_line_prefix) {
 						&parse_log_prefix($prefix_vars{'t_logprefix'});
@@ -2890,27 +2964,23 @@ sub process_file
 			} elsif ($fmt eq 'stderr') {
 
 				@matches = ($line =~ $compiled_prefix);
+
+				my $q_match = 0;
+				if ($#matches < 0 && $q_prefix) {
+					@matches = ($line =~ $q_prefix);
+					$q_match = 1;
+				}
+
 				if ($#matches >= 0) {
 
-					# Store auto explain plan when switching to an other log entry
-					foreach my $p (keys %cur_plan_info) {
-						if (exists $cur_plan_info{$p}{plan}) {
-							# Extract the query part from the plan
-							my $key = 'query';
-							my @plan = split("\n", $cur_plan_info{$p}{plan});
-							foreach my $l (@plan) {
-								$key = 'plan' if ($l =~ /\(cost=\d+.*rows=\d+/);
-								$cur_info{$p}{$key} .= "$l\n";
-							}
-							$cur_info{$p}{query} =~ s/^\s*Query Text:\s+//s;
-							delete $cur_plan_info{$p};
-							&store_queries($p);
-							delete $cur_info{$p};
+					if (!$q_match) {
+						for (my $i = 0 ; $i <= $#prefix_params ; $i++) {
+							$prefix_vars{$prefix_params[$i]} = $matches[$i];
+						}
+					} else {
+						for (my $i = 0 ; $i <= $#prefix_q_params ; $i++) {
+							$prefix_vars{$prefix_q_params[$i]} = $matches[$i];
 						}
-					}
-
-					for (my $i = 0 ; $i <= $#prefix_params ; $i++) {
-						$prefix_vars{$prefix_params[$i]} = $matches[$i];
 					}
 					$prefix_vars{'t_pid'} = $prefix_vars{'t_session_id'} if ($use_sessionid_as_pid);
 
@@ -2957,6 +3027,12 @@ sub process_file
 					# Store the current timestamp of the log line
 					&store_current_timestamp($prefix_vars{'t_timestamp'});
 
+					# Update current timestamp with the timezone wanted
+					if ($log_timezone) {
+						($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'}) = change_timezone($prefix_vars{'t_year'}, $prefix_vars{'t_month'}, $prefix_vars{'t_day'}, $prefix_vars{'t_hour'}, $prefix_vars{'t_min'}, $prefix_vars{'t_sec'});
+						$prefix_vars{'t_timestamp'} = "$prefix_vars{'t_year'}-$prefix_vars{'t_month'}-$prefix_vars{'t_day'} $prefix_vars{'t_hour'}:$prefix_vars{'t_min'}:$prefix_vars{'t_sec'}";
+					}
+
 					# Extract information from log line prefix
 					if (!$log_line_prefix) {
 						&parse_log_prefix($prefix_vars{'t_logprefix'});
@@ -2985,7 +3061,7 @@ sub process_file
 					# Some log line may be written by applications
 					next if ($line =~ /\bLOG:  /);
 
-					# Parse orphan lines to append inforamtion to the right place
+					# Parse orphan lines to append information to the right place
 					&parse_orphan_line($cur_pid, $line);
 
 				} else {
@@ -2996,6 +3072,7 @@ sub process_file
 			}
 			last if (($stop_offset > 0) && ($current_offset >= $stop_offset));
 		}
+
 		if ($last_parsed) {
 			$last_line{current_pos} = $current_offset;
 		}
@@ -3064,10 +3141,10 @@ sub process_file
 		$bpath =~ s/\-/\//g;
 
 		# Mark the directory as needing index update
-		if (open(OUT, ">>$last_parsed.tmp")) {
-			flock(OUT, 2) || return $getout;
-			print OUT "$incr_date\n";
-			close(OUT);
+		if (open(my $out, '>>', "$last_parsed.tmp")) {
+			flock($out, 2) || return $getout;
+			print $out "$incr_date\n";
+			close($out);
 		} else {
 			&logmsg('ERROR', "can't save last parsed line into $last_parsed.tmp, $!");
 		}
@@ -3092,18 +3169,18 @@ sub process_file
 
 	# Save last line into temporary file
 	if ($last_parsed && (scalar keys %last_line || scalar keys %pgb_last_line)) {
-		if (open(OUT, ">>$tmp_last_parsed")) {
-			flock(OUT, 2) || return $getout;
+		if (open(my $out, '>>', "$tmp_last_parsed")) {
+			flock($out, 2) || return $getout;
 			if ($fmt eq 'pgbouncer') {
 				$pgb_last_line{current_pos} ||= 0;
 				&logmsg('DEBUG', "Saving pgbouncer last parsed line into $tmp_last_parsed ($pgb_last_line{datetime}\t$pgb_last_line{current_pos})");
-				print OUT "pgbouncer\t$pgb_last_line{datetime}\t$pgb_last_line{current_pos}\t$pgb_last_line{orig}\n";
+				print $out "pgbouncer\t$pgb_last_line{datetime}\t$pgb_last_line{current_pos}\t$pgb_last_line{orig}\n";
 			} else {
 				$last_line{current_pos} ||= 0;
 				&logmsg('DEBUG', "Saving last parsed line into $tmp_last_parsed ($last_line{datetime}\t$last_line{current_pos})");
-				print OUT "$last_line{datetime}\t$last_line{current_pos}\t$last_line{orig}\n";
+				print $out "$last_line{datetime}\t$last_line{current_pos}\t$last_line{orig}\n";
 			}
-			close(OUT);
+			close($out);
 		} else {
 			&logmsg('ERROR', "can't save last parsed line into $tmp_last_parsed, $!");
 		}
@@ -3118,6 +3195,87 @@ sub process_file
 	return $getout;
 }
 
+sub unescape_jsonlog
+{
+	my $str = shift;
+
+	while ($str =~ s/([^\\])\\"/$1"/g) {};
+	while ($str =~ s/([^\\])\\t/$1\t/g) {};
+	while ($str =~ s/\\r\\n/\n/gs) {};
+	while ($str =~ s/([^\\])\\r/$1\n/gs) {};
+	while ($str =~ s/([^\\])\\n/$1\n/gs) {};
+	
+	return $str;
+}
+
+sub parse_jsonlog_input
+{
+	my $str = shift;
+
+	my %infos = ();
+
+	# Extract the date
+	if ($str =~ m/\{"timestamp":"(\d+)-(\d+)-(\d+)T(\d+):(\d+):(\d+)\.(\d+)/) {
+
+		$infos{'t_year'} = $1;
+		$infos{'t_month'} = $2;
+		$infos{'t_day'} = $3;
+		$infos{'t_hour'} = $4;
+		$infos{'t_min'} = $5;
+		$infos{'t_sec'} = $6;
+		my $milli = $7 || 0;
+		$infos{'t_timestamp'} = "$infos{'t_year'}-$infos{'t_month'}-$infos{'t_day'} $infos{'t_hour'}:$infos{'t_min'}:$infos{'t_sec'}";
+	}
+
+	# Set query parameters as global variables
+	if ($str =~ m/"user":"(.*?)"(?:,"|\})/) {
+		$infos{'t_dbuser'}  = $1;
+	}
+	if ($str =~ m/"dbname":"(.*?)"(?:,"|\})/) {
+		$infos{'t_dbname'}  = $1;
+	}
+	if ($str =~ m/"application_name":"(.*?)"(?:,"|\})/) {
+		$infos{'t_appname'} = $1;
+	}
+	if ($str =~ m/"remote_host":"(.*?)"(?:,"|\})/) {
+		$infos{'t_client'}  = $1;
+		$infos{'t_client'}  =~ s/:.*//;
+		$infos{'t_client'} = _gethostbyaddr($infos{'t_client'}) if ($dns_resolv);
+	}
+	$infos{'t_host'}    = 'jsonlog'; # this unused variable is used to store format information when log format is not syslog
+	if ($str =~ m/"pid":"(.*?)"(?:,"|\})/) {
+		$infos{'t_pid'} = $1;
+	}
+	if ($str =~ m/"error_severity":"(.*?)"(?:,"|\})/) {
+		$infos{'t_loglevel'} = $1;
+	}
+	if ($str =~ m/"state_code":"(.*?)"(?:,"|\})/) {
+		$infos{'t_sqlstate'} = $1;
+	}
+	if ($str =~ m/"message":"(.*?)"(?:,"|\})/) {
+		$infos{'t_query'} = unescape_jsonlog($1);
+	} elsif ($str =~ m/"statement":"(.*?)"(?:,"|\})/) {
+		$infos{'t_query'} = unescape_jsonlog($1);
+	}
+
+	# Set ERROR additional information
+	if ($str =~ m/"(?:detail_log|detail)":"(.*?)"(?:,"|\})/) {
+		$infos{'t_detail'} = unescape_jsonlog($1);
+	}
+	if ($str =~ m/"hint":"(.*?)"(?:,"|\})/) {
+		$infos{'t_hint'} = unescape_jsonlog($1);
+	}
+	if ($str =~ m/"context":"(.*?)"(?:,"|\})/) {
+		$infos{'t_context'} = unescape_jsonlog($1);
+	}
+	if ($str =~ m/"(?:statement|internal_query)":"(.*?)"(?:,"|\})/) {
+		$infos{'t_statement'} = unescape_jsonlog($1);
+	}
+
+	return %infos;
+}
+
+
 sub parse_orphan_line
 {
 	my ($cur_pid, $line) = @_;
@@ -3127,7 +3285,7 @@ sub parse_orphan_line
 		if ($line =~ /^\t?(pages|tuples): (\d+) removed, (\d+) remain/) {
 			$autovacuum_info{tables}{$cur_info{$cur_pid}{vacuum}}{$1}{removed} += $2;
 		}
-		if ($line =~ m#^\t?system usage: CPU .* sec elapsed (.*) sec#) {
+		if ($line =~ m#^\t?system usage: CPU .* (?:sec|s,) elapsed (.*) s#) {
 			if ($1 > $autovacuum_info{peak}{system_usage}{elapsed}) {
 				$autovacuum_info{peak}{system_usage}{elapsed} = $1;
 				$autovacuum_info{peak}{system_usage}{table} = $cur_info{$cur_pid}{vacuum};
@@ -3142,7 +3300,7 @@ sub parse_orphan_line
 
 		$cur_info{$cur_pid}{parameters} .= " $line" if (!$error_only);
 
-	} elsif (exists $cur_plan_info{$cur_pid}) {
+	} elsif (exists $cur_plan_info{$cur_pid}{plan}) {
 
 		$cur_plan_info{$cur_pid}{plan} .= "\n" . $line;
 
@@ -3198,79 +3356,6 @@ sub store_current_timestamp
 	}
 }
 
-# Method used to check if the log file is produced by pgbouncer
-sub detect_pgbouncer_log
-{
-	my ($file, $saved_date, $look_at_beginning) = @_;
-
-	my ($lfile, $totalsize, $iscompressed) = &get_log_file($file);
-
-	# Compressed files do not allow seeking
-	if ($iscompressed) {
-		$look_at_beginning = 1;	
-	}
-
-	my ($gsec, $gmin, $ghour, $gmday, $gmon, $gyear, $gwday, $gyday, $gisdst) = localtime(time);
-	$gyear += 1900;
-	my $CURRENT_DATE = $gyear . sprintf("%02d", $gmon + 1) . sprintf("%02d", $gmday);
-
-	%prefix_vars = ();
-	my $startoffset = 0;
-	# If seeking is not explicitely disabled
-	if (!$look_at_beginning) {
-		# do not seek if filesize is smaller than the seek position
-		if ($saved_last_line{current_pos} < $totalsize) {
-			$lfile->seek($saved_last_line{current_pos} || 0, 0);
-			$startoffset = $saved_last_line{current_pos} || 0;
-		}
-	}
-
-	my $more_lines = 0;
-	my $ispgbouncerlog = 0;
-	while (my $line = <$lfile>) {
-
-		$more_lines++;
-
-		$line =~ s/\r//;
-
-		my @matches = ($line =~ $pgbouncer_log_format);
-		if ($#matches >= 0) {
-			$ispgbouncerlog++;
-			for (my $i = 0 ; $i <= $#pgb_prefix_params ; $i++) {
-				$prefix_vars{$pgb_prefix_params[$i]} = $matches[$i];
-			}
-		} else {
-			@matches = ($line =~ $pgbouncer_log_parse1);
-			if (($#matches >= 0) && ($matches[-1] =~ /^Stats:/) ) {
-				$ispgbouncerlog++;
-				for (my $i = 0 ; $i <= $#pgb_prefix_parse1 ; $i++) {
-					$prefix_vars{$pgb_prefix_params[$i]} = $matches[$i];
-				}
-			}
-		}
-		next if (!$prefix_vars{'t_timestamp'});
-		if ($iscompressed) {
-			close($lfile);
-			return ($ispgbouncerlog, 0, "log file is compressed start at offset 0");
-		# This file has already been parsed
-		} elsif ($saved_date gt $prefix_vars{'t_timestamp'}) {
-			close($lfile);
-			return ($ispgbouncerlog, 0, "timestamp $prefix_vars{'t_timestamp'} read at offset $startoffset is lower than saved timestamp: $saved_date");
-		} else {
-			last;
-		}
-	}
-	close($lfile);
-
-	if (!$more_lines) {
-		close($lfile);
-		return ($ispgbouncerlog, 0, "there no new lines in this file");
-	}
-
-	return ($ispgbouncerlog, 1, "reach the end of detect_pgbouncer_log() with start date: $saved_date and file size: $totalsize") ;
-}
-
-
 # Method used to check if the file stores logs after the last incremental position or not
 # This position should have been saved in the incremental file and read in the $last_parsed at
 # start up. Here we just verify that the first date in file is before the last incremental date.
@@ -3279,6 +3364,7 @@ sub check_file_changed
 	my ($file, $fmt, $saved_date, $saved_pos, $look_at_beginning) = @_;
 
 	my ($lfile, $totalsize, $iscompressed) = &get_log_file($file);
+	return if (!defined $lfile);
 
 	# Compressed files do not allow seeking
 	if ($iscompressed) {
@@ -3456,10 +3542,10 @@ sub check_incremental_position
 			$bpath =~ s/\-/\//g;
 
 			# Mark this directory as needing a reindex	
-			if (open(OUT, ">>$last_parsed.tmp")) {
-				flock(OUT, 2) || return 1;
-				print OUT "$incr_date\n";
-				close(OUT);
+			if (open(my $out, '>>' , "$last_parsed.tmp")) {
+				flock($out, 2) || return 1;
+				print $out "$incr_date\n";
+				close($out);
 			} else {
 				&logmsg('ERROR', "can't save last parsed line into $last_parsed.tmp, $!");
 			}
@@ -3516,9 +3602,20 @@ sub normalize_query
 	# Remove comments
 	$orig_query =~ s/\/\*(.*?)\*\///gs;
 
+	# Keep case on object name between doublequote
+	my %objnames = ();
+	my $i = 0;
+	while ($orig_query =~ s/("[^"]+")/%%OBJNAME$i%%/) {
+		$objnames{$i} = $1;
+		$i++;
+	}
 	# Set the entire query lowercase
 	$orig_query = lc($orig_query);
 
+	# Restore object name
+	while ($orig_query =~ s/\%\%objname(\d+)\%\%/$objnames{$1}/gs) {};
+	%objnames = ();
+
 	# Remove extra space, new line and tab characters by a single space
 	$orig_query =~ s/\s+/ /gs;
 
@@ -3532,17 +3629,17 @@ sub normalize_query
 
 	# Remove string content
 	$orig_query =~ s/\\'//gs;
-	$orig_query =~ s/'[^']*'/''/gs;
-	$orig_query =~ s/''('')+/''/gs;
+	$orig_query =~ s/'[^']*'/\?/gs;
+	$orig_query =~ s/\?(\?)+/\?/gs;
 
 	# Remove NULL parameters
-	$orig_query =~ s/=\s*NULL/=''/gs;
+	$orig_query =~ s/=\s*NULL/= \?/gs;
 
 	# Remove numbers
-	$orig_query =~ s/([^a-z0-9_\$\-])-?\d+/${1}0/gs;
+	$orig_query =~ s/([^a-z0-9_\$\-])-?\d+/$1\?/gs;
 
 	# Remove hexadecimal numbers
-	$orig_query =~ s/([^a-z_\$-])0x[0-9a-f]{1,10}/${1}0x/gs;
+	$orig_query =~ s/([^a-z_\$-])0x[0-9a-f]{1,10}/$1\?/gs;
 
 	# Remove bind parameters
 	$orig_query =~ s/\$\d+/\?/gs;
@@ -3551,7 +3648,12 @@ sub normalize_query
 	$orig_query =~ s/\bin\s*\([\'0x,\s\?]*\)/in (...)/gs;
 
 	# Remove curor names in CURSOR and IN clauses
-	$orig_query =~ s/\b(declare|in)\s+"[^"]+"/$1 "..."/gs;
+	$orig_query =~ s/\b(declare|in|deallocate|close)\s+"[^"]+"/$1 "..."/gs;
+
+	# Normalise cursor name
+	$orig_query =~ s/\bdeclare\s+[^"\s]+\s+cursor/declare "..." cursor/gs;
+	$orig_query =~ s/\b(fetch\s+next\s+from)\s+[^\s]+/$1 "..."/gs;
+	$orig_query =~ s/\b(deallocate|close)\s+[^"\s]+/$1 "..."/gs;
 
 	return $orig_query;
 }
@@ -3817,6 +3919,27 @@ sub pgb_set_top_error_sample
 	}
 }
 
+sub get_log_limit
+{
+	$overall_stat{'first_log_ts'} =~ /^(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/;
+	my ($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s);
+	if (!$log_timezone) {
+		($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s) = ($1, $2, $3, $4, $5, $6);
+	} else {
+		($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s) = change_timezone($1, $2, $3, $4, $5, $6);
+	}
+	my $t_log_min = "$t_y-$t_mo-$t_d $t_h:$t_mi:$t_s";
+	$overall_stat{'last_log_ts'} =~ /^(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/;
+	if (!$log_timezone) {
+		($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s) = ($1, $2, $3, $4, $5, $6);
+	} else {
+		($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s) = change_timezone($1, $2, $3, $4, $5, $6);
+	}
+	my $t_log_max = "$t_y-$t_mo-$t_d $t_h:$t_mi:$t_s";
+
+	return ($t_log_min, $t_log_max);
+}
+
 sub dump_as_text
 {
 
@@ -3830,6 +3953,8 @@ sub dump_as_text
 	if ($#log_files > 0) {
 		$logfile_str .= ', ..., ' . $log_files[-1];
 	}
+	# Set logs limits
+	my ($t_log_min, $t_log_max) = get_log_limit();
 	print $fh qq{
 pgBadger :: $report_title
 
@@ -3838,7 +3963,7 @@ pgBadger :: $report_title
 Generated on $curdate
 Log file: $logfile_str
 Parsed $fmt_nlines log entries in $total_time
-Log start from $overall_stat{'first_log_ts'} to $overall_stat{'last_log_ts'}
+Log start from $t_log_min to $t_log_max
 
 };
 
@@ -4127,7 +4252,8 @@ Report not supported by text format
 			foreach my $d (sort {$b <=> $a} keys %{$normalyzed_info{$k}{samples}}) {
 				last if ($j > $sample);
 				my $ttl = $top_locked_info[$i]->[1] || '';
-				my $db = " - $normalyzed_info{$k}{samples}{$d}{date} - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
+				my $db = '';
+				$db .= " - $normalyzed_info{$k}{samples}{$d}{date} - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
 				$db .= ", user: $normalyzed_info{$k}{samples}{$d}{user}" if ($normalyzed_info{$k}{samples}{$d}{user});
 				$db .= ", remote: $normalyzed_info{$k}{samples}{$d}{remote}" if ($normalyzed_info{$k}{samples}{$d}{remote});
 				$db .= ", app: $normalyzed_info{$k}{samples}{$d}{app}" if ($normalyzed_info{$k}{samples}{$d}{app});
@@ -4146,7 +4272,8 @@ Report not supported by text format
 		print $fh "Rank   Wait time (s)    Query\n";
 		for (my $i = 0 ; $i <= $#top_locked_info ; $i++) {
 			my $ttl = $top_locked_info[$i]->[1] || '';
-			my $db = " - database: $top_locked_info[$i]->[3]" if ($top_locked_info[$i]->[3]);
+			my $db = '';
+			$db .= " - database: $top_locked_info[$i]->[3]" if ($top_locked_info[$i]->[3]);
 			$db .= ", user: $top_locked_info[$i]->[4]" if ($top_locked_info[$i]->[4]);
 			$db .= ", remote: $top_locked_info[$i]->[5]" if ($top_locked_info[$i]->[5]);
 			$db .= ", app: $top_locked_info[$i]->[6]" if ($top_locked_info[$i]->[6]);
@@ -4188,7 +4315,8 @@ Report not supported by text format
 				my $j = 1;
 				foreach my $d (sort {$b <=> $a} keys %{$normalyzed_info{$k}{samples}}) {
 					last if ($j > $sample);
-					my $db = "$normalyzed_info{$k}{samples}{$d}{date} - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
+					my $db = '';
+					$db .= "$normalyzed_info{$k}{samples}{$d}{date} - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
 					$db .= ", user: $normalyzed_info{$k}{samples}{$d}{user}" if ($normalyzed_info{$k}{samples}{$d}{user});
 					$db .= ", remote: $normalyzed_info{$k}{samples}{$d}{remote}" if ($normalyzed_info{$k}{samples}{$d}{remote});
 					$db .= ", app: $normalyzed_info{$k}{samples}{$d}{app}" if ($normalyzed_info{$k}{samples}{$d}{app});
@@ -4209,7 +4337,8 @@ Report not supported by text format
 		print $fh "Rank   Size    Query\n";
 		for (my $i = 0 ; $i <= $#top_tempfile_info ; $i++) {
 			my $ttl = $top_tempfile_info[$i]->[1] || '';
-			my $db = " - database: $top_tempfile_info[$i]->[3]" if ($top_tempfile_info[$i]->[3]);
+			my $db = '';
+			$db .= " - database: $top_tempfile_info[$i]->[3]" if ($top_tempfile_info[$i]->[3]);
 			$db .= ", user: $top_tempfile_info[$i]->[4]" if ($top_tempfile_info[$i]->[4]);
 			$db .= ", remote: $top_tempfile_info[$i]->[5]" if ($top_tempfile_info[$i]->[5]);
 			$db .= ", app: $top_tempfile_info[$i]->[6]" if ($top_tempfile_info[$i]->[6]);
@@ -4245,7 +4374,8 @@ Report not supported by text format
 				my $j = 1;
 				foreach my $d (sort {$b <=> $a} keys %{$normalyzed_info{$k}{samples}}) {
 					last if ($j > $sample);
-					my $db = "$normalyzed_info{$k}{samples}{$d}{date} - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
+					my $db = '';
+					$db .= "$normalyzed_info{$k}{samples}{$d}{date} - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
 					$db .= ", user: $normalyzed_info{$k}{samples}{$d}{user}" if ($normalyzed_info{$k}{samples}{$d}{user});
 					$db .= ", remote: $normalyzed_info{$k}{samples}{$d}{remote}" if ($normalyzed_info{$k}{samples}{$d}{remote});
 					$db .= ", app: $normalyzed_info{$k}{samples}{$d}{app}" if ($normalyzed_info{$k}{samples}{$d}{app});
@@ -4266,7 +4396,8 @@ Report not supported by text format
 		print $fh "Rank   Times cancelled    Query\n";
 		for (my $i = 0 ; $i <= $#top_cancelled_info ; $i++) {
 			my $ttl = $top_cancelled_info[$i]->[1] || '';
-			my $db = " - database: $top_cancelled_info[$i]->[3]" if ($top_cancelled_info[$i]->[3]);
+			my $db = '';
+			$db .= " - database: $top_cancelled_info[$i]->[3]" if ($top_cancelled_info[$i]->[3]);
 			$db .= ", user: $top_cancelled_info[$i]->[4]" if ($top_cancelled_info[$i]->[4]);
 			$db .= ", remote: $top_cancelled_info[$i]->[5]" if ($top_cancelled_info[$i]->[5]);
 			$db .= ", app: $top_cancelled_info[$i]->[6]" if ($top_cancelled_info[$i]->[6]);
@@ -4282,7 +4413,8 @@ Report not supported by text format
 		print $fh "\n- Slowest queries ------------------------------------------------------\n\n";
 		print $fh "Rank     Duration (s)     Query\n";
 		for (my $i = 0 ; $i <= $#top_slowest ; $i++) {
-			my $db = " database: $top_slowest[$i]->[3]" if ($top_slowest[$i]->[3]);
+			my $db = '';
+			$db .= " database: $top_slowest[$i]->[3]" if ($top_slowest[$i]->[3]);
 			$db .= ", user: $top_slowest[$i]->[4]" if ($top_slowest[$i]->[4]);
 			$db .= ", remote: $top_slowest[$i]->[5]" if ($top_slowest[$i]->[5]);
 			$db .= ", app: $top_slowest[$i]->[6]" if ($top_slowest[$i]->[6]);
@@ -4317,7 +4449,8 @@ Report not supported by text format
 			my $j = 1;
 			foreach my $d (sort {$b <=> $a} keys %{$normalyzed_info{$k}{samples}}) {
 				last if ($j > $sample);
-				my $db = " - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
+				my $db = '';
+				$db .= " - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
 				$db .= ", user: $normalyzed_info{$k}{samples}{$d}{user}" if ($normalyzed_info{$k}{samples}{$d}{user});
 				$db .= ", remote: $normalyzed_info{$k}{samples}{$d}{remote}" if ($normalyzed_info{$k}{samples}{$d}{remote});
 				$db .= ", app: $normalyzed_info{$k}{samples}{$d}{app}" if ($normalyzed_info{$k}{samples}{$d}{app});
@@ -4355,7 +4488,8 @@ Report not supported by text format
 			my $i = 1;
 			foreach my $d (sort {$b <=> $a} keys %{$normalyzed_info{$k}{samples}}) {
 				last if ($i > $sample);
-				my $db = " - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
+				my $db = '';
+				$db .= " - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
 				$db .= ", user: $normalyzed_info{$k}{samples}{$d}{user}" if ($normalyzed_info{$k}{samples}{$d}{user});
 				$db .= ", remote: $normalyzed_info{$k}{samples}{$d}{remote}" if ($normalyzed_info{$k}{samples}{$d}{remote});
 				$db .= ", app: $normalyzed_info{$k}{samples}{$d}{app}" if ($normalyzed_info{$k}{samples}{$d}{app});
@@ -4393,7 +4527,8 @@ Report not supported by text format
 			my $i = 1;
 			foreach my $d (sort {$b <=> $a} keys %{$normalyzed_info{$k}{samples}}) {
 				last if ($i > $sample);
-				my $db = " - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
+				my $db = '';
+				$db .= " - database: $normalyzed_info{$k}{samples}{$d}{db}" if ($normalyzed_info{$k}{samples}{$d}{db});
 				$db .= ", user: $normalyzed_info{$k}{samples}{$d}{user}" if ($normalyzed_info{$k}{samples}{$d}{user});
 				$db .= ", remote: $normalyzed_info{$k}{samples}{$d}{remote}" if ($normalyzed_info{$k}{samples}{$d}{remote});
 				$db .= ", app: $normalyzed_info{$k}{samples}{$d}{app}" if ($normalyzed_info{$k}{samples}{$d}{app});
@@ -4509,6 +4644,8 @@ sub dump_error_as_text
 	}
 	$report_title ||= 'PostgreSQL Log Analyzer';
 
+	# Set logs limits
+	my ($t_log_min, $t_log_max) = get_log_limit();
 	print $fh qq{
 pgBadger :: $report_title
 
@@ -4517,7 +4654,7 @@ pgBadger :: $report_title
 Generated on $curdate
 Log file: $logfile_str
 Parsed $fmt_nlines log entries in $total_time
-Log start from $overall_stat{'first_log_ts'} to $overall_stat{'last_log_ts'}
+Log start from $t_log_min to $t_log_max
 };
 
 	&show_error_as_text();
@@ -4699,7 +4836,9 @@ sub html_header
 	my $global_info = &print_global_information();
 
 	my @tmpjscode = @jscode;
-	map { s/EDIT_URI/$uri/; } @tmpjscode;
+	for (my $i = 0; $i <= $#tmpjscode; $i++) {
+		$tmpjscode[$i] =~ s/EDIT_URI/\./;
+	}
 
 	my $local_title = 'PostgreSQL Log Analyzer';
 	if ($report_title) {
@@ -4884,7 +5023,8 @@ sub html_header
 		}
 	}
 	if (!$disable_error && !$pgbouncer_only) {
-		my $sqlstate_report = '<li><a href="#error-code">Error class distribution</a></li>' if (scalar keys %errors_code > 0);
+		my $sqlstate_report = '';
+		$sqlstate_report = '<li><a href="#error-code">Error class distribution</a></li>' if (scalar keys %errors_code > 0);
 		print $fh qq{
      		<li id="menu-events" class="dropdown"><a class="dropdown-toggle" data-toggle="dropdown" href="#">Events <span class="caret"></span></a>
      			<ul class="dropdown-menu">
@@ -5026,12 +5166,15 @@ sub print_global_information
 	if ($#log_files > 0) {
 		$logfile_str .= ', ..., ' . $log_files[-1];
 	}
+
+	# Set logs limits
+	my ($t_log_min, $t_log_max) = get_log_limit();
 	return qq{
 <ul>
 <li>Generated on $curdate</li>
 <li>Log file: $logfile_str</li>
 <li>Parsed $fmt_nlines log entries in $total_time</li>
-<li>Log start from $overall_stat{'first_log_ts'} to $overall_stat{'last_log_ts'}</li>
+<li>Log start from $t_log_min to $t_log_max</li>
 </ul>
 };
 
@@ -5883,7 +6026,7 @@ sub compute_query_graphs
 	);
 
 	$drawn_graphs{'sessionspersecond_graph'} = &jqplot_linegraph( $graphid++, 'sessionspersecond_graph', $graph_data{sess_max},
-		$graph_data{sess_avg}, $graph_data{sess_min}, 'Number of sessions (' . $avg_minutes . ' minutes average)',
+		$graph_data{sess_avg}, $graph_data{sess_min}, 'Number of sessions/second (' . $avg_minutes . ' minutes average)',
 		'Sessions', 'Maximum', 'Average', 'Minimum'
 	);
 
@@ -6024,7 +6167,7 @@ sub compute_pgbouncer_graphs
 	);
 
 	$drawn_graphs{'pgb_sessionspersecond_graph'} = &jqplot_linegraph( $graphid++, 'pgb_sessionspersecond_graph', $graph_data{sess_max},
-		$graph_data{sess_avg}, $graph_data{sess_min}, 'Number of sessions (' . $avg_minutes . ' minutes average)',
+		$graph_data{sess_avg}, $graph_data{sess_min}, 'Number of sessions/second (' . $avg_minutes . ' minutes average)',
 		'Sessions', 'Maximum', 'Average', 'Minimum'
 	);
 
@@ -7700,9 +7843,9 @@ sub print_temporary_file
 					if ($tempfile_info{count}) {
 						$t_dataavg{size}{"$rd"} = 0 if (!exists $t_dataavg{size}{"$rd"});
 						$t_dataavg{count}{"$rd"} = 0 if (!exists $t_dataavg{count}{"$rd"});
-						if (exists $per_minute_info{$tm}{$h}{$m}{tempfile}) {
-							$t_dataavg{size}{"$rd"} += ($per_minute_info{$tm}{$h}{$m}{tempfile}{size} || 0);
-							$t_dataavg{count}{"$rd"} += ($per_minute_info{$tm}{$h}{$m}{tempfile}{count} || 0);
+						if (exists $per_minute_info{$tm}{$h}{$m}{'tempfile'}) {
+							$t_dataavg{size}{"$rd"} += ($per_minute_info{$tm}{$h}{$m}{'tempfile'}{size} || 0);
+							$t_dataavg{count}{"$rd"} += ($per_minute_info{$tm}{$h}{$m}{'tempfile'}{count} || 0);
 						}
 					}
 				}
@@ -7801,9 +7944,9 @@ $drawn_graphs{temporaryfile_graph}
 			$zday = "";
 			my %tinf = ();
 			foreach my $m (keys %{$per_minute_info{$d}{$h}}) {
-				if (exists $per_minute_info{$d}{$h}{$m}{tempfile}) {
-					$tinf{size} += $per_minute_info{$d}{$h}{$m}{tempfile}{size};
-					$tinf{count} += $per_minute_info{$d}{$h}{$m}{tempfile}{count};
+				if (exists $per_minute_info{$d}{$h}{$m}{'tempfile'}) {
+					$tinf{size} += $per_minute_info{$d}{$h}{$m}{'tempfile'}{size};
+					$tinf{count} += $per_minute_info{$d}{$h}{$m}{'tempfile'}{count};
 				}
 			}
 			if (scalar keys %tinf) {
@@ -7812,7 +7955,7 @@ $drawn_graphs{temporaryfile_graph}
 							"</td><td>" . &pretty_print_size($tinf{size}) . "</td>" .
 							"</td><td>$temp_average</td>";
 			} else {
-				$tempfiles_activity .= "<td>0</td><td>0</td>";
+				$tempfiles_activity .= "<td>0</td><td>0</td><td>0</td>";
 			}
 		}
 	}
@@ -9093,6 +9236,19 @@ sub print_query_per_host
 
 }
 
+sub display_plan
+{
+	my ($id, $plan) = @_;
+
+	my $url = $EXPLAIN_URL . url_escape($plan);
+
+	# Only TEXT format plan can be sent to Depesz site.
+	if ($plan !~ /Node Type:|"Node Type":|Node-Type/s) {
+		return "<div id=\"$id\" class=\"sql sql-largesize\"><a href=\"$url\" target=\"explain\" title=\"Click to beautify Explain Plan\"><i class=\"glyphicon icon-compass\"></i><b>Explain plan</b></a></div>\n<div style=\"width:900px;overflow:auto\">\n<pre>" . $plan . "</pre>\n</div>\n";
+	} else {
+		return "<div id=\"$id\" class=\"sql sql-largesize\"><i class=\"glyphicon icon-compass\"></i><b>Explain plan</b></div>\n<div style=\"width:900px;overflow:auto\">\n<pre>" . $plan . "</pre>\n</div>\n";
+	}
+}
 
 sub print_lock_queries_report
 {
@@ -9169,8 +9325,7 @@ sub print_lock_queries_report
 				$details .= "<b>Bind query:</b> yes\n" if ($normalyzed_info{$k}{samples}{$d}{bind});
 				my $explain = '';
 				if ($normalyzed_info{$k}{samples}{$d}{plan}) {
-					my $url = $EXPLAIN_URL . url_escape($normalyzed_info{$k}{samples}{$d}{plan});
-					$explain = "<div id=\"query-a-explain-$rank\" class=\"sql sql-largesize\"><a href=\"$url\" target=\"explain\" title=\"Click to beautify Explain Plan\"><i class=\"glyphicon icon-compass\"></i><b>Explain plan</b></a></div>\n<pre>" . $normalyzed_info{$k}{samples}{$d}{plan} . "</pre>\n";
+					$explain = &display_plan("query-a-explain-$rank", $normalyzed_info{$k}{samples}{$d}{plan});
 				}
 				print $fh qq{
 					<dt>
@@ -9670,8 +9825,7 @@ sub print_slowest_individual_queries
 		$details .= " ]";
 		my $explain = '';
 		if ($top_slowest[$i]->[8]) {
-			my $url = $EXPLAIN_URL . url_escape($top_slowest[$i]->[8]);
-			$explain = "<div id=\"query-d-explain-$rank-$idx\" class=\"sql sql-largesize\"><a href=\"$url\" target=\"explain\" title=\"Click to beautify Explain Plan\"><i class=\"glyphicon icon-compass\"></i><b>Explain plan</b></a></div>\n<pre>" . $top_slowest[$i]->[8] . "</pre>\n";
+			$explain = &display_plan("query-d-explain-$rank-$idx", $top_slowest[$i]->[8]);
 		}
 		my $query = &highlight_code($top_slowest[$i]->[2]);
 		my $md5 = '';
@@ -9745,26 +9899,32 @@ sub print_time_consuming
 			$d =~ /^(\d{4})(\d{2})(\d{2})$/;
 			$days++;
 			my $zday = "$abbr_month{$2} $3";
+			my $dd = $3;
+			my $mo = $2 -1 ;
+			my $y = $1 - 1900;
 			foreach my $h (sort keys %{$normalyzed_info{$k}{chronos}{$d}}) {
+				my $t = timegm_nocheck(0, 0, $h, $dd, $mo, $y);
+				$t += $timezone;
+				my $ht = sprintf("%02d", (localtime($t))[2]);
 				$normalyzed_info{$k}{chronos}{$d}{$h}{average} =
 					$normalyzed_info{$k}{chronos}{$d}{$h}{duration} / ($normalyzed_info{$k}{chronos}{$d}{$h}{count} || 1);
-				$details .= "<tr><td>$zday</td><td>$h</td><td>" .
+				$details .= "<tr><td>$zday</td><td>$ht</td><td>" .
 					&comma_numbers($normalyzed_info{$k}{chronos}{$d}{$h}{count}) .   "</td><td>" .
 					&convert_time($normalyzed_info{$k}{chronos}{$d}{$h}{duration}) . "</td><td>" .
 					&convert_time($normalyzed_info{$k}{chronos}{$d}{$h}{average}) .  "</td></tr>";
 				$zday = "";
 				foreach my $m (sort keys %{$normalyzed_info{$k}{chronos}{$d}{$h}{min}}) {
 					my $rd = &average_per_minutes($m, $histo_avg_minutes);
-					$hourly_count{"$h:$rd"} += $normalyzed_info{$k}{chronos}{$d}{$h}{min}{$m};
-					$hourly_duration{"$h:$rd"} += ($normalyzed_info{$k}{chronos}{$d}{$h}{min_duration}{$m} || 0);
+					$hourly_count{"$ht:$rd"} += $normalyzed_info{$k}{chronos}{$d}{$h}{min}{$m};
+					$hourly_duration{"$ht:$rd"} += ($normalyzed_info{$k}{chronos}{$d}{$h}{min_duration}{$m} || 0);
 				}
 				if ($#histo_avgs > 0) {
 					foreach my $rd (@histo_avgs) {
-						next if (!exists $hourly_count{"$h:$rd"});
-						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$h:$rd</td><td>" .
-							&comma_numbers($hourly_count{"$h:$rd"}) .   "</td><td>" .
-							&convert_time($hourly_duration{"$h:$rd"}) . "</td><td>" .
-							&convert_time($hourly_duration{"$h:$rd"}/($hourly_count{"$h:$rd"}||1)) .  "</td></tr>";
+						next if (!exists $hourly_count{"$ht:$rd"});
+						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$ht:$rd</td><td>" .
+							&comma_numbers($hourly_count{"$ht:$rd"}) .   "</td><td>" .
+							&convert_time($hourly_duration{"$ht:$rd"}) . "</td><td>" .
+							&convert_time($hourly_duration{"$ht:$rd"}/($hourly_count{"$ht:$rd"}||1)) .  "</td></tr>";
 					}
 				}
 			}
@@ -9898,8 +10058,7 @@ sub print_time_consuming
 			$details .= "<b>Bind query:</b> yes\n" if ($normalyzed_info{$k}{samples}{$d}{bind});
 			my $explain = '';
 			if ($normalyzed_info{$k}{samples}{$d}{plan}) {
-				my $url = $EXPLAIN_URL . url_escape($normalyzed_info{$k}{samples}{$d}{plan});
-				$explain = "<div id=\"query-e-explain-$rank-$idx\" class=\"sql sql-largesize\"><a href=\"$url\" target=\"explain\" title=\"Click to beautify Explain Plan\"><i class=\"glyphicon icon-compass\"></i><b>Explain plan</b></a></div>\n<pre>" . $normalyzed_info{$k}{samples}{$d}{plan} . "</pre>\n";
+				$explain = &display_plan("query-e-explain-$rank-$idx", $normalyzed_info{$k}{samples}{$d}{plan});
 			}
 			$query = &highlight_code($normalyzed_info{$k}{samples}{$d}{query});
 			my $md5 = '';
@@ -9973,29 +10132,35 @@ sub print_most_frequent
 		my $days = 0;
                 my $details = '';
 		foreach my $d (sort keys %{$normalyzed_info{$k}{chronos}}) {
-			$d =~ /^\d{4}(\d{2})(\d{2})$/;
+			$d =~ /^(\d{4})(\d{2})(\d{2})$/;
 			$days++;
-			my $zday = "$abbr_month{$1} $2";
+			my $zday = "$abbr_month{$2} $3";
+			my $dd = $3;
+			my $mo = $2 - 1;
+			my $y = $1 - 1900;
 			foreach my $h (sort keys %{$normalyzed_info{$k}{chronos}{$d}}) {
+				my $t = timegm_nocheck(0, 0, $h, $dd, $mo, $y);
+				$t += $timezone;
+				my $ht = sprintf("%02d", (localtime($t))[2]);
 				$normalyzed_info{$k}{chronos}{$d}{$h}{average} =
 					$normalyzed_info{$k}{chronos}{$d}{$h}{duration} / $normalyzed_info{$k}{chronos}{$d}{$h}{count};
-				$details .= "<tr><td>$zday</td><td>$h</td><td>" .
+				$details .= "<tr><td>$zday</td><td>$ht</td><td>" .
 					&comma_numbers($normalyzed_info{$k}{chronos}{$d}{$h}{count}) .   "</td><td>" .
 					&convert_time($normalyzed_info{$k}{chronos}{$d}{$h}{duration}) . "</td><td>" .
 					&convert_time($normalyzed_info{$k}{chronos}{$d}{$h}{average}) .  "</td></tr>";
 				$zday = "";
 				foreach my $m (sort keys %{$normalyzed_info{$k}{chronos}{$d}{$h}{min}}) {
 					my $rd = &average_per_minutes($m, $histo_avg_minutes);
-					$hourly_count{"$h:$rd"} += $normalyzed_info{$k}{chronos}{$d}{$h}{min}{$m};
-					$hourly_duration{"$h:$rd"} += ($normalyzed_info{$k}{chronos}{$d}{$h}{min_duration}{$m} || 0);
+					$hourly_count{"$ht:$rd"} += $normalyzed_info{$k}{chronos}{$d}{$h}{min}{$m};
+					$hourly_duration{"$ht:$rd"} += ($normalyzed_info{$k}{chronos}{$d}{$h}{min_duration}{$m} || 0);
 				}
 				if ($#histo_avgs > 0) {
 					foreach my $rd (@histo_avgs) {
-						next if (!exists $hourly_count{"$h:$rd"});
-						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$h:$rd</td><td>" .
-							&comma_numbers($hourly_count{"$h:$rd"}) .   "</td><td>" .
-							&convert_time($hourly_duration{"$h:$rd"}) . "</td><td>" .
-							&convert_time($hourly_duration{"$h:$rd"}/($hourly_count{"$h:$rd"}||1)) .  "</td></tr>";
+						next if (!exists $hourly_count{"$ht:$rd"});
+						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$ht:$rd</td><td>" .
+							&comma_numbers($hourly_count{"$ht:$rd"}) .   "</td><td>" .
+							&convert_time($hourly_duration{"$ht:$rd"}) . "</td><td>" .
+							&convert_time($hourly_duration{"$ht:$rd"}/($hourly_count{"$ht:$rd"}||1)) .  "</td></tr>";
 					}
 				}
 			}
@@ -10130,8 +10295,7 @@ sub print_most_frequent
 			$details .= "<b>Bind query:</b> yes\n" if ($normalyzed_info{$k}{samples}{$d}{bind});
 			my $explain = '';
 			if ($normalyzed_info{$k}{samples}{$d}{plan}) {
-				my $url = $EXPLAIN_URL . url_escape($normalyzed_info{$k}{samples}{$d}{plan});
-				$explain = "<div id=\"query-f-explain-$rank-$idx\" class=\"sql sql-largesize\"><a href=\"$url\" target=\"explain\" title=\"Click to beautify Explain Plan\"><i class=\"glyphicon icon-compass\"></i><b>Explain plan</b></a></div>\n<pre>" . $normalyzed_info{$k}{samples}{$d}{plan} . "</pre>";
+				$explain = &display_plan("query-f-explain-$rank-$idx", $normalyzed_info{$k}{samples}{$d}{plan});
 			}
 			$query = &highlight_code($normalyzed_info{$k}{samples}{$d}{query});
 			my $md5 = '';
@@ -10167,7 +10331,6 @@ sub print_most_frequent
 
 }
 
-
 sub print_slowest_queries
 {
 	print $fh qq{
@@ -10209,29 +10372,35 @@ sub print_slowest_queries
 		my $days = 0;
 		foreach my $d (sort keys %{$normalyzed_info{$k}{chronos}}) {
 			my $c = 1;
-			$d =~ /^\d{4}(\d{2})(\d{2})$/;
+			$d =~ /^(\d{4})(\d{2})(\d{2})$/;
 			$days++;
-			my $zday = "$abbr_month{$1} $2";
+			my $zday = "$abbr_month{$2} $3";
+			my $dd = $3;
+			my $mo = $2 - 1;
+			my $y = $1 - 1900;
 			foreach my $h (sort keys %{$normalyzed_info{$k}{chronos}{$d}}) {
+				my $t = timegm_nocheck(0, 0, $h, $dd, $mo, $y);
+				$t += $timezone;
+				my $ht = sprintf("%02d", (localtime($t))[2]);
 				$normalyzed_info{$k}{chronos}{$d}{$h}{average} =
 					$normalyzed_info{$k}{chronos}{$d}{$h}{duration} / $normalyzed_info{$k}{chronos}{$d}{$h}{count};
-				$details .= "<tr><td>$zday</td><td>$h</td><td>" .
+				$details .= "<tr><td>$zday</td><td>$ht</td><td>" .
 					&comma_numbers($normalyzed_info{$k}{chronos}{$d}{$h}{count}) .   "</td><td>" .
 					&convert_time($normalyzed_info{$k}{chronos}{$d}{$h}{duration}) . "</td><td>" .
 					&convert_time($normalyzed_info{$k}{chronos}{$d}{$h}{average}) .  "</td></tr>";
 				$zday = "";
 				foreach my $m (sort keys %{$normalyzed_info{$k}{chronos}{$d}{$h}{min}}) {
 					my $rd = &average_per_minutes($m, $histo_avg_minutes);
-					$hourly_count{"$h:$rd"} += $normalyzed_info{$k}{chronos}{$d}{$h}{min}{$m};
-					$hourly_duration{"$h:$rd"} += ($normalyzed_info{$k}{chronos}{$d}{$h}{min_duration}{$m} || 0);
+					$hourly_count{"$ht:$rd"} += $normalyzed_info{$k}{chronos}{$d}{$h}{min}{$m};
+					$hourly_duration{"$ht:$rd"} += ($normalyzed_info{$k}{chronos}{$d}{$h}{min_duration}{$m} || 0);
 				}
 				if ($#histo_avgs > 0) {
 					foreach my $rd (@histo_avgs) {
-						next if (!exists $hourly_count{"$h:$rd"});
-						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$h:$rd</td><td>" .
-							&comma_numbers($hourly_count{"$h:$rd"}) .   "</td><td>" .
-							&convert_time($hourly_duration{"$h:$rd"}) . "</td><td>" .
-							&convert_time($hourly_duration{"$h:$rd"}/($hourly_count{"$h:$rd"}||1)) .  "</td></tr>";
+						next if (!exists $hourly_count{"$ht:$rd"});
+						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$ht:$rd</td><td>" .
+							&comma_numbers($hourly_count{"$ht:$rd"}) .   "</td><td>" .
+							&convert_time($hourly_duration{"$ht:$rd"}) . "</td><td>" .
+							&convert_time($hourly_duration{"$ht:$rd"}/($hourly_count{"$ht:$rd"}||1)) .  "</td></tr>";
 					}
 				}
 			}
@@ -10366,8 +10535,7 @@ sub print_slowest_queries
 			$details .= "<b>Bind query:</b> yes\n" if ($normalyzed_info{$k}{samples}{$d}{bind});
 			my $explain = '';
 			if ($normalyzed_info{$k}{samples}{$d}{plan}) {
-				my $url = $EXPLAIN_URL . url_escape($normalyzed_info{$k}{samples}{$d}{plan});
-				$explain = "<div id=\"query-g-explain-$rank-$idx\" class=\"sql sql-largesize\"><a href=\"$url\" target=\"explain\" title=\"Click to beautify Explain Plan\"><i class=\"glyphicon icon-compass\"></i><b>Explain plan</b></a></div>\n<pre>" . $normalyzed_info{$k}{samples}{$d}{plan} . "</pre>\n";
+				$explain = &display_plan("query-g-explain-$rank-$idx", $normalyzed_info{$k}{samples}{$d}{plan});
 			}
 			$query = &highlight_code($normalyzed_info{$k}{samples}{$d}{query});
 			my $md5 = '';
@@ -10411,6 +10579,30 @@ sub dump_as_html
 	# Dump the html header
 	&html_header($uri);
 
+	# Set graphs limits
+	if ($overall_stat{'first_log_ts'} =~ /^(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/) {
+		my ($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s);
+		if (!$log_timezone) {
+			($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s) = ($1, $2, $3, $4, $5, $6);
+		} else {
+			($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s) = change_timezone($1, $2, $3, $4, $5, $6);
+		}
+		$t_min = timegm_nocheck(0, $t_mi, $t_h, $t_d, $t_mo - 1, $t_y) * 1000;
+		$t_min += ($timezone*1000);
+		$t_min -= ($avg_minutes * 60000);
+	}
+	if ($overall_stat{'last_log_ts'} =~ /^(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/) {
+		my ($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s);
+		if (!$log_timezone) {
+			($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s) = ($1, $2, $3, $4, $5, $6);
+		} else {
+			($t_y, $t_mo, $t_d, $t_h, $t_mi, $t_s) = change_timezone($1, $2, $3, $4, $5, $6);
+		}
+		$t_max = timegm_nocheck(59, $t_mi, $t_h, $t_d, $t_mo - 1, $t_y) * 1000;
+		$t_max += ($timezone*1000);
+		$t_max += ($avg_minutes * 60000);
+	}
+
 	if (!$error_only) {
 
 		if (!$pgbouncer_only) {
@@ -10419,18 +10611,7 @@ sub dump_as_html
 	<li class="slide active-slide" id="overview-slide">
 };
 			&print_overall_statistics();
-
 		}
-		# Set graphs limits
-		$overall_stat{'first_log_ts'} =~ /^(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/;
-		$t_min = timegm_nocheck(0, $5, $4, $3, $2 - 1, $1) * 1000;
-		$t_min += ($timezone*1000);
-		$t_min -= ($avg_minutes * 60000);
-
-		$overall_stat{'last_log_ts'} =~ /^(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/;
-		$t_max = timegm_nocheck(59, $5, $4, $3, $2 - 1, $1) * 1000;
-		$t_max += ($timezone*1000);
-		$t_max += ($avg_minutes * 60000);
 
 		if (!$disable_hourly && !$pgbouncer_only) {
 
@@ -10678,9 +10859,8 @@ sub escape_html
 	return $_[0];
 }
 
-sub print_log_level
+sub restore_log_type_count
 {
-	my %infos = ();
 	my $ret = 0;
 
 	# Some messages have seen their log level change during log parsing.
@@ -10703,6 +10883,11 @@ sub print_log_level
 			}
 		}
 	}
+}
+
+sub print_log_level
+{
+	my %infos = ();
 
 	# Show log types
 	my $total_logs = 0;
@@ -10736,45 +10921,48 @@ sub print_log_level
 		foreach my $l (qw(FATAL WARNING ERROR PANIC)) {
 			$max_events{$l} = 0;
 		}
+		my %e_dataavg = ();
 		foreach my $tm (sort {$a <=> $b} keys %per_minute_info) {
-			$tm =~ /(\d{4})(\d{2})(\d{2})/;
-			my $y  = $1 - 1900;
-			my $mo = $2 - 1;
-			my $d  = $3;
 			foreach my $h ("00" .. "23") {
 				next if (!exists $per_minute_info{$tm}{$h});
-				my %e_dataavg = ();
 				foreach my $m ("00" .. "59") {
 					next if (!exists $per_minute_info{$tm}{$h}{$m});
 
-					my $rd = &average_per_minutes($m, $avg_minutes);
-
 					if (exists $per_minute_info{$tm}{$h}{$m}{log_level}) {
 
+						my $rd = &average_per_minutes($m, $avg_minutes);
+
 						# Average per minute
 						foreach my $l (qw(FATAL WARNING ERROR PANIC)) {
-							$e_dataavg{$l}{"$rd"} += ($per_minute_info{$tm}{$h}{$m}{log_level}{$l} || 0);
+							$e_dataavg{$l}{$tm}{$h}{"$rd"} += ($per_minute_info{$tm}{$h}{$m}{log_level}{$l} || 0);
 							$max_events{$l} += ($per_minute_info{$tm}{$h}{$m}{log_level}{$l} || 0);
 						}
 						delete $per_minute_info{$tm}{$h}{$m}{log_level};
 					}
 				}
+			}
+		}
 
-				foreach my $rd (@avgs) {
-					my $t = timegm_nocheck(0, $rd, $h, $d, $mo, $y) * 1000;
-					$t += ($timezone*1000);
+		foreach my $l (qw(FATAL ERROR PANIC WARNING)) {
+			foreach my $tm (sort {$a <=> $b} keys %{$e_dataavg{$l}}) {
+				$tm =~ /(\d{4})(\d{2})(\d{2})/;
+				my $y  = $1 - 1900;
+				my $mo = $2 - 1;
+				my $d  = $3;
+				foreach my $h ("00" .. "23") {
+					foreach my $rd (@avgs) {
+						my $t = timegm_nocheck(0, $rd, $h, $d, $mo, $y) * 1000;
+						$t += ($timezone*1000);
 
-					next if ($t < $t_min);
-					last if ($t > $t_max);
+						next if ($t < $t_min);
+						last if ($t > $t_max);
 
-					if (scalar keys %e_dataavg> 0) {
-						foreach my $l (qw(FATAL ERROR PANIC WARNING)) {
-							$graph_data{$l} .= "[$t, " . ($e_dataavg{$l}{"$rd"} || 0) . "],";
-						}
+						$graph_data{$l} .= "[$t, " . ($e_dataavg{$l}{$tm}{$h}{"$rd"} || 0) . "],";
 					}
 				}
 			}
 		}
+
 		foreach (keys %graph_data) {
 			$graph_data{$_} =~ s/,$//;
 		}
@@ -11009,22 +11197,28 @@ sub show_error_as_html
                 my $days = 0;
 		foreach my $d (sort keys %{$error_info{$k}{chronos}}) {
 			my $c = 1;
-			$d =~ /^\d{4}(\d{2})(\d{2})$/;
+			$d =~ /^(\d{4})(\d{2})(\d{2})$/;
 			$days++;
-			my $zday = "$abbr_month{$1} $2";
+			my $zday = "$abbr_month{$2} $3";
+			my $y = $1 - 1900;
+			my $mo = $2 - 1;
+			my $dd = $3;
 			foreach my $h (sort keys %{$error_info{$k}{chronos}{$d}}) {
-				$details .= "<tr><td>$zday</td><td>$h</td><td>" .
+				my $t = timegm_nocheck(0, 0, $h, $dd, $mo, $y);
+				$t += $timezone;
+				my $ht = sprintf("%02d", (localtime($t))[2]);
+				$details .= "<tr><td>$zday</td><td>$ht</td><td>" .
 					&comma_numbers($error_info{$k}{chronos}{$d}{$h}{count}) . "</td></tr>";
 				$zday = "";
 				foreach my $m (sort keys %{$error_info{$k}{chronos}{$d}{$h}{min}}) {
 					my $rd = &average_per_minutes($m, $histo_avg_minutes);
-					$hourly_count{"$h:$rd"} += $error_info{$k}{chronos}{$d}{$h}{min}{$m};
+					$hourly_count{"$ht:$rd"} += $error_info{$k}{chronos}{$d}{$h}{min}{$m};
 				}
 				if ($#histo_avgs > 0) {
 					foreach my $rd (@histo_avgs) {
-						next if (!exists $hourly_count{"$h:$rd"});
-						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$h:$rd</td><td>" .
-							&comma_numbers($hourly_count{"$h:$rd"}) . "</td></tr>";
+						next if (!exists $hourly_count{"$ht:$rd"});
+						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$ht:$rd</td><td>" .
+							&comma_numbers($hourly_count{"$ht:$rd"}) . "</td></tr>";
 					}
 				}
 			}
@@ -11191,22 +11385,28 @@ sub show_pgb_error_as_html
                 my $days = 0;
 		foreach my $d (sort keys %{$pgb_error_info{$k}{chronos}}) {
 			my $c = 1;
-			$d =~ /^\d{4}(\d{2})(\d{2})$/;
+			$d =~ /^(\d{4})(\d{2})(\d{2})$/;
 			$days++;
-			my $zday = "$abbr_month{$1} $2";
+			my $zday = "$abbr_month{$2} $3";
+			my $y = $1 - 1900;
+			my $mo = $2 - 1;
+			my $dd = $3;
 			foreach my $h (sort keys %{$pgb_error_info{$k}{chronos}{$d}}) {
-				$details .= "<tr><td>$zday</td><td>$h</td><td>" .
+				my $t = timegm_nocheck(0, 0, $h, $dd, $mo, $y);
+				$t += $timezone;
+				my $ht = sprintf("%02d", (localtime($t))[2]);
+				$details .= "<tr><td>$zday</td><td>$ht</td><td>" .
 					&comma_numbers($pgb_error_info{$k}{chronos}{$d}{$h}{count}) . "</td></tr>";
 				$zday = "";
 				foreach my $m (sort keys %{$pgb_error_info{$k}{chronos}{$d}{$h}{min}}) {
 					my $rd = &average_per_minutes($m, $histo_avg_minutes);
-					$hourly_count{"$h:$rd"} += $pgb_error_info{$k}{chronos}{$d}{$h}{min}{$m};
+					$hourly_count{"$ht:$rd"} += $pgb_error_info{$k}{chronos}{$d}{$h}{min}{$m};
 				}
 				if ($#histo_avgs > 0) {
 					foreach my $rd (@histo_avgs) {
-						next if (!exists $hourly_count{"$h:$rd"});
-						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$h:$rd</td><td>" .
-							&comma_numbers($hourly_count{"$h:$rd"}) . "</td></tr>";
+						next if (!exists $hourly_count{"$ht:$rd"});
+						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$ht:$rd</td><td>" .
+							&comma_numbers($hourly_count{"$ht:$rd"}) . "</td></tr>";
 					}
 				}
 			}
@@ -11346,22 +11546,28 @@ sub show_pgb_reserved_pool
                 my $days = 0;
 		foreach my $d (sort keys %{$pgb_pool_info{$k}{chronos}}) {
 			my $c = 1;
-			$d =~ /^\d{4}(\d{2})(\d{2})$/;
+			$d =~ /^(\d{4})(\d{2})(\d{2})$/;
 			$days++;
-			my $zday = "$abbr_month{$1} $2";
+			my $zday = "$abbr_month{$2} $3";
+			my $y = $1 - 1900;
+			my $mo = $2 - 1;
+			my $dd = $3;
 			foreach my $h (sort keys %{$pgb_pool_info{$k}{chronos}{$d}}) {
-				$details .= "<tr><td>$zday</td><td>$h</td><td>" .
+				my $t = timegm_nocheck(0, 0, $h, $dd, $mo, $y);
+				$t += $timezone;
+				my $ht = sprintf("%02d", (localtime($t))[2]);
+				$details .= "<tr><td>$zday</td><td>$ht</td><td>" .
 					&comma_numbers($pgb_pool_info{$k}{chronos}{$d}{$h}{count}) . "</td></tr>";
 				$zday = "";
 				foreach my $m (sort keys %{$pgb_pool_info{$k}{chronos}{$d}{$h}{min}}) {
 					my $rd = &average_per_minutes($m, $histo_avg_minutes);
-					$hourly_count{"$h:$rd"} += $pgb_pool_info{$k}{chronos}{$d}{$h}{min}{$m};
+					$hourly_count{"$ht:$rd"} += $pgb_pool_info{$k}{chronos}{$d}{$h}{min}{$m};
 				}
 				if ($#histo_avgs > 0) {
 					foreach my $rd (@histo_avgs) {
-						next if (!exists $hourly_count{"$h:$rd"});
-						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$h:$rd</td><td>" .
-							&comma_numbers($hourly_count{"$h:$rd"}) . "</td></tr>";
+						next if (!exists $hourly_count{"$ht:$rd"});
+						$details .= "<tr><td>$zday</td><td style=\"text-align: right\">$ht:$rd</td><td>" .
+							&comma_numbers($hourly_count{"$ht:$rd"}) . "</td></tr>";
 					}
 				}
 			}
@@ -11620,7 +11826,7 @@ sub load_stats
 	foreach my $day (keys %{ $_connection_info{chronos} }) {
 		foreach my $hour (keys %{ $_connection_info{chronos}{$day} }) {
 
-			$connection_info{chronos}{$day}{$hour}{count} += $_connection_info{chronos}{$day}{$hour}{count}
+			$connection_info{chronos}{$day}{$hour}{count} += $_connection_info{chronos}{$day}{$hour}{count};
 
 ###############################################################################
 # May be used in the future to display more detailed information on connection
@@ -11797,10 +12003,10 @@ sub load_stats
 
 				$per_minute_info{$day}{$hour}{$min}{cancelled}{count} += $_per_minute_info{$day}{$hour}{$min}{cancelled}{count}
 						if defined $_per_minute_info{$day}{$hour}{$min}{cancelled}{count};
-				$per_minute_info{$day}{$hour}{$min}{tempfile}{count} += $_per_minute_info{$day}{$hour}{$min}{tempfile}{count}
-						if defined $_per_minute_info{$day}{$hour}{$min}{tempfile}{count};
-				$per_minute_info{$day}{$hour}{$min}{tempfile}{size} += $_per_minute_info{$day}{$hour}{$min}{tempfile}{size}
-						if defined $_per_minute_info{$day}{$hour}{$min}{tempfile}{size};
+				$per_minute_info{$day}{$hour}{$min}{'tempfile'}{count} += $_per_minute_info{$day}{$hour}{$min}{'tempfile'}{count}
+						if defined $_per_minute_info{$day}{$hour}{$min}{'tempfile'}{count};
+				$per_minute_info{$day}{$hour}{$min}{'tempfile'}{size} += $_per_minute_info{$day}{$hour}{$min}{'tempfile'}{size}
+						if defined $_per_minute_info{$day}{$hour}{$min}{'tempfile'}{size};
 
 				$per_minute_info{$day}{$hour}{$min}{checkpoint}{file_removed} += $_per_minute_info{$day}{$hour}{$min}{checkpoint}{file_removed};
 				$per_minute_info{$day}{$hour}{$min}{checkpoint}{sync} += $_per_minute_info{$day}{$hour}{$min}{checkpoint}{sync};
@@ -11816,6 +12022,11 @@ sub load_stats
 				$per_minute_info{$day}{$hour}{$min}{checkpoint}{sync_avg} += $_per_minute_info{$day}{$hour}{$min}{checkpoint}{sync_avg};
 				$per_minute_info{$day}{$hour}{$min}{checkpoint}{sync_longest} = $_per_minute_info{$day}{$hour}{$min}{checkpoint}{sync_longest}
 					if ($_per_minute_info{$day}{$hour}{$min}{checkpoint}{sync_longest} > $per_minute_info{$day}{$hour}{$min}{checkpoint}{sync_longest});
+				$per_minute_info{$day}{$hour}{$min}{checkpoint}{distance} = $_per_minute_info{$day}{$hour}{$min}{checkpoint}{distance};
+				$per_minute_info{$day}{$hour}{$min}{checkpoint}{distance_count} = $_per_minute_info{$day}{$hour}{$min}{checkpoint}{distance_count};
+				$per_minute_info{$day}{$hour}{$min}{checkpoint}{estimate} = $_per_minute_info{$day}{$hour}{$min}{checkpoint}{estimate};
+				$per_minute_info{$day}{$hour}{$min}{checkpoint}{warnning} = $_per_minute_info{$day}{$hour}{$min}{checkpoint}{warning};
+				$per_minute_info{$day}{$hour}{$min}{checkpoint}{warning_seconds} = $_per_minute_info{$day}{$hour}{$min}{checkpoint}{warning_seconds};
 			}
 		}
 	}
@@ -12056,6 +12267,10 @@ sub load_stats
 	$checkpoint_info{total} += $_checkpoint_info{total};
 	$checkpoint_info{file_added} += $_checkpoint_info{file_added};
 	$checkpoint_info{write} += $_checkpoint_info{write};
+	$checkpoint_info{distance} += $_checkpoint_info{distance};
+	$checkpoint_info{estimate} += $_checkpoint_info{estimate};
+	$checkpoint_info{warning} += $_checkpoint_info{warning};
+	$checkpoint_info{warning_seconds} += $_checkpoint_info{warning_seconds};
 
 	#### Autovacuum info ####
 
@@ -12137,16 +12352,22 @@ sub dump_as_binary
 
 sub dump_error_as_json
 {
-	my $json = encode_json({
-		'error_info' => \%error_info,
-	}) || localdie ("Encode object to JSON failed!\n");
+	my $perl_hash = { 'error_info' => \%error_info };
+
+	my $json = undef;
+	if (!$json_prettify) {
+		$json = encode_json($perl_hash) || localdie ("Encode events objects to JSON failed!\n");
+	} else {
+		my $coder = JSON::XS->new->ascii->pretty->allow_nonref(0);
+		$json = $coder->encode($perl_hash) || localdie ("Encode events objects to prettified JSON failed!\n");
+	}
 
 	print $fh $json;
 }
 
 sub dump_as_json
 {
-	my $json = encode_json({
+	my $perl_hash = {
 		'overall_stat' => \%overall_stat,
 		'pgb_overall_stat' => \%pgb_overall_stat,
 		'overall_checkpoint' => \%overall_checkpoint,
@@ -12174,8 +12395,15 @@ sub dump_as_json
 		'autovacuum_info' => \%autovacuum_info,
 		'autoanalyze_info' => \%autoanalyze_info,
 		'top_tempfile_info' => \@top_tempfile_info,
-		'top_locked_info' => \@top_locked_info,
-	}) || localdie ("Encode object to JSON failed!\n");
+		'top_locked_info' => \@top_locked_info
+	};
+	my $json = undef;
+	if (!$json_prettify) {
+		$json = encode_json($perl_hash) || localdie ("Encode stats objects to JSON failed!\n");
+	} else {
+		my $coder = JSON::XS->new->ascii->pretty->allow_nonref(0);
+		$json = $coder->encode($perl_hash) || localdie ("Encode stats objects to prettified JSON failed!\n");
+	}
 
 	print $fh $json;
 }
@@ -12195,7 +12423,8 @@ sub highlight_code
 	# prettify SQL query
 	if (!$noprettify) {
 		$sql_prettified->query($code);
-		$code = $sql_prettified->beautify;
+		$sql_prettified->beautify();
+		$code = $sql_prettified->content();
 	}
 
 	return $code if ($nohighlight);
@@ -12213,22 +12442,21 @@ sub highlight_code
 		$i++;
 	}
 
-	foreach my $x (sort keys %SYMBOLS) {
-		$code =~ s/$x/\$\$PGBGYA\$\$$SYMBOLS{$x}\$\$PGBGYB\$\$/gs;
+	foreach my $x (sort keys %{ $sql_prettified->{ 'dict' }->{ 'symbols' } }) {
+		$code =~ s/\Q$x\E/\$\$PGBGYA\$\$$sql_prettified->{ 'dict' }->{ 'symbols' }{$x}\$\$PGBGYB\$\$/gs;
 	}
-	for (my $x = 0 ; $x <= $#KEYWORDS1 ; $x++) {
-		#$code =~ s/\b$KEYWORDS1[$x]\b/<span class="kw1">$KEYWORDS1[$x]<\/span>/igs;
-		$code =~ s/(?<!(?-i)PGBGYB\$\$)\b$KEYWORDS1[$x]\b/<span class="kw1">$KEYWORDS1[$x]<\/span>/igs;
+	for (my $x = 0 ; $x <= $#{ $sql_prettified->{ 'dict' }->{ 'pg_keywords' } } ; $x++) {
+		$code =~ s/(?<!(?-i)PGBGYB\$\$)\b$sql_prettified->{ 'dict' }->{ 'pg_keywords' }[$x]\b/<span class="kw1">$sql_prettified->{ 'dict' }->{ 'pg_keywords' }[$x]<\/span>/igs;
 	}
 
-	for (my $x = 0 ; $x <= $#KEYWORDS2 ; $x++) {
-		$code =~ s/(?<!:)\b$KEYWORDS2[$x]\b/<span class="kw2">$KEYWORDS2[$x]<\/span>/igs;
+	for (my $x = 0 ; $x <= $#{ $sql_prettified->{ 'dict' }->{ 'pg_functions' } } ; $x++) {
+		$code =~ s/(?<!:)\b$sql_prettified->{ 'dict' }->{ 'pg_functions' }[$x]\b/<span class="kw2">$sql_prettified->{ 'dict' }->{ 'pg_functions' }[$x]<\/span>/igs;
 	}
-	for (my $x = 0 ; $x <= $#KEYWORDS3 ; $x++) {
-		$code =~ s/\b$KEYWORDS3[$x]\b/<span class="kw3">$KEYWORDS3[$x]<\/span>/igs;
+	for (my $x = 0 ; $x <= $#{ $sql_prettified->{ 'dict' }->{ 'copy_keywords' } } ; $x++) {
+		$code =~ s/\b$sql_prettified->{ 'dict' }->{ 'copy_keywords' }[$x]\b/<span class="kw3">$sql_prettified->{ 'dict' }->{ 'copy_keywords' }[$x]<\/span>/igs;
 	}
-	for (my $x = 0 ; $x <= $#BRACKETS ; $x++) {
-		$code =~ s/($BRACKETS[$x])/<span class="br0">$1<\/span>/igs;
+	for (my $x = 0 ; $x <= $#{ $sql_prettified->{ 'dict' }->{ 'brackets' } } ; $x++) {
+		$code =~ s/(\Q$sql_prettified->{ 'dict' }->{ 'brackets' }[$x]\E)/<span class="br0">$1<\/span>/igs;
 	}
 
 	$code =~ s/\$\$PGBGYA\$\$([^\$]+)\$\$PGBGYB\$\$/<span class="sy0">$1<\/span>/gs;
@@ -12421,7 +12649,6 @@ sub parse_log_prefix
 		if ($t_logprefix =~ $regex_prefix_dbappname) {
 			$prefix_vars{'t_appname'} = $1;
 		}
-
 	}
 }
 
@@ -12598,8 +12825,8 @@ sub parse_query
 		my $size = $2;
 		$tempfile_info{count}++;
 		$tempfile_info{size} += $size;
-		$per_minute_info{$date_part}{$prefix_vars{'t_hour'}}{$prefix_vars{'t_min'}}{tempfile}{count}++;
-		$per_minute_info{$date_part}{$prefix_vars{'t_hour'}}{$prefix_vars{'t_min'}}{tempfile}{size} += $size;
+		$per_minute_info{$date_part}{$prefix_vars{'t_hour'}}{$prefix_vars{'t_min'}}{'tempfile'}{count}++;
+		$per_minute_info{$date_part}{$prefix_vars{'t_hour'}}{$prefix_vars{'t_min'}}{'tempfile'}{size} += $size;
 
 		# Store current temporary file information that will be used later
 		# when we will parse the query responsible for the tempfile
@@ -12757,7 +12984,7 @@ sub parse_query
 			if ($prefix_vars{'t_query'} =~ /tuples: (\d+) removed, (\d+) remain/) {
 				$autovacuum_info{tables}{$cur_info{$t_pid}{vacuum}}{tuples}{removed} += $1;
 			}
-			if ($prefix_vars{'t_query'} =~ m#system usage: CPU .* sec elapsed (.*) sec#) {
+			if ($prefix_vars{'t_query'} =~ m#system usage: CPU .* (?:sec|s,) elapsed (.*) s#) {
 				if ($1 > $autovacuum_info{peak}{system_usage}{elapsed}) {
 					$autovacuum_info{peak}{system_usage}{elapsed} = $1;
 					$autovacuum_info{peak}{system_usage}{table} = $cur_info{$t_pid}{vacuum};
@@ -12790,7 +13017,7 @@ sub parse_query
 		$autoanalyze_info{tables}{$table}{analyzes} += 1;
 		$autoanalyze_info{chronos}{$date_part}{$prefix_vars{'t_hour'}}{count}++;
 		$per_minute_info{$date_part}{$prefix_vars{'t_hour'}}{$prefix_vars{'t_min'}}{autoanalyze}{count}++;
-		if ($prefix_vars{'t_query'} =~ m#system usage: CPU .* sec elapsed (.*) sec#) {
+		if ($prefix_vars{'t_query'} =~ m#system usage: CPU .* (?:sec|s,) elapsed (.*) s#) {
 			if ($1 > $autoanalyze_info{peak}{system_usage}{elapsed}) {
 				$autoanalyze_info{peak}{system_usage}{elapsed} = $1;
 				$autoanalyze_info{peak}{system_usage}{table} = $table;
@@ -12803,11 +13030,12 @@ sub parse_query
 	if (
 		($prefix_vars{'t_loglevel'} eq 'LOG')
 		&& ($prefix_vars{'t_query'} =~
-/point complete: wrote (\d+) buffers \(([^\)]+)\); (\d+) transaction log file\(s\) added, (\d+) removed, (\d+) recycled; write=([0-9\.]+) s, sync=([0-9\.]+) s, total=([0-9\.]+) s/
+/point complete: wrote (\d+) buffers \(([^\)]+)\); (\d+) (?:transaction log|WAL) file\(s\) added, (\d+) removed, (\d+) recycled; write=([0-9\.]+) s, sync=([0-9\.]+) s, total=([0-9\.]+) s/
 		   )
 	   )
 	{
 		# Example: LOG:  checkpoint complete: wrote 8279 buffers (50.5%); 0 transaction log file(s) added, 0 removed, 0 recycled; write=2.277 s, sync=0.194 s, total=2.532 s; sync files=13, longest=0.175 s, average=0.014 s; distance=402024 kB, estimate=402024 kB
+		# checkpoint complete: wrote 38 buffers (0.1%); 0 WAL file(s) added, 0 removed, 0 recycled; write=4.160 s, sync=0.096 s, total=4.338 s; sync files=29, longest=0.018 s, average=0.003 s; distance=79 kB, estimate=79 kB
 		return if ($disable_checkpoint);
 
 		$checkpoint_info{wbuffer} += $1;
@@ -12985,7 +13213,7 @@ sub parse_query
 
 	my $t_action = '';
 	# Store query duration generated by log_min_duration >= 0 in postgresql.conf
-	if ($prefix_vars{'t_query'} =~ s/duration: ([0-9\.]+) ms\s+(query|statement): //is) {
+	if ($prefix_vars{'t_query'} =~ s/duration: ([0-9\.]+) ms\s+(query|statement): //s) {
 		$prefix_vars{'t_duration'} = $1;
 		$t_action   = $2;
 		my $k = &get_hist_inbound($1, @histogram_query_time);
@@ -12998,7 +13226,7 @@ sub parse_query
 			return if (lc($1) eq 'prepare');
 		}
 	# Log line with duration and statement from prepared queries
-	} elsif ($prefix_vars{'t_query'} =~ s/duration: ([0-9\.]+) ms\s+(prepare|parse|bind|execute from fetch|execute)\s+[^:]+:\s//is)
+	} elsif ($prefix_vars{'t_query'} =~ s/duration: ([0-9\.]+) ms\s+(prepare|parse|bind|execute from fetch|execute)\s+[^:]+:\s//s)
 	{
 		$prefix_vars{'t_duration'} = $1;
 		$t_action = $2;
@@ -13013,12 +13241,10 @@ sub parse_query
 		$overall_stat{histogram}{query_total}++;
 		$prefix_vars{'t_bind'} = 1;
 	# Activate storage of the explain plan generated by auto_explain
-	} elsif ($prefix_vars{'t_query'} =~ s/duration: ([0-9\.]+) ms\s+plan://is) {
-		$prefix_vars{'t_duration'} = $1;
-		$cur_plan_info{$prefix_vars{'t_pid'}}{duration} = $prefix_vars{'t_duration'};
-		my $k = &get_hist_inbound($prefix_vars{'t_duration'}, @histogram_query_time);
-		$overall_stat{histogram}{query_time}{$k}++;
-		$overall_stat{histogram}{query_total}++;
+	} elsif ($prefix_vars{'t_query'} =~ s/duration: ([0-9\.]+) ms\s+plan://s) {
+		$cur_plan_info{$prefix_vars{'t_pid'}}{duration} = $1;
+		$cur_plan_info{$prefix_vars{'t_pid'}}{plan} = '';
+		$prefix_vars{'t_duration'} = $1; # needed to be saved later
 	# Log line without duration at all
 	} elsif ($prefix_vars{'t_query'} =~ s/(query|statement): //is) {
 		$t_action = $1;
@@ -13027,7 +13253,7 @@ sub parse_query
 			$per_minute_info{$date_part}{$prefix_vars{'t_hour'}}{$prefix_vars{'t_min'}}{lc($1)}++;
 		}
 	# Log line without duration at all from prepared queries
-	} elsif ($prefix_vars{'t_query'} =~ s/(prepare|parse|bind|execute from fetch|execute)\s+[^:]+:\s//is)
+	} elsif ($prefix_vars{'t_query'} =~ s/(prepare|parse|bind|execute from fetch|execute)\s+[^:]+:\s//s)
 	{
 		$t_action = $1;
 		$t_action =~ s/ from fetch//;
@@ -13048,7 +13274,7 @@ sub parse_query
 		return;
 	}
 
-	if ( ($fmt eq 'csv') && ($prefix_vars{'t_loglevel'} ne 'LOG')) {
+	if ( ($fmt =~ /csv|jsonlog/) && ($prefix_vars{'t_loglevel'} ne 'LOG')) {
 		$cur_info{$t_pid}{detail} = $prefix_vars{'t_detail'};
 		$cur_info{$t_pid}{hint} = $prefix_vars{'t_hint'};
 		$cur_info{$t_pid}{context} = $prefix_vars{'t_context'};
@@ -13259,19 +13485,6 @@ sub set_current_infos
 	$cur_info{$t_pid}{date}      = $prefix_vars{'t_date'} if (!$cur_info{$t_pid}{date});
 	$cur_info{$t_pid}{bind}      = $prefix_vars{'t_bind'} if (!$cur_info{$t_pid}{bind});
 	$cur_info{$t_pid}{sqlstate}  = $prefix_vars{'t_sqlstate'} if (!$cur_info{$t_pid}{sqlstate});
-
-	# Extract the query part from the plan
-	if (exists $cur_plan_info{$t_pid} && exists $cur_plan_info{$t_pid}{plan} && $cur_plan_info{$t_pid}{plan} ne '') {
-		my $key = 'query';
-		my @plan = split("\n", $cur_plan_info{$t_pid}{plan});
-		$plan[0] =~ s/^\s*Query Text:\s+//;
-		foreach my $l (@plan) {
-			$key = 'plan' if ($l =~ /\(cost=\d+.*rows=\d+/);
-			$cur_info{$t_pid}{$key} .= "$l\n";
-		}
-		$cur_info{$t_pid}{query} =~ s/^\s*Query Text:\s+//s;
-		delete $cur_plan_info{$t_pid};
-	}
 }
 
 sub store_tsung_session
@@ -13345,14 +13558,12 @@ sub store_queries
 	}
 
 	return 0 if (!exists $cur_info{$t_pid});
-	return 1 if (!$cur_info{$t_pid}{year});
-
+	return 1 if (!exists $cur_info{$t_pid}{year});
 
 	# Cleanup and pre-normalize the current query
 	$cur_info{$t_pid}{query} =~ s/^\s+//s;
 	$cur_info{$t_pid}{query} =~ s/[\s;]+$//s;
 
-
 	# Just store normalized query when --normalized-only is used
 	if ($dump_normalized_only && $cur_info{$t_pid}{query}) {
 
@@ -13476,6 +13687,50 @@ sub store_queries
 
 	} elsif ($cur_info{$t_pid}{loglevel} eq 'LOG') {
 
+		# Store auto explain plan when switching to an other log entry
+		if (exists $cur_plan_info{$t_pid}{plan}) {
+			$cur_plan_info{$t_pid}{plan} =~ s/^\s+//s;
+			$cur_plan_info{$t_pid}{plan} =~ s/\s+$//s;
+			# Extract the query part from the plan then the plan itself
+			if ($cur_plan_info{$t_pid}{plan}) {
+				my $key = 'query';
+				my @plan = split("\n", $cur_plan_info{$t_pid}{plan});
+				foreach my $l (@plan) {
+					# In TEXT format
+					if ($l =~ /\(cost=\d+.*rows=\d+/) {
+						$key = 'plan' ;
+					# In JSON or YAML format
+					} elsif ($l =~ /"Plan": \{|Plan:/) {
+						$key = 'plan' ;
+					# In XML format
+					} elsif ($l =~ /<Plan>/) {
+						$key = 'plan' ;
+					}
+					$cur_info{$t_pid}{$key} .= "$l\n";
+				}
+				# YAML format
+				if ($cur_info{$t_pid}{query} =~ s/Query Text: "//s) {
+					$cur_info{$t_pid}{query} =~ s/"$//s;
+					$cur_info{$t_pid}{plan} .= "\n";
+				# TEXT format
+				} elsif ($cur_info{$t_pid}{query} =~ s/Query Text: ([^"])/$1/s) {
+					$cur_info{$t_pid}{plan} .= "\n";
+				# JSON format
+				} elsif ($cur_info{$t_pid}{query} =~ s/.*"Query Text": "//s) {
+					$cur_info{$t_pid}{query} =~ s/"$//s;
+					$cur_info{$t_pid}{plan} = "  [\n    {\n" . $cur_info{$t_pid}{plan} . "  ]\n";
+				} elsif ($cur_info{$t_pid}{query} =~ s/.*<Query-Text>//s) {
+					$cur_info{$t_pid}{query} =~ s/<\/Query-Text>//s;
+					$cur_info{$t_pid}{plan} .= "\n";
+					if ($extension eq 'html') {
+						$cur_info{$t_pid}{plan} =~ s/</&lt;/gs;
+						$cur_info{$t_pid}{plan} =~ s/>/&gt;/gs;
+					}
+				}
+			}
+			delete $cur_plan_info{$t_pid};
+		}
+
 		# Stores global statistics
 
 		$overall_stat{'queries_number'}++;
@@ -13752,7 +14007,8 @@ sub normalize_error
 	$orig_query =~ s/(byte sequence for encoding).*/$1/;
 
 	# Replace changing parameter by ...
-	$orig_query =~ s/"[^"]*"/"..."/g;
+	$orig_query =~ s/"[^"]+"/"..."/g;
+	$orig_query =~ s/""...""/"..."/g;
 	$orig_query =~ s/\(.*\)/\(...\)/g;
 	$orig_query =~ s/column .* does not exist/column "..." does not exist/;
 	$orig_query =~ s/(database system was.* at (?:log time )?).*/$1 .../;
@@ -13831,30 +14087,38 @@ sub autodetect_format
 	my $fltf;
 
 	if (!$remote_host) {
-		localdie("FATAL: when looking for log file format, can't open file $file, $!\n") unless(open(TESTFILE, $file));
-		$fltf = <TESTFILE>;
-		close(TESTFILE);
+		if (open(my $in, '<', $file)) {
+			$fltf = <$in>;
+			close($in);
+		} else {
+			localdie("FATAL: when looking for log file format, can't open file $file, $!\n");
+		}
 	}
 
 	# is file in binary format ?
 	if ( $fltf =~ /^pst\d/ ) {
 		$fmt = 'binary';
 	}
-	else { # try to detect syslogs, stderr, csv or pgbouncer format
+	else { # try to detect syslogs, stderr, csv jsonlog or pgbouncer format
 		my ($tfile, $totalsize) = &get_log_file($file, $remote_host);
-		while (my $line = <$tfile>) {
-			chomp($line);
-			$line =~ s/\r//;
-			next if (!$line);
-			$nline++;
-
-			my ($f, $i) = search_log_format($line);
-			$nfound++ if ($f);
-			$fmt = $f;
-			$ident_name{$i}++ if ($i);
-			last if (($nfound > 10) || ($nline > 5000));
+		if (defined $tfile) {
+			while (my $line = <$tfile>) {
+				chomp($line);
+				$line =~ s/\r//;
+				next if (!$line);
+				$nline++;
+
+				my ($f, $i) = search_log_format($line);
+				$nfound++ if ($f);
+				$fmt = $f;
+				$ident_name{$i}++ if ($i);
+				last if (($nfound > 10) || ($nline > 5000));
+			}
+			$tfile->close();
+		} else {
+			&logmsg('DEBUG', "Can not autodetected log format from $file, using default");
+			return 'default';
 		}
-		$tfile->close();
 	}
 
 	# When --pgbouncer-only is used force the format
@@ -13884,14 +14148,21 @@ sub search_log_format
 	my $ident_name = '';
 
 	# Are pgbouncer syslog lines ?
-	if ($line =~ /^[A-Z][a-z]{2}\s+\d+ \d+:\d+:\d+(?:\s[^\s]+)?\s[^\s]+\s([^\s\[]+)\[\d+\]: (.\-0x[0-9a-f\.]*|Stats):/) {
-		localdie("FATAL: parsing pgbouncer log from syslog is not supported.\n");
+	if ($line =~
+/^[A-Z][a-z]{2}\s+\d+ \d+:\d+:\d+(?:\s[^\s]+)?\s[^\s]+\s([^\s\[]+)\[\d+\]: (.\-0x[0-9a-f\.]*|Stats):/
+	   )
+	{
+		$fmt = 'pgbouncer1';
+		# If we just have one single pgbouncer file, force pgbouncer_only to 1
+		$pgbouncer_only = 1 if ($#log_files == 0);
 
 	} elsif ($line =~
 /^\d+-\d+-\d+T\d+:\d+:\d+(?:.[^\s]+)?\s[^\s]+\s(?:[^\s]+\s)?(?:[^\s]+\s)?([^\s\[]+)\[\d+\]: (.\-0x[0-9a-f\.]*|Stats):/
 	   )
 	{
-		localdie("FATAL: parsing pgbouncer log from syslog is not supported.\n");
+		$fmt = 'pgbouncer2';
+		# If we just have one single pgbouncer file, force pgbouncer_only to 1
+		$pgbouncer_only = 1 if ($#log_files == 0);
 
 	# Are syslog lines ?
 	} elsif ($line =~
@@ -13919,31 +14190,34 @@ sub search_log_format
 	{
 		$fmt = 'csv';
 
-	# Are default stderr lines since 10.0 ?
+	# Are stderr lines ?
 	} elsif ($line =~
-/(\d{10}\.\d{3}|\d+-\d+-\d+ \d+:\d+:\d+)[\.0-9]*(?: [A-Z\+\-\d]{3,6})? \[(\d+)\] (LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT):\s+/
+/(\d{10}\.\d{3}|\d+-\d+-\d+ \d+:\d+:\d+)[\.0-9]*(?: [A-Z\+\-\d]{3,6})? \[([0-9a-f\.]+)\]: \[\d+-\d+\] (.*?)\s+(.*?)(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT):\s+/
 		)
 	{
-		$fmt = 'default';
+		$fmt = 'stderr';
 
-	# Are stderr lines ?
+	# Are default stderr lines since 10.0 or minimal prefix for pgbadger?
 	} elsif ($line =~
-/(\d{10}\.\d{3}|\d+-\d+-\d+ \d+:\d+:\d+)[\.0-9]*(?: [A-Z\+\-\d]{3,6})?(.*?)(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT):\s+/
+/(\d{10}\.\d{3}|\d+-\d+-\d+ \d+:\d+:\d+)[\.0-9]*(?: [A-Z\+\-\d]{3,6})? \[([0-9a-f\.]+)\][:]*\s+(.*?)\s+(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT):\s+/
 		)
 	{
-		$fmt = 'stderr';
-
+		$fmt = 'default';
 
 	# Are pgbouncer lines ?
 	} elsif ($line =~ /^(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2})\.\d+(?: [A-Z\+\-\d]{3,6})? (\d+) (LOG|ERROR) (.\-0x[0-9a-f\.]*|Stats):/) {
 		$fmt = 'pgbouncer';
 		# If we just have one single pgbouncer file, force pgbouncer_only to 1
 		$pgbouncer_only = 1 if ($#log_files == 0);
+
+	# jsonlog lines
+	} elsif ($line =~ /\{"timestamp":"/) {
+		$fmt = 'jsonlog';
 	}
 
 	return ($fmt, $ident_name);
 }
-
+	
 sub progress_bar
 {
 	my ($got, $total, $width, $char, $queries, $errors) = @_;
@@ -14166,1096 +14440,2323 @@ sub build_log_line_prefix_regex
 		'%i' => [('t_command',           '([0-9a-zA-Z\.\-\_\s]*)')],                                        # command tag
 		'%e' => [('t_sqlstate',          '([0-9a-zA-Z]+)')],                                              # SQL state
 	);
-	my @param_list = ();
+	my $param_list = [];
 	$llp =~ s/([\[\]\|\(\)\{\}])/\\$1/g;
 	$llp =~ s/\%l([^\d])\d+/\%l$1\\d\+/;
-	$llp =~ s/\%q//;
+	my $q_prefix = '';
+	if ($llp =~ s/(.*)\%q(.*)/$1$2/) {
+		$q_prefix =  $1;
+	}
 	while ($llp =~ s/(\%[audrhpntmlscvxie])/$regex_map{"$1"}->[1]/) {
-		push(@param_list, $regex_map{"$1"}->[0]);
+		push(@$param_list, $regex_map{"$1"}->[0]);
 	}
+	my $q_prefix_param = [];
+	while ($q_prefix =~ s/(\%[audrhpntmlscvxie])/$regex_map{"$1"}->[1]/) {
+		push(@$q_prefix_param, $regex_map{"$1"}->[0]);
+	}
+	push(@$q_prefix_param, 't_loglevel', 't_query');
+
 	# replace %% by a single %
-	$llp =~ s/\%\%/\%/;
+	$llp =~ s/\%\%/\%/g;
+	$q_prefix =~ s/\%\%/\%/g;
+	$q_prefix = qr/$q_prefix\s*(LOG|WARNING|ERROR|FATAL|PANIC|DETAIL|STATEMENT|HINT|CONTEXT|LOCATION):\s+(?:[0-9A-Z]{5}:\s+)?(.*)/;
 
 	# t_session_id (%c) can naturaly replace pid as unique session id
 	# when it is given in log_line_prefix and pid is not present.
-	$use_sessionid_as_pid = 1 if ( grep(/t_session_id/, @param_list) && !grep(/t_pid/, @param_list) );
+	$use_sessionid_as_pid = 1 if ( grep(/t_session_id/, @$param_list) && !grep(/t_pid/, @$param_list) );
 
 	# Check regex in log line prefix from command line
 	&check_regex($llp, '--prefix');
 
-	return ($llp, @param_list);
+	return (
+		'llp' => $llp, 'param_list' => $param_list,
+		'q_prefix' => $q_prefix, 'q_param_list' => $q_prefix_param
+	);
 }
 
-# Inclusion of Perl package SQL::Beautify
-# Copyright (C) 2009 by Jonas Kramer
-# Published under the terms of the Artistic License 2.0.
+sub get_log_file
 {
+	my $logf = shift;
+	my $sample_only = shift;
 
-	package SQL::Beautify;
-
-	use strict;
-	use warnings;
-
-	our $VERSION = 0.04;
-
-	use Carp;
-
-	# Keywords from SQL-92, SQL-99, SQL-2003, SQL-2008 and SQL-2011 specifics keywords.
-	use constant KEYWORDS => qw(
-		ABSOLUTE ACTION ADD AFTER ALL ALLOCATE ALTER AND ANY ARE ARRAY AS ASC
-		ASENSITIVE ASSERTION ASYMMETRIC AT ATOMIC AUTHORIZATION AVG BEFORE BEGIN
-		BETWEEN BIGINT BINARY BIT BIT_LENGTH BLOB BOOLEAN BOTH BREADTH BY CALL
-		CALLED CASCADE CASCADED CASE CAST CATALOG CHAR CHARACTER CHARACTER_LENGTH
-		CHAR_LENGTH CHECK CLOB CLOSE COALESCE COLLATE COLLATION COLUMN COMMIT
-		CONDITION CONNECT CONNECTION CONSTRAINT CONSTRAINTS CONSTRUCTOR CONTAINS
-		CONTINUE CONVERT CORRESPONDING COUNT CREATE CROSS CUBE CURRENT CURRENT_DATE
-		CURRENT_DEFAULT_TRANSFORM_GROUP CURRENT_CATALOG CURRENT_PATH CURRENT_ROLE
-		CURRENT_SCHEMA CURRENT_TIME CURRENT_TIMESTAMP CURRENT_TRANSFORM_GROUP_FOR_TYPE
-		CURRENT_USER CURSOR CYCLE DATA DATE DAY DEALLOCATE DEC DECIMAL DECLARE DEFAULT
-		DEFERRABLE DEFERRED DELETE DEPTH DEREF DESC DESCRIBE DESCRIPTOR DETERMINISTIC
-		DIAGNOSTICS DISCONNECT DISTINCT DO DOMAIN DOUBLE DROP DYNAMIC EACH ELEMENT
-		ELSE ELSEIF END EPOCH EQUALS ESCAPE EXCEPT EXCEPTION EXEC EXECUTE EXISTS
-		EXIT EXTERNAL EXTRACT FALSE FETCH FILTER FIRST FLOAT FOR FOREIGN FOUND FREE
-		FROM FULL FUNCTION GENERAL GET GLOBAL GO GOTO GRANT GROUP GROUPING HANDLER
-		HAVING HOLD HOUR IDENTITY IF IMMEDIATE IN INDICATOR INITIALLY INNER INOUT
-		INPUT INSENSITIVE INSERT INT INTEGER INTERSECT INTERVAL INTO IS ISOLATION
-		ITERATE JOIN KEY LANGUAGE LARGE LAST LATERAL LEADING LEAVE LEFT LEVEL LIKE
-		LIMIT LOCAL LOCALTIME LOCALTIMESTAMP LOCATOR LOOP LOWER MAP MATCH MAX
-		MEMBER MERGE METHOD MIN MINUTE MODIFIES MODULE MONTH MULTISET NAMES
-		NATIONAL NATURAL NCHAR NCLOB NEW NEXT NO NONE NOT NULL NULLIF NUMERIC
-		OBJECT OCTET_LENGTH OF OFFSET OLD ON ONLY OPEN OPTION OR ORDER ORDINALITY OUT
-		OUTER OUTPUT OVER OVERLAPS PAD PARAMETER PARTIAL PARTITION PATH POSITION
-		PRECISION PREPARE PRESERVE PRIMARY PRIOR PRIVILEGES PROCEDURE PUBLIC RANGE
-		READ READS REAL RECURSIVE REF REFERENCES REFERENCING RELATIVE RELEASE
-		REPEAT RESIGNAL RESTRICT RESULT RETURN RETURNS REVOKE RIGHT ROLE ROLLBACK
-		ROLLUP ROUTINE ROW ROWS SAVEPOINT SCHEMA SCOPE SCROLL SEARCH SECOND SECTION
-		SELECT SENSITIVE SESSION SESSION_USER SET SETS SIGNAL SIMILAR SIZE SMALLINT
-		SOME SPACE SPECIFIC SPECIFICTYPE SQL SQLCODE SQLERROR SQLEXCEPTION SQLSTATE
-		SQLWARNING START STATE STATIC SUBMULTISET SUBSTRING SUM SYMMETRIC SYSTEM
-		SYSTEM_USER TABLE TABLESAMPLE TEMPORARY TEXT THEN TIME TIMESTAMP
-		TIMEZONE_HOUR TIMEZONE_MINUTE TINYINT TO TRAILING TRANSACTION TRANSLATE
-		TRANSLATION TREAT TRIGGER TRIM TRUE UNDER UNDO UNION UNIQUE UNKNOWN UNNEST
-		UNTIL UPDATE UPPER USAGE USER USING VALUE VALUES VARCHAR VARYING VIEW WHEN
-		WHENEVER WHERE WHILE WINDOW WITH WITHIN WITHOUT WORK WRITE YEAR ZONE
-	);
-	use constant FUNCTIONS => qw();
-
-	sub tokenize_sql
-	{
-		my ($query, $remove_white_tokens) = @_;
+	my $lfile = undef;
+	my $iscompressed = 1;
 
-		my $re = qr{
-    (
-        (?:--)[\ \t\S]*      # single line comments
-        |
-        (?:\-\|\-) # range operator "is adjacent to"
-        |
-        (?:\->>|\->|\#>>|\#>|\?\&|\?)  # Json Operators
-        |
-        (?:\#<=|\#>=|\#<>|\#<|\#=) # compares tinterval and reltime
-        |
-        (?:>>=|<<=) # inet operators
-        |
-        (?:!!|\@\@\@) # deprecated factorial and full text search  operators
-        |
-        (?:\|\|\/|\|\/) # square root and cube root
-        |
-        (?:\@\-\@|\@\@|\#\#|<\->|<<\||\|>>|\&<\||\&<|\|\&>|\&>|<\^|>\^|\?\#|\#|\?<\||\?\-\||\?\-|\?\|\||\?\||\@>|<\@|\~=)
-				# Geometric Operators
-        |
-        (?:~<=~|~>=~|~>~|~<~) # string comparison for pattern matching operator families
-        |
-        (?:!~~|!~~\*|~~\*|~~) # LIKE operators
-        |
-        (?:!~\*|!~|~\*) # regular expression operators
-        |
-        (?:\*=|\*<>|\*<=|\*>=|\*<|\*>) # composite type comparison operators
-        |
-        (?:<>|<=>|>=|<=|==|!=|=|!|<<|>>|<|>|\|\||\||&&|&|-|\+|\*(?!/)|/(?!\*)|\%|~|\^|\?)
-                                  # operators and tests
-        |
-        [\[\]\(\),;.]            # punctuation (parenthesis, comma)
-        |
-        E\'\'(?!\')              # escape empty single quoted string
-        |
-        \'\'(?!\')              # empty single quoted string
-        |
-        \"\"(?!\"")             # empty double quoted string
-        |
-        "(?>(?:(?>[^"\\]+)|""|\\.)*)+"
-                                # anything inside double quotes, ungreedy
-        |
-        `(?>(?:(?>[^`\\]+)|``|\\.)*)+`
-                                # anything inside backticks quotes, ungreedy
-        |
-        E'(?>(?:(?>[^'\\]+)|''|\\.)*)+'
-                                # anything escaped inside single quotes, ungreedy.
-        |
-        '(?>(?:(?>[^'\\]+)|''|\\.)*)+'
-                                # anything inside single quotes, ungreedy.
-        |
-        /\*[\ \t\r\n\S]*?\*/      # C style comments
-        |
-        (?:[\w:@]+(?:\.(?:\w+|\*)?)*)
-                                # words, standard named placeholders, db.table.*, db.*
-        |
-        (?:\$\w+\$)
-        |
-        (?: \$_\$ | \$\d+ | \${1,2} | \$\w+\$ )
-                                # dollar expressions - eg $_$ $3 $$ $BODY$
-        |
-        \n                      # newline
-        |
-        [\t\ ]+                 # any kind of white spaces
-    )
-}smx;
-
-		my @query = ();
-		@query = $query =~ m{$re}smxg;
+	chomp($logf);
 
-		if ($remove_white_tokens) {
-			@query = grep(!/^[\s\n\r]*$/, @query);
+	# get file size
+	my $totalsize = 0;
+	if ( $journalctl_cmd && ($logf =~ m/\Q$journalctl_cmd\E/) ) {
+		$totalsize = 0;
+	} elsif (!$remote_host) {
+		$totalsize = (stat("$logf"))[7] || 0 if ($logf ne '-');
+	} elsif ($logf !~ /\.(gz|bz2|zip|xz)$/i) {
+		&logmsg('DEBUG', "Looking for file size using command: $ssh_command \"ls -l $logf\" | awk '{print \$5}'");
+		$totalsize = `$ssh_command "ls -l $logf" | awk '{print \$5}'`;
+		chomp($totalsize);
+		if ($totalsize eq '') {
+			localdie("FATAL: can't get size of remote file, please check what's going wrong with command: $ssh_command \"ls -l $logf\" | awk '{print \$5}'\n");
+		}
+		&logmsg('DEBUG', "Remote file size: $totalsize");
+		if (!$totalsize) {
+			# In list context returns the filehandle and the size of the file
+			if (wantarray()) {
+				return ($lfile, $totalsize, $iscompressed);
+			} else {
+				return $totalsize;
+			}
 		}
-		return wantarray ? @query : \@query;
 	}
 
-	sub new
-	{
-		my ($class, %options) = @_;
-
-		my $self = bless {%options}, $class;
+	# Open a file handle
+	if ( $journalctl_cmd && ($logf =~ m/\Q$journalctl_cmd\E/) ) {
+		# For journalctl command we need to use a pipe as file handle
+		if (!$remote_host) {
+			open($lfile, '-|', $logf) || localdie("FATAL: cannot read output of command: $logf. $!\n");
+		} else {
+			if (!$sample_only) {
+				&logmsg('DEBUG', "Retrieving log entries using command: $ssh_command \"$logf\" |");
+				# Open a pipe to remote journalctl program
+				open($lfile, '-|', "$ssh_command \"$logf\"") || localdie("FATAL: cannot read from pipe to $ssh_command \"$logf\". $!\n");
+			} else {
+				&logmsg('DEBUG', "Retrieving log entries using command: $ssh_command \"$logf -n 100\" |");
+				# Open a pipe to remote journalctl program
+				open($lfile, '-|', "$ssh_command \"$logf -n 100\"") || localdie("FATAL: cannot read from pipe to $ssh_command \"$logf -n 100\". $!\n");
+			}
+		}
+		$iscompressed = 0;
+	} elsif ($logf !~ /\.(gz|bz2|zip|xz)$/i) {
+		if (!$remote_host) {
+			open($lfile, '<', $logf) || localdie("FATAL: cannot read log file $logf. $!\n");
+		} else {
+			if (!$sample_only) {
+				&logmsg('DEBUG', "Retrieving log entries using command: $ssh_command \" cat $logf\" |");
+				# Open a pipe to cat program
+				open($lfile, '-|', "$ssh_command \"cat $logf\"") || localdie("FATAL: cannot read from pipe to $ssh_command \"cat $logf\". $!\n");
+			} else {
+				# Open a pipe to cat program
+				open($lfile, '-|', "$ssh_command \"tail -n 100 $logf\"") || localdie("FATAL: cannot read from pipe to $ssh_command \"tail -n 100 $logf\". $!\n");
+			}
+		}
+		$totalsize = 0 if ($logf eq '-');
+		$iscompressed = 0;
+	} else {
+		my $uncompress = $zcat;
+		my $sample_cmd = 'zgrep';
+		if (($logf =~ /\.bz2/i) && ($zcat =~ /^$zcat_cmd$/)) {
+			$uncompress = $bzcat;
+			$sample_cmd = 'bzgrep';
+		} elsif (($logf =~ /\.zip/i) && ($zcat =~ /^$zcat_cmd$/)) {
+			$uncompress = $ucat;
+		}
+		elsif (($logf =~ /\.xz/i) && ($zcat =~ /^$zcat_cmd$/)) {
+			$uncompress = $xzcat;
+			$sample_cmd = 'xzgrep';
+		}
+		if (!$remote_host) {
+			&logmsg('DEBUG', "Compressed log file, will use command: $uncompress \"$logf\"");
+			# Open a pipe to zcat program for compressed log
+			open($lfile, '-|', "$uncompress \"$logf\"") || localdie("FATAL: cannot read from pipe to $uncompress \"$logf\". $!\n");
+		} else {
+			if (!$sample_only) {
+				&logmsg('DEBUG', "Compressed log file, will use command: $ssh_command \"$uncompress $logf\"");
+				# Open a pipe to zcat program for compressed log
+				open($lfile, '-|', "$ssh_command \"$uncompress $logf\"") || localdie("FATAL: cannot read from pipe to $ssh_command \"$uncompress $logf\". $!\n");
+			} else {
+				&logmsg('DEBUG', "Compressed log file, will use command: $ssh_command \"$uncompress $logf\"");
+				# Open a pipe to zcat program for compressed log
+				open($lfile, '-|', "$ssh_command \"$sample_cmd -m 100 '[1234567890]' $logf\"") || localdie("FATAL: cannot read from pipe to $ssh_command \"$sample_cmd -m 100 '' $logf\". $!\n");
+			}
+		}
 
-		# Set some defaults.
-		$self->{query}       = ''   unless defined($self->{query});
-		$self->{spaces}      = 4    unless defined($self->{spaces});
-		$self->{space}       = ' '  unless defined($self->{space});
-		$self->{break}       = "\n" unless defined($self->{break});
-		$self->{break}       = ' '  unless ($self->{spaces} != 0);
-		$self->{wrap}        = {}   unless defined($self->{wrap});
-		$self->{keywords}    = []   unless defined($self->{keywords});
-		$self->{functions}   = []   unless defined($self->{functions});
-		$self->{rules}       = {}   unless defined($self->{rules});
-		$self->{uc_keywords} = 0    unless defined($self->{uc_keywords});
-		$self->{uc_functions}= 0    unless defined($self->{uc_functions});
-		$self->{no_comments} = 0    unless defined($self->{no_comments});
-
-		push @{$self->{keywords}}, KEYWORDS;
-		push @{$self->{functions}}, FUNCTIONS;
-
-		# Initialize internal stuff.
-		$self->{_level} = 0;
-        @{$self->{have_from_clause}} = qw( extract overlay substring trim );
 
-		return $self;
+		# Real size of the file is unknown, try to find it
+		# bz2 does not report real size
+		$totalsize = 0;
+		if ($logf =~ /\.(gz|zip|xz)$/i) {
+			my $cmd_file_size = $gzip_uncompress_size;
+			if ($logf =~ /\.zip$/i) {
+				$cmd_file_size = $zip_uncompress_size;
+			} elsif ($logf =~ /\.xz$/i) {
+				$cmd_file_size = $xz_uncompress_size;
+			}			
+			$cmd_file_size =~ s/\%f/$logf/g;
+			if (!$remote_host) {
+				&logmsg('DEBUG', "Looking for file size using command: $cmd_file_size");
+				$totalsize = `$cmd_file_size`;
+			} else {
+				&logmsg('DEBUG', "Looking for remote file size using command: $ssh_command $cmd_file_size");
+				$totalsize = `$ssh_command $cmd_file_size`;
+			}
+			chomp($totalsize);
+		}
+		$queue_size = 0;
 	}
 
-	# Add more SQL.
-	sub add
-	{
-		my ($self, $addendum) = @_;
+	# In list context returns the filehandle and the size of the file
+	if (wantarray()) {
+		return ($lfile, $totalsize, $iscompressed);
+	}
+	# In scalar context return size only
+	close($lfile);
 
-		$addendum =~ s/^\s*/ /;
+	return $totalsize;
+}
 
-		$self->{query} .= $addendum;
-	}
+sub split_logfile
+{
+	my $logf = shift;
+	my $saved_pos = shift;
 
-	# Set SQL to beautify.
-	sub query
-	{
-		my ($self, $query) = @_;
+	# CSV file can't be parsed using multiprocessing
+	return (0, -1) if ( $format eq 'csv' );
 
-		$self->{query} = $query if (defined($query));
+	# get file size
+	my $totalsize = (stat("$logf"))[7] || 0;
 
-		return $self->{query};
+	# Real size of a compressed file is unknown, try to find it
+	# bz2 does not report real size
+	if ($logf =~ /\.(gz|zip|xz)$/i) {
+		$totalsize = 0;
+		my $cmd_file_size = $gzip_uncompress_size;
+		if ($logf =~ /\.zip$/i) {
+			$cmd_file_size = $zip_uncompress_size;
+		} elsif ($logf =~ /\.xz$/i) {
+			$cmd_file_size = $xz_uncompress_size;
+		}
+		$cmd_file_size =~ s/\%f/$logf/g;
+		$totalsize = `$cmd_file_size`;
+		chomp($totalsize);
+		return (0, $totalsize) if ($totalsize);
+	} elsif ($logf =~ /\.bz2$/i) {
+		$totalsize = 0;
 	}
 
-	# Beautify SQL.
-	sub beautify
-	{
-		my ($self) = @_;
-
-		$self->{_output}	  = '';
-		$self->{_level_stack} = [];
-		$self->{_new_line}	= 1;
-		$self->{ '_is_in_create' } = 0;
-
-		my $last;
-		$self->{_tokens} = [tokenize_sql($self->query, 1)];
-
-		while (defined(my $token = $self->_token)) {
-			my $rule = $self->_get_rule($token);
-
-			if ($token =~ /^CREATE$/i) {
-				  $self->{ '_is_in_create' } = 1;
-			} elsif ($token =~ /^(AS|IS|RETURN)$/) {
-				  $self->{ '_is_in_create' } = 0;
-			}
-			# Allow custom rules to override defaults.
-			if ($rule) {
-				$self->_process_rule($rule, $token);
-			}
-
-			elsif ($token eq '(') {
-				$self->{ '_is_in_create' }++ if ($self->{ '_is_in_create' });
-				$self->_add_token($token);
-				if ((uc($last) eq 'AS') || ($self->{ '_is_in_create' } == 2)) {
-					$self->_new_line;
-				}
-				if (!$self->{'_is_in_function'} && $last && grep(/^\Q$last\E$/i, @KEYWORDS2)) {
-					$self->{'_is_in_function'} = 1;
-				} elsif ($self->{'_is_in_function'}) {
-					$self->{'_is_in_function'}++;
-				}
-				if ( ($self->_next_token ne ')') && ($self->_next_token ne '*') ) {
-					$self->{ '_has_from' } = 1 if ($last && grep(/^\Q$last\E$/i, @{$self->{have_from_clause}}));
-					push @{$self->{_level_stack}}, $self->{_level};
-					$self->_over unless $last and uc($last) eq 'WHERE';
-				}
-			}
-
-			elsif ($token eq ')') {
-				$self->{ '_is_in_create' }-- if ($self->{ '_is_in_create' });
-				$self->{ '_has_from' } = 0;
-				if ($self->{ '_is_in_function' }) {
-					$self->{ '_is_in_function' }--;
-				}
-				$self->_new_line if ($self->_next_token =~ /^SELECT$/i);
-				if ( ($last ne '(') && ($last ne '*') )  {
-					$self->{_level} = pop(@{$self->{_level_stack}}) || 0;
-				}
-				$self->_add_token($token);
-				if ($self->{ '_is_in_create' } <= 1) {
-					my $next_tok = quotemeta($self->_next_token);
-					$self->_new_line if ($self->_next_token
-							and $self->_next_token !~ /^AS$/i
-							and $self->_next_token ne ')'
-							and $self->_next_token !~ /::/
-							and $self->_next_token ne ';'
-							and $self->_next_token ne ','
-							and !exists $SYMBOLS{$next_tok}
-					);
-				}
-			}
-			elsif ($token eq ',') {
-				$self->_add_token($token);
-				$self->_new_line if (!$self->{ 'no_break' } && !$self->{ '_is_in_function' } && $self->_next_token !~ /^('|\-\-)/ && !$self->{ '_is_in_where' });
-			}
-
-			elsif ($token eq ';') {
-				$self->{ '_has_from' } = 0;
-				$self->{ '_is_in_where' } = 0;
-				$self->{ '_is_in_from' } = 0;
-				$self->{ '_is_an_update' } = 0;
-				$self->{ '_is_in_create' } = 0;
-				$self->_add_token($token);
-				$self->{break} = "\n" unless ($self->{spaces} != 0);
-				$self->_new_line;
-
-				# End of statement; remove all indentation.
-				@{$self->{_level_stack}} = ();
-				$self->{_level} = 0;
-				$self->{break} = ' ' unless ($self->{spaces} != 0);
-			}
-			elsif ($token =~ /^(?:SELECT|UPDATE|FROM|WHERE|HAVING|BEGIN|SET|RETURNING|VALUES)$/i) {
-
-			   $self->{ 'no_break' } = 0;
-
-			   if (($token =~ /^FROM$/i) && $self->{ '_has_from' } ) {
-				   $self->{ '_has_from' } = 0;
-					$self->_new_line;
-				   $self->_add_token( $token );
-					$self->_new_line;
-			   }
-			   else
-			   {
-				   # if we're not in a sub-select, make sure these always are
-				   # at the far left (col 1)
-				   $self->_back if ( $last and $last ne '(' and uc($last) ne 'FOR' and uc($last) ne 'KEY' );
-
-				   $self->_new_line if ( $last and uc($last) ne 'FOR' and uc($last) ne 'KEY' );
-				   $self->_add_token( $token );
-				   if ( $token !~ /^SET$/i || $self->{ '_is_an_update' } ) {
-					   $self->_new_line if ($self->_next_token and $self->_next_token ne '(' and $self->_next_token ne ';' );
-				   }
-				   $self->_over;
-			   }
-			   if ($token =~ /^UPDATE$/i and !$last) {
-				  $self->{ '_is_an_update' } = 1;
-			   }
-
-			   if ($token =~ /^WHERE$/i) {
-					$self->{ '_is_in_where' } = 1;
-					$self->{ 'is_in_from' } = 0;
-			   } else {
-					$self->{ '_is_in_where' } = 0;
-					if ($token =~ /^FROM$/i) {
-						$self->{ 'is_in_from' } = 1;
-					} else {
-						$self->{ 'is_in_from' } = 0;
-					}
-			   }
-			}
+	# Only uncompressed file can be splitted
+	return (0, -1) if (!$totalsize);
 
-			elsif ($token =~ /^(?:GROUP|ORDER|LIMIT)$/i) {
-				$self->_back;
-				$self->_new_line;
-				$self->_add_token($token);
-				$self->{ '_is_in_where' } = 0;
-				$self->{ '_is_in_from' } = 0;
+	my @chunks = (0);
+	# Seek to the last saved position
+	if ($last_parsed && $saved_pos) {
+		if ($saved_pos < $totalsize) {
+			$chunks[0] = $saved_pos;
+		}
+	}
+	# With small files splitting is inefficient
+	if ($totalsize <= 16777216) {
+		return ($chunks[0], $totalsize);
+	}
+	my $i = 1;
+	my ($lfile, $null) = &get_log_file($logf); # Get file handle to the file
+	if (defined) {
+		while ($i < $queue_size) {
+			my $pos = int(($totalsize/$queue_size) * $i);
+			if ($pos > $chunks[0]) {
+				$lfile->seek($pos, 0);
+				#Move the offset to the BEGINNING of each line, because the logic in process_file requires so
+				$pos= $pos + length(<$lfile>) - 1;
+				push(@chunks, $pos) if ($pos < $totalsize);
 			}
+			last if ($pos >= $totalsize);
+			$i++;
+		}
+		$lfile->close();
+	}
+	push(@chunks, $totalsize);
 
-			elsif ($token =~ /^(?:BY)$/i) {
-				$self->_add_token($token);
-				$self->_new_line;
-				$self->_over;
-			}
+	return @chunks;
+}
 
-			elsif ($token =~ /^(?:CASE)$/i) {
-				$self->_add_token($token);
-				$self->_over;
-			}
+# Return the week number of the year for a given date
+sub get_week_number
+{
+        my ($year, $month, $day) = @_;
 
-			elsif ($token =~ /^(?:WHEN)$/i) {
-				$self->_new_line;
-				$self->_add_token($token);
-			}
+#       %U     The week number of the current year as a decimal number, range 00 to 53, starting with the first
+#              Sunday as the first day of week 01.
+#       %V     The ISO 8601 week number (see NOTES) of the current year as a decimal number, range 01 to 53,
+#              where week 1 is the first week that has at least 4 days in the new year.
+#       %W     The week number of the current year as a decimal number, range 00 to 53, starting with the first
+#              Monday as the first day of week 01.
 
-			elsif ($token =~ /^(?:ELSE)$/i) {
-				$self->_new_line;
-				$self->_add_token($token);
-			}
+	# Check if the date is valid first
+	my $datefmt = POSIX::strftime("%Y-%m-%d", 1, 1, 1, $day, $month - 1, $year - 1900);
+	if ($datefmt ne "$year-$month-$day") {
+		return -1;
+	}
+	my $weekNumber = '';
+	if (!$week_start_monday) {
+		$weekNumber = POSIX::strftime("%U", 1, 1, 1, $day, $month - 1, $year - 1900);
+	} else {
+		$weekNumber = POSIX::strftime("%W", 1, 1, 1, $day, $month - 1, $year - 1900);
+	}
+	
 
-			elsif ($token =~ /^(?:END)$/i) {
-				$self->_back;
-				$self->_new_line;
-				$self->_add_token($token);
-			}
+	return sprintf("%02d", $weekNumber+1);
+}
 
-			elsif ($token =~ /^(?:UNION|INTERSECT|EXCEPT)$/i) {
-				$self->{ 'no_break' } = 0;
-				$self->_back unless $last and $last eq '(';
-				$self->_new_line;
-				$self->_add_token($token);
-				$self->_new_line if ($self->_next_token and $self->_next_token ne '(' and $self->_next_token !~ /^ALL$/i);
-				$self->_over;
-			}
+# Returns day number of the week of a given days
+sub get_day_of_week
+{
+        my ($year, $month, $day) = @_;
 
-			elsif ($token =~ /^(?:LEFT|RIGHT|INNER|OUTER|CROSS|NATURAL)$/i) {
-				$self->{ 'no_break' } = 0;
-				$self->_back unless $last and $last eq ')';
-				if ($token =~ /(?:LEFT|RIGHT|CROSS|NATURAL)$/i) {
-					$self->_new_line;
-					$self->_over if ($self->{_level} == 0);
-				}
-				if ( ($token =~ /(?:INNER|OUTER)$/i) && ($last !~ /(?:LEFT|RIGHT|CROSS|NATURAL)$/i) ) {
-					$self->_new_line;
-					$self->_over if ($self->{_level} == 0);
-				}
-				$self->_add_token($token);
-			}
+#       %w     The day of the week as a decimal, range 0 to 6, Sunday being 0.
 
-			elsif ($token =~ /^(?:JOIN)$/i) {
-				$self->{ 'no_break' } = 0;
-				if (!$last or $last !~ /^(?:LEFT|RIGHT|INNER|OUTER|CROSS|NATURAL)$/i) {
-					$self->_new_line;
-				}
-				$self->_add_token($token);
-				if ( $last && $last =~ /^(?:INNER|OUTER)$/i ) {
-					$self->_over;
-				}
-			}
+	my $weekDay = '';
+	if (!$week_start_monday) {
+		# Start on sunday = 0
+		$weekDay = POSIX::strftime("%w", 1,1,1,$day,--$month,$year-1900);
+	} else {
+		# Start on monday = 1
+		$weekDay = POSIX::strftime("%u", 1,1,1,$day,--$month,$year-1900);
+		$weekDay--;
+	}
 
-			elsif ($token =~ /^(?:AND|OR)$/i) {
-				$self->{ 'no_break' } = 0;
-				if (!$last or ($last !~ /^(?:CREATE)$/i) ) {
-					$self->_new_line;
-				}
-				$self->_add_token($token);
-			}
+	return $weekDay;
+}
 
-			elsif ($token =~ /^--/) {
-				if (!$self->{no_comments}) {
-					$self->_add_token($token);
-					$self->{break} = "\n" unless ($self->{spaces} != 0);
-					$self->_new_line;
-					$self->{break} = ' ' unless ($self->{spaces} != 0);
-				}
-			}
+# Returns all days following the week number
+sub get_wdays_per_month
+{
+	my $wn = shift;
+	my ($year, $month) = split(/\-/, shift);
+	my @months = ();
+	my @retdays = ();
 
-			elsif ($token =~ /^\/\*.*\*\/$/s) {
-				if (!$self->{no_comments}) {
-					$token =~ s/\n[\s\t]+\*/\n\*/gs;
-					$self->_new_line;
-					$self->_add_token($token);
-					$self->{break} = "\n" unless ($self->{spaces} != 0);
-					$self->_new_line;
-					$self->{break} = " " unless ($self->{spaces} != 0);
-				}
-			}
+	$month ||= '01';
+	push(@months, "$year$month");
+	my $start_month = $month;
+	if ($month eq '01') {
+		unshift(@months, ($year - 1) . "12");
+	} else {
+		unshift(@months, $year . sprintf("%02d", $month - 1));
+	}
+	if ($month == 12) {
+		push(@months, ($year+1) . "01");
+	} else {
+		push(@months, $year . sprintf("%02d", $month + 1));
+	}
 
-			elsif ($token =~ /^USING$/i) {
-				if (!$self->{ 'is_in_from' }) {
-					$self->_new_line;
-				} else {
-					# USING from join clause disable line break
-					$self->{ 'no_break' } = 1;
-				}
-				$self->_add_token($token);
+	foreach my $d (@months) {
+		$d =~ /^(\d{4})(\d{2})$/;
+		my $y = $1;
+		my $m = $2;
+		foreach my $day ("01" .. "31") {
+			# Check if the date is valid first
+			my $datefmt = POSIX::strftime("%Y-%m-%d", 1, 1, 1, $day, $m - 1, $y - 1900);
+			if ($datefmt ne "$y-$m-$day") {
+				next;
 			}
-
-			else {
-					$self->_add_token($token, $last);
+			my $weekNumber = '';
+			if (!$week_start_monday) {
+				$weekNumber = POSIX::strftime("%U", 1, 1, 1, $day, $m - 1, $y - 1900);
+			} else {
+				$weekNumber = POSIX::strftime("%W", 1, 1, 1, $day, $m - 1, $y - 1900);
 			}
-
-			$last = $token;
+			if ( ($weekNumber == $wn) || ( ($weekNumber eq '00') && (($wn == 1) || ($wn >= 52)) ) ) {
+				push(@retdays, "$year-$m-$day");
+				return @retdays if ($#retdays == 6);
+			}
+			next if ($weekNumber > $wn);
 		}
+	}
 
-		$self->_new_line;
-
-		$self->{_output};
+	return @retdays;
+}
 
-	}
+sub IsLeapYear
+{
+	return ((($_[0] & 3) == 0) && (($_[0] % 100 != 0) || ($_[0] % 400 == 0)));
+} 
 
-	# Add a token to the beautified string.
-	sub _add_token
-	{
-		my ($self, $token, $last_token) = @_;
+####
+# Display calendar
+####
+sub get_calendar
+{
+	my ($year, $month) = @_;
 
-		if ($self->{wrap}) {
-			my $wrap;
-			if ($self->_is_keyword($token)) {
-				$wrap = $self->{wrap}->{keywords};
-			} elsif ($self->_is_constant($token)) {
-				$wrap = $self->{wrap}->{constants};
+	my $str = "<table class=\"table table-striped table-hover table-condensed\">\n";
+	my @wday = qw(Su Mo Tu We Th Fr Sa);
+	my @std_day = qw(Su Mo Tu We Th Fr Sa);
+	if ($week_start_monday) {
+		@wday = qw(Mo Tu We Th Fr Sa Su);
+		@std_day = qw(Mo Tu We Th Fr Sa Su);
+	}
+	my %day_lbl = ();
+	for (my $i = 0; $i <= $#wday; $i++) {
+		$day_lbl{$wday[$i]} = $wday[$i];
+	}
+	$str .= "<thead><tr><td>&nbsp;</td>";
+	map { $str .= '<th>' . $day_lbl{$_} . '</th>'; } @wday;
+	$str .= "</tr></thead>\n<tbody>\n";
+	my @currow = ('','','','','','','');
+	my $wd = 0;
+	my $wn = 0;
+	my $week = '';
+	for my $d ("01" .. "31") {
+		last if (($d == 31) && grep(/^$month$/, '04','06','09','11'));
+		last if (($d == 30) && ($month eq '02'));
+		last if (($d == 29) && ($month eq '02') && !&IsLeapYear($year));
+		$wd = &get_day_of_week($year,$month,$d);
+		$wn =  &get_week_number($year,$month,$d);
+		next if ($wn == -1);
+		if ( !-e "$outdir/$year/$month/$d/index.html" ) {
+			$currow[$wd] = "<td>$d</td>";
+		} else {
+			$currow[$wd] = "<td><a href=\"$year/$month/$d/index.html\" target=\"new\">$d</a></td>";
+		}
+		if ($wd == 6) {
+			$week = sprintf("%02d", $wn);
+			if (-e "$outdir/$year/week-$week/index.html") {
+				$week = "<th><a href=\"$year/week-$week/index.html\" target=\"new\">$week</a>&nbsp;</th>";
+			} else {
+				$week = "<th>$week</th>";
 			}
-
-			if ($wrap) {
-					$token = $wrap->[0] . $token . $wrap->[1];
+			for (my $i = 0; $i <= $#currow; $i++) {
+				$currow[$i] = "<td>&nbsp;</td>" if ($currow[$i] eq '');
 			}
+			$str .= "<tr>$week" . join('', @currow) . "</tr>\n";
+			@currow = ('','','','','','','');
 		}
+	} 
+	if ( ($wd != 6) || ($currow[0] ne '') ) {
+		$week = sprintf("%02d", $wn);
+		if (-e "$outdir/$year/week-$week/index.html") {
+			$week = "<th><a href=\"$year/week-$week/index.html\" target=\"new\">$week</a>&nbsp;</th>";
+		} else {
+			$week = "<th>$week</th>";
+		}
+		for (my $i = 0; $i <= $#currow; $i++) {
+			$currow[$i] = "<td>&nbsp;</td>" if ($currow[$i] eq '');
+		}
+		$str .= "<tr>$week" . join('', @currow) . "</tr>\n";
+		@currow = ('','','','','','','');
+	}
+	$str .=  "</tbody>\n</table>\n";
 
-		my $last_is_dot = defined($last_token) && $last_token eq '.';
-
-		if (!$self->_is_punctuation($token) and !$last_is_dot) {
+	my %month_name = (
+		'01' => 'January', '02' => 'February', '03' => 'March', '04' => 'April',
+		'05' => 'May', '06' => 'June', '07' => 'July', '08' => 'August',
+		'09' => 'September', '10' => 'October', '11' => 'November', '12' => 'December'
+	);
+	return qq{
+              <div class="panel panel-default">
+                <div class="panel-heading">
+                <i class="fa fa-cogs fa-2x pull-left fa-border"></i>&nbsp;<h2>$month_name{$month}</h2>
+                </div>
+                <div class="panel-body">
+		$str
+                </div>
+              </div>
+};
 
-			my $sp = $self->_indent;
-			if ( (!defined($last_token) || $last_token ne '(') && $token ne ')' && ($token !~ /^::/) ) {
-			    $self->{ '_output' } .= $sp if ($token ne ')'
-							    && defined($last_token)
-							    && $last_token ne '::'
-							    && ($token ne '(' || !$self->_is_function( $last_token ))
-				);
-			    $self->{ '_output' } .= $sp if (!defined($last_token) && $token);
-			} elsif ( $self->{ '_is_in_create' } == 2 && defined($last_token)) {
-			    $self->{ '_output' } .= $sp if ($last_token ne '::' and ($last_token ne '(' || !$self->{ '_is_in_index' }));
-			}
-			$token =~ s/\n/\n$sp/gs;
+}
 
-		}
+sub _gethostbyaddr
+{
+	my $ip = shift;
 
-		# uppercase keywords
-		if ($self->{uc_keywords} && $self->_is_keyword($token)) {
-			$token = lc($token) if ($self->{uc_keywords} == 1);
-			$token = uc($token) if ($self->{uc_keywords} == 2);
-			$token = ucfirst(lc($token)) if ($self->{uc_keywords} == 3);
+	my $host = undef;
+	unless(exists $CACHE_DNS{$ip}) {
+		eval {
+			local $SIG{ALRM} = sub { die "DNS lookup timeout.\n"; };
+			alarm($DNSLookupTimeout);
+			$host = gethostbyaddr(inet_aton($ip), AF_INET);
+			alarm(0);
+		};
+		if ($@) {
+			$CACHE_DNS{$ip} = undef;
+			#printf "_gethostbyaddr timeout : %s\n", $ip;
 		}
-		# uppercase functions
-		if ($self->{uc_functions} && (my $fct = $self->_is_function($token))) {
-			$token =~ s/$fct/\L$fct\E/i if ($self->{uc_functions} == 1);
-			$token =~ s/$fct/\U$fct\E/i if ($self->{uc_functions} == 2);
-			$fct = ucfirst(lc($fct));
-			$token =~ s/$fct/$fct/i if ($self->{uc_functions} == 3);
+		else {
+			$CACHE_DNS{$ip} = $host;
+			#printf "_gethostbyaddr success : %s (%s)\n", $ip, $host;
 		}
-
-		$self->{_output} .= $token;
-		$self->{_output} =~ s/\(\s+\(/\(\(/gs;
-
-		# This can't be the beginning of a new line anymore.
-		$self->{_new_line} = 0;
 	}
 
-	# Increase the indentation level.
-	sub _over
-	{
-		my ($self) = @_;
+	return $CACHE_DNS{$ip} || $ip;
 
-		++$self->{_level};
-	}
+}
 
-	# Decrease the indentation level.
-	sub _back
-	{
-		my ($self) = @_;
+sub localdie
+{
+	my $msg = shift;
 
-		--$self->{_level} if ($self->{_level} > 0);
-	}
+	print STDERR "$msg";
+	unlink("$PID_FILE");
 
-	# Return a string of spaces according to the current indentation level and the
-	# spaces setting for indenting.
-	sub _indent
-	{
-		my ($self) = @_;
+	exit 1;
+}
 
-		if ($self->{_new_line}) {
-			return $self->{space} x ($self->{spaces} * $self->{_level});
-		} else {
-			return $self->{space};
+sub skip_unwanted_line
+{
+
+	# Skip unwanted lines
+	if ($#exclude_time >= 0) {
+		my $found = 0;
+		foreach (@exclude_time) {
+			if ($prefix_vars{'t_timestamp'} =~ /$_/) {
+				$found = 1;
+				last;
+			}
 		}
+		return 1 if ($found);
 	}
 
-	# Add a line break, but make sure there are no empty lines.
-	sub _new_line
-	{
-		my ($self) = @_;
-
-		$self->{_output} .= $self->{break} unless ($self->{_new_line});
-		$self->{_new_line} = 1;
+	if ($#include_time >= 0) {
+		my $found = 0;
+		foreach (@include_time) {
+			if ($prefix_vars{'t_timestamp'} !~ /$_/) {
+				$found = 1;
+				last;
+			}
+        }
+		return 1 if ($found);
 	}
 
-	# Have a look at the token that's coming up next.
-	sub _next_token
-	{
-		my ($self) = @_;
-
-		return @{$self->{_tokens}} ? $self->{_tokens}->[0] : undef;
-	}
 
-	# Get the next token, removing it from the list of remaining tokens.
-	sub _token
-	{
-		my ($self) = @_;
+	return 1 if ($from && ($from gt $prefix_vars{'t_timestamp'}));
 
-		return shift @{$self->{_tokens}};
+	if ($to   && ($to lt $prefix_vars{'t_timestamp'})) {
+		return -1;
 	}
 
-	# Check if a token is a known SQL keyword.
-	sub _is_keyword
-	{
-		my ($self, $token) = @_;
+	return 0;
+}
 
-		return ~~ grep {$_ eq uc($token)} @{$self->{keywords}};
-	}
+sub change_timezone
+{
+	my ($y, $mo, $d, $h, $mi, $s) = @_;
 
-	# Check if a token is a known SQL function.
-	sub _is_function
-	{
-		my ($self, $token) = @_;
+	my $t = timegm_nocheck($s, $mi, $h, $d, $mo-1, $y-1900);
+	$t += $log_timezone;
+	($s, $mi, $h, $d, $mo, $y) = localtime($t);
 
-		my @ret = grep($token =~ /\b[\.]*$_$/i, @{$self->{functions}});
+	return ($y+1900, sprintf("%02d", ++$mo), sprintf("%02d", $d), sprintf("%02d", $h), sprintf("%02d", $mi), sprintf("%02d", $s));
+}
 
-		return $ret[0];
-	}
+# Inclusion of Perl package pgFormatter::Beautify.
+{
 
-	# Add new keywords to highlight.
-	sub add_keywords
-	{
-		my $self = shift;
+package pgFormatter::Beautify;
 
-		for my $keyword (@_) {
-			push @{$self->{keywords}}, ref($keyword) ? @{$keyword} : $keyword;
-		}
-	}
+use strict;
+use warnings;
+use warnings qw( FATAL );
+use Encode qw( decode );
 
-	# Add new functions to highlight.
-	sub add_functions
-	{
-		my $self = shift;
+# PostgreSQL functions that use a FROM clause
+our @have_from_clause = qw( extract overlay substring trim );
 
-		for my $function (@_) {
-			push @{$self->{functions}}, ref($function) ? @{$function} : $function;
-		}
-	}
+# Version of pgFormatter
+our $VERSION = '3.0';
 
-	# Add new rules.
-	sub add_rule
-	{
-		my ($self, $format, $token) = @_;
+# Inclusion of code from Perl package SQL::Beautify
+# Copyright (C) 2009 by Jonas Kramer
+# Published under the terms of the Artistic License 2.0.
 
-		my $rules = $self->{rules}    ||= {};
-		my $group = $rules->{$format} ||= [];
+sub new {
+    my $class   = shift;
+    my %options = @_;
 
-		push @{$group}, ref($token) ? @{$token} : $token;
-	}
+    my $self = bless {}, $class;
+    $self->set_defaults();
 
-	# Find custom rule for a token.
-	sub _get_rule
-	{
-		my ($self, $token) = @_;
+    for my $key ( qw( query spaces space break wrap keywords functions rules uc_keywords uc_functions no_comments placeholder separator comma comma_break format colorize) ) {
+        $self->{ $key } = $options{ $key } if defined $options{ $key };
+    }
 
-		values %{$self->{rules}};    # Reset iterator.
+    # Make sure "break" is sensible
+    $self->{ 'break' } = ' ' if $self->{ 'spaces' } == 0;
 
-		while (my ($rule, $list) = each %{$self->{rules}}) {
-			return $rule if (grep {uc($token) eq uc($_)} @$list);
-		}
+    # Initialize internal stuff.
+    $self->{ '_level' } = 0;
 
-		return;
-	}
+    # Array to store placeholders values
+    @{ $self->{ 'placeholder_values' } } = ();
 
-	sub _process_rule
-	{
-		my ($self, $rule, $token) = @_;
+    # Hash to store dynamic code
+    %{ $self->{ 'dynamic_code' } } = ();
 
-		my $format = {
-			break => sub {$self->_new_line},
-			over  => sub {$self->_over},
-			back  => sub {$self->_back},
-			token => sub {$self->_add_token($token)},
-			push  => sub {push @{$self->{_level_stack}}, $self->{_level}},
-			pop   => sub {$self->{_level} = pop(@{$self->{_level_stack}}) || 0},
-			reset => sub {$self->{_level} = 0; @{$self->{_level_stack}} = ();},
-		};
+    # Check comma value, when invalid set to default: end
+    if (lc($self->{ 'comma' }) ne 'start') {
+        $self->{ 'comma' } = 'end';
+    } else {
+        $self->{ 'comma' } = lc($self->{ 'comma' });
+    }
 
-		for (split /-/, lc $rule) {
-			&{$format->{$_}} if ($format->{$_});
-		}
-	}
+    $self->{ 'format' } //= 'text';
+    $self->{ 'colorize' } //= 1;
 
-	# Check if a token is a constant.
-	sub _is_constant
-	{
-		my ($self, $token) = @_;
+    return $self;
+}
 
-		return ($token =~ /^\d+$/ or $token =~ /^(['"`]).*\1$/);
-	}
+sub query {
+    my $self      = shift;
+    my $new_value = shift;
 
-	# Check if a token is punctuation.
-	sub _is_punctuation
-	{
-		my ($self, $token) = @_;
-		return ($token =~ /^[,;.]$/);
-	}
+    $self->{ 'query' } = $new_value if defined $new_value;
 
-}
+    # Store values of code that must not be changed following the given placeholder
+    if ($self->{ 'placeholder' }) {
+        my $i = 0;
+        while ( $self->{ 'query' } =~ s/($self->{ 'placeholder' })/PLACEHOLDER${i}PLACEHOLDER/) {
+            push(@{ $self->{ 'placeholder_values' } }, $1);
+            $i++;
+       }
+    }
 
-sub get_log_file
-{
-	my $logf = shift;
-	my $sample_only = shift;
+    # Replace dynamic code with placeholder
+    $self->_remove_dynamic_code( \$self->{ 'query' }, $self->{ 'separator' } );
 
-	my $lfile = undef;
+    return $self->{ 'query' };
+}
 
-	chomp($logf);
+sub content {
+    my $self      = shift;
+    my $new_value = shift;
 
-	# get file size
-	my $totalsize = 0;
-	if ( $journalctl_cmd && ($logf =~ m/\Q$journalctl_cmd\E/) ) {
-		$totalsize = 0;
-	} elsif (!$remote_host) {
-		$totalsize = (stat("$logf"))[7] || 0 if ($logf ne '-');
-	} elsif ($logf !~ /\.(gz|bz2|zip|xz)$/i) {
-		&logmsg('DEBUG', "Looking for file size using command: $ssh_command \"ls -l $logf\" | awk '{print \$5}'");
-		$totalsize = `$ssh_command "ls -l $logf" | awk '{print \$5}'`;
-		chomp($totalsize);
-		if ($totalsize eq '') {
-			localdie("FATAL: can't get size of remote file, please check what's going wrong with command: $ssh_command \"ls -l $logf\" | awk '{print \$5}'\n");
-		}
-		&logmsg('DEBUG', "Remote file size: $totalsize");
-		if (!$totalsize) {
-			return $totalsize;
-		}
-	}
-	my $iscompressed = 1;
+    $self->{ 'content' } = $new_value if defined $new_value;
 
-	# Open a file handle
-	if ( $journalctl_cmd && ($logf =~ m/\Q$journalctl_cmd\E/) ) {
-		# For journalctl command we need to use a pipe as file handle
-		if (!$remote_host) {
-			open($lfile, "$logf |") || localdie("FATAL: cannot read output of commanf: $logf. $!\n");
-		} else {
-			if (!$sample_only) {
-				&logmsg('DEBUG', "Retrieving log entries using command: $ssh_command \"$logf\" |");
-				# Open a pipe to remote journalctl program
-				open($lfile,"$ssh_command \"$logf\" |") || localdie("FATAL: cannot read from pipe to $ssh_command \"$logf\". $!\n");
-			} else {
-				&logmsg('DEBUG', "Retrieving log entries using command: $ssh_command \"$logf -n 100\" |");
-				# Open a pipe to remote journalctl program
-				open($lfile,"$ssh_command \"$logf -n 100\" |") || localdie("FATAL: cannot read from pipe to $ssh_command \"$logf -n 100\". $!\n");
-			}
-		}
-		$iscompressed = 0;
-	} elsif ($logf !~ /\.(gz|bz2|zip|xz)$/i) {
-		if (!$remote_host) {
-			open($lfile, $logf) || localdie("FATAL: cannot read log file $logf. $!\n");
-		} else {
-			if (!$sample_only) {
-				&logmsg('DEBUG', "Retrieving log entries using command: $ssh_command \" cat $logf\" |");
-				# Open a pipe to cat program
-				open($lfile,"$ssh_command \"cat $logf\" |") || localdie("FATAL: cannot read from pipe to $ssh_command \"cat $logf\". $!\n");
-			} else {
-				# Open a pipe to cat program
-				open($lfile,"$ssh_command \"tail -n 100 $logf\" |") || localdie("FATAL: cannot read from pipe to $ssh_command \"tail -n 100 $logf\". $!\n");
-			}
-		}
-		$totalsize = 0 if ($logf eq '-');
-		$iscompressed = 0;
-	} else {
-		my $uncompress = $zcat;
-		my $sample_cmd = 'zgrep';
-		if (($logf =~ /\.bz2/i) && ($zcat =~ /^$zcat_cmd$/)) {
-			$uncompress = $bzcat;
-			$sample_cmd = 'bzgrep';
-		} elsif (($logf =~ /\.zip/i) && ($zcat =~ /^$zcat_cmd$/)) {
-			$uncompress = $ucat;
-		}
-		elsif (($logf =~ /\.xz/i) && ($zcat =~ /^$zcat_cmd$/)) {
-			$uncompress = $xzcat;
-			$sample_cmd = 'xzgrep';
-		}
-		if (!$remote_host) {
-			&logmsg('DEBUG', "Compressed log file, will use command: $uncompress \"$logf\"");
-			# Open a pipe to zcat program for compressed log
-			open($lfile,"$uncompress \"$logf\" |") || localdie("FATAL: cannot read from pipe to $uncompress \"$logf\". $!\n");
-		} else {
-			if (!$sample_only) {
-				&logmsg('DEBUG', "Compressed log file, will use command: $ssh_command \"$uncompress $logf\"");
-				# Open a pipe to zcat program for compressed log
-				open($lfile,"$ssh_command \"$uncompress $logf\" |") || localdie("FATAL: cannot read from pipe to $ssh_command \"$uncompress $logf\". $!\n");
-			} else {
-				&logmsg('DEBUG', "Compressed log file, will use command: $ssh_command \"$uncompress $logf\"");
-				# Open a pipe to zcat program for compressed log
-				open($lfile,"$ssh_command \"$sample_cmd -m 100 '[1234567890]' $logf\" |") || localdie("FATAL: cannot read from pipe to $ssh_command \"$sample_cmd -m 100 '' $logf\". $!\n");
-			}
-		}
+    # Hide comment beside a placeholder for easy parsing: OBSOLETE
+    #$self->_remove_comments( \$self->{ 'content' } );
 
+    # Replace placeholders with their original dynamic code
+    $self->_restore_dynamic_code( \$self->{ 'content' } );
 
-		# Real size of the file is unknown, try to find it
-		# bz2 does not report real size
-		$totalsize = 0;
-		if ($logf =~ /\.(gz|zip|xz)$/i) {
-			my $cmd_file_size = $gzip_uncompress_size;
-			if ($logf =~ /\.zip$/i) {
-				$cmd_file_size = $zip_uncompress_size;
-			} elsif ($logf =~ /\.xz$/i) {
-				$cmd_file_size = $xz_uncompress_size;
-			}			
-			$cmd_file_size =~ s/\%f/$logf/g;
-			if (!$remote_host) {
-				&logmsg('DEBUG', "Looking for file size using command: $cmd_file_size");
-				$totalsize = `$cmd_file_size`;
-			} else {
-				&logmsg('DEBUG', "Looking for remote file size using command: $ssh_command $cmd_file_size");
-				$totalsize = `$ssh_command $cmd_file_size`;
-			}
-			chomp($totalsize);
-		}
-		$queue_size = 0;
-	}
+    # Restore comments inplace: OBSOLETE
+    #$self->_restore_comments(\$self->{ 'content' });
 
-	# In list context returns the filehandle and the size of the file
-	if (wantarray()) {
-		return ($lfile, $totalsize, $iscompressed);
-	}
-	# In scalar context return size only
-	close($lfile);
+    # Replace placeholders by their original values
+    if ($self->{ 'placeholder' }) {
+        $self->{ 'content' } =~ s/PLACEHOLDER(\d+)PLACEHOLDER/$self->{ 'placeholder_values' }[$1]/igs;
+    }
 
-	return $totalsize;
+    return $self->{ 'content' };
 }
 
-sub split_logfile
-{
-	my $logf = shift;
-	my $saved_pos = shift;
-
-	# CSV file can't be parsed using multiprocessing
-	return (0, -1) if ( $format eq 'csv' );
+sub highlight_code {
+    my ($self, $token, $last_token, $next_token) = @_;
 
-	# get file size
-	my $totalsize = (stat("$logf"))[7] || 0;
+    # Do not use uninitialized variable
+    $last_token //= '';
+    $next_token //= '';
 
-	# Real size of a compressed file is unknown, try to find it
-	# bz2 does not report real size
-	if ($logf =~ /\.(gz|zip|xz)$/i) {
-		$totalsize = 0;
-		my $cmd_file_size = $gzip_uncompress_size;
-		if ($logf =~ /\.zip$/i) {
-			$cmd_file_size = $zip_uncompress_size;
-		} elsif ($logf =~ /\.xz$/i) {
-			$cmd_file_size = $xz_uncompress_size;
-		}
-		$cmd_file_size =~ s/\%f/$logf/g;
-		$totalsize = `$cmd_file_size`;
-		chomp($totalsize);
-		return (0, $totalsize) if ($totalsize);
-	} elsif ($logf =~ /\.bz2$/i) {
-		$totalsize = 0;
+    # Colorize operators
+    while ( my ( $k, $v ) = each %{ $self->{ 'dict' }->{ 'symbols' } } ) {
+        if ($token eq $k) {
+            $token = '<span class="sy0">' . $v . '</span>';
+	    return $token;
 	}
+    }
 
-	# Only uncompressed file can be splitted
-	return (0, -1) if (!$totalsize);
-
-	my @chunks = (0);
-	# Seek to the last saved position
-	if ($last_parsed && $saved_pos) {
-		if ($saved_pos < $totalsize) {
-			$chunks[0] = $saved_pos;
-		}
+    # lowercase/uppercase keywords
+    if ( $self->_is_keyword( $token ) ) {
+	if ( $self->{ 'uc_keywords' } == 1 ) {
+		$token = '<span class="kw1_l">' . $token . '</span>';
+	} elsif ( $self->{ 'uc_keywords' } == 2 ) {
+		$token = '<span class="kw1_u">' . $token . '</span>';
+	} elsif ( $self->{ 'uc_keywords' } == 3 ) {
+		$token = '<span class="kw1_c">' . $token . '</span>';
+	} else {
+		$token = '<span class="kw1">' . $token . '</span>';
 	}
-	# With small files splitting is inefficient
-	if ($totalsize <= 16777216) {
-		return ($chunks[0], $totalsize);
+	return $token;
+    }
+
+    # lowercase/uppercase known functions or words followed by an open parenthesis if the token is not an open parenthesis
+    if ($self->_is_function( $token ) || (!$self->_is_keyword( $token ) && $next_token eq '(' && $token ne '(' && !$self->_is_comment( $token )) ) {
+	if ($self->{ 'uc_functions' } == 1) {
+		$token = '<span class="kw2_l">' . $token . '</span>';
+	} elsif ($self->{ 'uc_functions' } == 2) {
+		$token = '<span class="kw2_u">' . $token . '</span>';
+	} elsif ($self->{ 'uc_functions' } == 3) {
+		$token = '<span class="kw2_c">' . $token . '</span>';
+	} else {
+		$token = '<span class="kw2">' . $token . '</span>';
 	}
-	my $i = 1;
-	my ($lfile, $null) = &get_log_file($logf); # Get file handle to the file
-	while ($i < $queue_size) {
-		my $pos = int(($totalsize/$queue_size) * $i);
-		if ($pos > $chunks[0]) {
-			$lfile->seek($pos, 0);
-			#Move the offset to the BEGINNING of each line, because the logic in process_file requires so
-			$pos= $pos + length(<$lfile>) - 1;
-			push(@chunks, $pos) if ($pos < $totalsize);
-		}
-		last if ($pos >= $totalsize);
-		$i++;
+	return $token;
+    }
+
+    # Colorize STDIN/STDOUT in COPY statement
+    if ( grep(/^\Q$token\E$/i, @{ $self->{ 'dict' }->{ 'copy_keywords' } }) ) {
+	if ($self->{ 'uc_keywords' } == 1) {
+		$token = '<span class="kw3_!">' . $token . '</span>';
+	} elsif ($self->{ 'uc_keywords' } == 2) {
+		$token = '<span class="kw3_u">' . $token . '</span>';
+	} elsif ($self->{ 'uc_keywords' } == 3) {
+		$token = '<span class="kw3_c">' . $token . '</span>';
+	} else {
+		$token = '<span class="kw3">' . $token . '</span>';
 	}
-	$lfile->close();
-	push(@chunks, $totalsize);
+	return $token;
+    }
 
-	return @chunks;
-}
+    # Colorize parenthesis
+    if ( grep(/^\Q$token\E$/i, @{ $self->{ 'dict' }->{ 'brackets' } }) ) {
+        $token = '<span class="br0">' . $token . '</span>';
+	return $token;
+    }
+
+    # Colorize comment
+    if ( $self->_is_comment( $token ) ) {
+        $token = '<span class="br1">' . $token . '</span>';
+	return $token;
+    }
+
+    # Colorize numbers
+    $token =~ s/\b(\d+)\b/<span class="nu0">$1<\/span>/igs;
+
+    # Colorize string
+    $token =~ s/('.*?(?<!\\)')/<span class="st0">$1<\/span>/gs;
+    $token =~ s/(`[^`]*`)/<span class="st0">$1<\/span>/gs;
+
+    return $token;
+}
+
+sub tokenize_sql {
+    my $self  = shift;
+    my $query = $self->query();
+
+    my $re = qr{
+        (
+                (?:\\(?:copyright|errverbose|g|gx|gexec|gset|q|crosstabview|watch|\?|h|e|ef|ev|p|r|s|w|copy|echo|i|ir|o|qecho|if|elif|else|endif|d(?:[aAbcCdDfFgilLmnoOpstTuvExy]|dp|et|es|eu|ew|fa|fn|ft|fw|Fd|Fp|Ft|rds|Rp|Rs)?S?\+?|l\+?|sf\+?|sv\+?|z|a|C|f|H|pset|t|T|x|c|connect|encoding|password|conninfo|cd|setenv|timing|\!|prompt|set|unset|lo_export|lo_import|lo_list|lo_unlink))(?:$|[\n]|[\ \t](?:(?!\\\\)[\ \t\S])*)        # psql meta-command
+                |
+                (?:--)[\ \t\S]*      # single line comments
+                |
+                (?:\-\|\-) # range operator "is adjacent to"
+                |
+                (?:\->>|\->|\#>>|\#>|\?\&|\?)  # Json Operators
+                |
+                (?:\#<=|\#>=|\#<>|\#<|\#=) # compares tinterval and reltime
+                |
+                (?:>>=|<<=) # inet operators
+                |
+                (?:!!|\@\@\@) # deprecated factorial and full text search  operators
+                |
+                (?:\|\|\/|\|\/) # square root and cube root
+                |
+                (?:\@\-\@|\@\@|\#\#|<\->|<<\||\|>>|\&<\||\&<|\|\&>|\&>|<\^|>\^|\?\#|\#|\?<\||\?\-\||\?\-|\?\|\||\?\||\@>|<\@|\~=)
+                                 # Geometric Operators
+                |
+                (?:~<=~|~>=~|~>~|~<~) # string comparison for pattern matching operator families
+                |
+                (?:!~~|!~~\*|~~\*|~~) # LIKE operators
+                |
+                (?:!~\*|!~|~\*) # regular expression operators
+                |
+                (?:\*=|\*<>|\*<=|\*>=|\*<|\*>) # composite type comparison operators
+                |
+                (?:<>|<=>|>=|<=|==|!=|:=|=|!|<<|>>|<|>|\|\||\||&&|&|-|\+|\*(?!/)|/(?!\*)|\%|~|\^|\?) # operators and tests
+                |
+                [\[\]\(\),;.]            # punctuation (parenthesis, comma)
+                |
+                E\'\'(?!\')              # empty single escaped quoted string
+                |
+                \'\'(?!\')              # empty single quoted string
+                |
+                \"\"(?!\"")             # empty double quoted string
+                |
+                "(?>(?:(?>[^"\\]+)|""|\\.)*)+" # anything inside double quotes, ungreedy
+                |
+                `(?>(?:(?>[^`\\]+)|``|\\.)*)+` # anything inside backticks quotes, ungreedy
+                |
+                E'(?>(?:(?>[^'\\]+)|''|\\.)*)+' # anything escaped inside single quotes, ungreedy.
+                |
+                '(?>(?:(?>[^'\\]+)|''|\\.)*)+' # anything inside single quotes, ungreedy.
+                |
+                /\*[\ \t\r\n\S]*?\*/      # C style comments
+                |
+                (?:[\w:@]+(?:\.(?:\w+|\*)?)*) # words, standard named placeholders, db.table.*, db.*
+                |
+                (?:\$\w+\$)
+                |
+                (?: \$_\$ | \$\d+ | \${1,2} | \$\w+\$ ) # dollar expressions - eg $_$ $3 $$ $BODY$
+                |
+                \n                      # newline
+                |
+                [\t\ ]+                 # any kind of white spaces
+        )
+    }smx;
+
+    my @query = ();
+    @query = grep { /\S/ } $query =~ m{$re}smxg;
+    $self->{ '_tokens' } = \@query;
+
+    return @query;
+}
+
+sub beautify {
+    my $self = shift;
+
+    # Use to store the token position in the array
+    my $pos = 0;
+
+    # Main variables used to store differents state
+    $self->content( '' );
+    $self->{ '_level_stack' } = [];
+    $self->{ '_level_parenthesis' } = [];
+    $self->{ '_new_line' }    = 1;
+    $self->{ '_current_sql_stmt' } = '';
+    $self->{ '_is_meta_command' } = 0;
+    $self->{ '_fct_code_delimiter' } = '';
+    $self->{ '_first_when_in_case' } = 0;
+
+    $self->{ '_has_from' } = 0;
+    $self->{ '_is_in_case' } = 0;
+    $self->{ '_is_in_where' } = 0;
+    $self->{ '_is_in_from' } = 0;
+    $self->{ '_is_in_join' } = 0;
+    $self->{ '_is_in_create' } = 0;
+    $self->{ '_is_in_type' } = 0;
+    $self->{ '_is_in_declare' } = 0;
+    $self->{ '_is_in_block' } = -1;
+    $self->{ '_is_in_function' } = 0;
+    $self->{ '_is_in_index' } = 0;
+    $self->{ '_is_in_with' }  = 0;
+    $self->{ '_parenthesis_level' } = 0;
+    $self->{ '_parenthesis_function_level' } = 0;
+    $self->{ '_has_order_by' }  = 0;
+    $self->{ '_has_over_in_join' } = 0;
 
-# Return the week number of the year for a given date
-sub get_week_number
-{
-        my ($year, $month, $day) = @_;
+    my $last = '';
+    my @token_array = $self->tokenize_sql();
 
-#       %U     The week number of the current year as a decimal number, range 00 to 53, starting with the first
-#              Sunday as the first day of week 01.
-#       %V     The ISO 8601 week number (see NOTES) of the current year as a decimal number, range 01 to 53,
-#              where week 1 is the first week that has at least 4 days in the new year.
-#       %W     The week number of the current year as a decimal number, range 00 to 53, starting with the first
-#              Monday as the first day of week 01.
+    while ( defined( my $token = $self->_token ) ) {
+        my $rule = $self->_get_rule( $token );
 
-	# Check if the date is valid first
-	my $datefmt = POSIX::strftime("%Y-%m-%d", 1, 1, 1, $day, $month - 1, $year - 1900);
-	if ($datefmt ne "$year-$month-$day") {
-		return -1;
-	}
-	my $weekNumber = '';
-	if (!$week_start_monday) {
-		$weekNumber = POSIX::strftime("%U", 1, 1, 1, $day, $month - 1, $year - 1900);
-	} else {
-		$weekNumber = POSIX::strftime("%W", 1, 1, 1, $day, $month - 1, $year - 1900);
-	}
-	
+	####
+	# Find if the current keyword is a known function name
+	####
+        if (defined $last && $last && defined $self->_next_token and $self->_next_token eq '(') {
+	    my $word = $token;
+	    $word =~ s/^[^\.]+\.//;
+	    if ($word && grep(/^\Q$word\E$/i, @{$self->{ 'dict' }->{ 'pg_functions' }})) {
+	        $self->{ '_is_in_function' }++;
+	    }
+        }
 
-	return sprintf("%02d", $weekNumber+1);
-}
+	####
+        # Set open parenthesis position to know if we
+	# are in subqueries or function parameters
+	####
+        if ( $token eq ')')
+        {
+            if (!$self->{ '_is_in_function' }) {
+                $self->{ '_parenthesis_level' }--;
+            } else {
+                $self->{ '_parenthesis_function_level' }--;
+            }
+            $self->{ '_is_in_function' } = 0 if (!$self->{ '_parenthesis_function_level' });
+        }
+        elsif ( $token eq '(')
+        {
+            if ($self->{ '_is_in_function' }) {
+                $self->{ '_parenthesis_function_level' }++;
+            } else {
+                if (!$self->{ '_parenthesis_level' } && $self->{ '_is_in_from' }) {
+                    push(@{ $self->{ '_level_parenthesis' } } , $self->{ '_level' });
+                }
+                $self->{ '_parenthesis_level' }++;
+            }
+        }
 
-# Returns day number of the week of a given days
-sub get_day_of_week
-{
-        my ($year, $month, $day) = @_;
+	####
+	# Control case where we have to add a newline, go back and
+	# reset indentation after the last ) in the WITH statement
+	####
+	if ($token =~ /^WITH$/i && (!defined $last || $last ne ')')) {
+            $self->{ '_is_in_with' } = 1;
+        }
+        elsif ($token =~ /^(AS|IS)$/i && defined $self->_next_token && $self->_next_token eq '(') {
+            $self->{ '_is_in_with' }++ if ($self->{ '_is_in_with' } == 1);
+        }
+	elsif ( $token eq ')' ) {
+	    $self->{ '_has_order_by' } = 0;
+            $self->{ '_has_from' } = 0;
+            if ($self->{ '_is_in_with' } > 1 && !$self->{ '_parenthesis_level' }) {
+		$self->_new_line;
+                $self->_back;
+                $self->_add_token( $token );
+                @{ $self->{ '_level_stack' } } = ();
+                $self->{ '_level' } = 0;
+                $self->{ 'break' } = ' ' unless ( $self->{ 'spaces' } != 0 );
+		if ($self->{ '_is_in_with' }) {
+		    if (defined $self->_next_token && $self->_next_token eq ',') {
+			$self->{ '_is_in_with' } = 1;
+		    } else {
+			$self->{ '_is_in_with' } = 0;
+		    }
+	        }
+		next;
+            }
+	}
 
-#       %w     The day of the week as a decimal, range 0 to 6, Sunday being 0.
+	####
+	# Set the current kind of statement parsed
+	####
+        if ($token =~ /^(FUNCTION|PROCEDURE|SEQUENCE|INSERT|DELETE|UPDATE|SELECT|RAISE|ALTER|GRANT|REVOKE)$/i) {
+	    my $k_stmt = uc($1);
+	    # Set current statement with taking care to exclude of SELECT ... FOR UPDATE statement.
+            if ($k_stmt ne 'UPDATE' or (defined $self->_next_token and $self->_next_token ne ';' and $self->_next_token ne ')')) {
+                $self->{ '_current_sql_stmt' } = $k_stmt if ($self->{ '_current_sql_stmt' } !~ /^(GRANT|REVOKE)$/i);
+	    }
+        }
 
-	my $weekDay = '';
-	if (!$week_start_monday) {
-		# Start on sunday = 0
-		$weekDay = POSIX::strftime("%w", 1,1,1,$day,--$month,$year-1900);
-	} else {
-		# Start on monday = 1
-		$weekDay = POSIX::strftime("%u", 1,1,1,$day,--$month,$year-1900);
-		$weekDay--;
+	####
+	# Mark that we are in CREATE statement that need newline
+	# after a comma in the parameter, declare or column lists.
+	####
+        if ($token =~ /^CREATE$/i && $self->_next_token !~ /^(UNIQUE|INDEX|EXTENSION|TYPE)$/i) {
+            $self->{ '_is_in_create' } = 1;
+        } elsif ($token =~ /^CREATE$/i && $self->_next_token =~ /^TYPE$/i) {
+            $self->{ '_is_in_type' } = 1;
+        }
+
+	####
+	# Mark that we are in index/constraint creation statement to
+	# avoid inserting a newline after comma and AND/OR keywords.
+        # This also used in SET statement taking care that we are not
+	# in update statement. CREATE statement are not subject to this rule
+	####
+        if (! $self->{ '_is_in_create' } and $token =~ /^(INDEX|PRIMARY|CONSTRAINT)$/i) {
+            $self->{ '_is_in_index' } = 1;
+        } elsif (! $self->{ '_is_in_create' } and uc($token) eq 'SET') {
+            $self->{ '_is_in_index' } = 1 if ($self->{ '_current_sql_stmt' } ne 'UPDATE');
+        }
+        # Same as above but for ALTER FUNCTION/PROCEDURE/SEQUENCE or when
+	# we are in a CREATE FUNCTION/PROCEDURE statement
+        elsif ($token =~ /^(FUNCTION|PROCEDURE|SEQUENCE)$/i) {
+            $self->{ '_is_in_index' } = 1 if (uc($last) eq 'ALTER');
+            if ($token =~ /^(FUNCTION|PROCEDURE)$/i && $self->{ '_is_in_create' }) {
+                $self->{ '_is_in_index' } = 1;
+            }
+        }
+        # Desactivate index like formatting when RETURN(S) keyword is found
+        elsif ($token =~ /^(RETURN|RETURNS)$/i) {
+            $self->{ '_is_in_index' } = 0;
 	}
 
-	return $weekDay;
-}
+	####
+	# Mark statements that use string_agg() or group_concat() function
+	# as statement that can have an ORDER BY clause inside the call to
+	# prevent applying order by formatting.
+	####
+	if ($token =~ /^(string_agg|group_concat)$/i) {
+	    $self->{ '_has_order_by' } = 1;
+        } elsif ( $self->{ '_has_order_by' } and uc($token) eq 'ORDER' and $self->_next_token =~ /^BY$/i) {
+	    $self->_add_token( $token );
+            $last = $token;
+            next;
+        } elsif ($self->{ '_has_order_by' } and uc($token) eq 'BY') {
+	    $self->_add_token( $token );
+            $self->{ '_has_order_by' } = 0;
+            next;
+        }
 
-# Returns all days following the week number
-sub get_wdays_per_month
-{
-	my $wn = shift;
-	my ($year, $month) = split(/\-/, shift);
-	my @months = ();
-	my @retdays = ();
+	####
+	# Set function code delimiter, it can be any string found after
+	# the AS keyword in function or procedure creation code
+	####
+        # Toogle _fct_code_delimiter to force next token to be stored as the function code delimiter
+        if (uc($token) eq 'AS' and !$self->{ '_fct_code_delimiter' }
+		and $self->{ '_current_sql_stmt' } =~ /^(FUNCTION|PROCEDURE)$/i) {
+
+            if ($self->{ '_is_in_create' }) {
+                $self->_new_line;
+                @{ $self->{ '_level_stack' } } = ();
+                $self->{ '_level' } = 0;
+                $self->{ 'break' } = ' ' unless ( $self->{ 'spaces' } != 0 );
+                $self->{ '_is_in_create' } = 0;
+            }
+            $self->{ '_fct_code_delimiter' } = '1';
+            $self->{ '_is_in_create' } = 0;
+            $self->_add_token( $token );
+            next;
+        }
+        # Store function code delimiter
+        if ($self->{ '_fct_code_delimiter' } eq '1') {
+            $self->{ '_fct_code_delimiter' } = $token;
+            $self->_add_token( $token );
+            $last = $token;
+            $self->_new_line;
+            $self->_over if (defined $self->_next_token && $self->_next_token !~ /^(DECLARE|BEGIN)$/i);
+            next;
+        }
+        # Desactivate the block mode when code delimiter is found for the second time
+        if ($self->{ '_fct_code_delimiter' } && $token eq $self->{ '_fct_code_delimiter' }) {
+            $self->{ '_is_in_block' } = -1;
+            @{ $self->{ '_level_stack' } } = ();
+            $self->{ '_level' } = 0;
+            $self->{ 'break' } = ' ' unless ( $self->{ 'spaces' } != 0 );
+            $self->{ '_fct_code_delimiter' } = '';
+            $self->{ '_current_sql_stmt' } = '';
+            $self->_new_line;
+            $self->_add_token( $token );
+            next;
+        }
 
-	$month ||= '01';
-	push(@months, "$year$month");
-	my $start_month = $month;
-	if ($month eq '01') {
-		unshift(@months, ($year - 1) . "12");
-	} else {
-		unshift(@months, $year . sprintf("%02d", $month - 1));
-	}
-	if ($month == 12) {
-		push(@months, ($year+1) . "01");
-	} else {
-		push(@months, $year . sprintf("%02d", $month + 1));
-	}
+	####
+	# Mark when we are parsing a DECLARE or a BLOCK section. When
+	# entering a BLOCK section store the current indentation level
+	####
+        if (uc($token) eq 'DECLARE') {
+            $self->{ '_is_in_block' } = -1;
+            $self->{ '_is_in_declare' } = 1;
+            $self->_new_line;
+            $self->_add_token( $token );
+            $self->_new_line;
+            $self->_over;
+	    next;
+	}
+        elsif ( uc($token) eq 'BEGIN' ) {
+            $self->{ '_is_in_declare' } = 0;
+            if ($self->{ '_is_in_block' } == -1) {
+                @{ $self->{ '_level_stack' } } = ();
+                $self->{ '_level' } = 0;
+                $self->{ 'break' } = ' ' unless ( $self->{ 'spaces' } != 0 );
+            } else {
+                # Store current indent position to print END at the right level
+                push @{ $self->{ '_level_stack' } }, $self->{ '_level' };
+            }
+            $self->_new_line;
+            $self->_add_token( $token );
+            if (defined $self->_next_token && $self->_next_token ne ';') {
+                $self->_new_line;
+                $self->_over;
+                $self->{ '_is_in_block' }++;
+            }
+	    next;
+        }
 
-	foreach my $d (@months) {
-		$d =~ /^(\d{4})(\d{2})$/;
-		my $y = $1;
-		my $m = $2;
-		foreach my $day ("01" .. "31") {
-			# Check if the date is valid first
-			my $datefmt = POSIX::strftime("%Y-%m-%d", 1, 1, 1, $day, $m - 1, $y - 1900);
-			if ($datefmt ne "$y-$m-$day") {
-				next;
-			}
-			my $weekNumber = '';
-			if (!$week_start_monday) {
-				$weekNumber = POSIX::strftime("%U", 1, 1, 1, $day, $m - 1, $y - 1900);
-			} else {
-				$weekNumber = POSIX::strftime("%W", 1, 1, 1, $day, $m - 1, $y - 1900);
-			}
-			if ( ($weekNumber == $wn) || ( ($weekNumber eq '00') && (($wn == 1) || ($wn >= 52)) ) ) {
-				push(@retdays, "$year-$m-$day");
-				return @retdays if ($#retdays == 6);
-			}
-			next if ($weekNumber > $wn);
-		}
-	}
+	####
+	# Special case where we want to add a newline into ) AS (
+	####
+        if (uc($token) eq 'AS' and $last eq ')' and $self->_next_token eq '(') {
+            $self->_new_line;
+	# and before RETURNS with increasing indent level
+        } elsif (uc($token) eq 'RETURNS') {
+            $self->_new_line;
+            $self->_over;
+        }
 
-	return @retdays;
+        if ( $rule ) {
+            $self->_process_rule( $rule, $token );
+        }
+
+        elsif ($token =~ /^(LANGUAGE|SECURITY|)$/i) {
+            $self->_new_line;
+            $self->_add_token( $token );
+        }
+
+        elsif ( $token eq '(' ) {
+            $self->{ '_is_in_create' }++ if ($self->{ '_is_in_create' });
+            $self->_add_token( $token, $last );
+            if ( !$self->{ '_is_in_index' }) {
+                if (uc($last) eq 'AS' || $self->{ '_is_in_create' } == 2 || uc($self->_next_token) eq 'CASE') {
+                    $self->_new_line;
+                }
+		if ($self->{ '_is_in_with' } == 1) {
+                    $self->_over;
+                    $self->_new_line;
+                    next;
+		}
+                $self->_over;
+                if ($self->{ '_is_in_type' } == 1) {
+                    $last = $token;
+                    next;
+                }
+            }
+        }
+
+        elsif ( $token eq ')' ) {
+	    if ($self->{ '_is_in_with' } == 1) {
+                $self->_back;
+                $self->_new_line;
+                $self->_add_token( $token );
+                next;
+	    }
+            if ($self->{ '_is_in_index' }) {
+                $self->_add_token( '' );
+                $self->_add_token( $token );
+                $last = $token;
+                next;
+            }
+            $self->_new_line if ($self->{ '_is_in_create' } > 1
+                    and (not defined $self->_next_token or $self->_next_token eq ';')
+                );
+            $self->_new_line if ($self->{ '_is_in_type' } == 1
+                    and (not defined $self->_next_token or $self->_next_token eq ';')
+                );
+            $self->{ '_is_in_create' }-- if ($self->{ '_is_in_create' });
+            $self->{ '_is_in_type' }-- if ($self->{ '_is_in_type' });
+            $self->_new_line if ($self->{ '_current_sql_stmt' } ne 'INSERT' and !$self->{ '_is_in_function' } and (defined $self->_next_token and $self->_next_token =~ /^(SELECT|WITH)$/i) and $last ne ')');
+            $self->_back;
+            $self->_add_token( $token );
+            # Do not go further if this is the last token
+            if (not defined $self->_next_token) {
+                $last = $token;
+                next;
+            }
+
+            # When closing CTE statement go back again
+            if ($self->_next_token =~ /^SELECT|INSERT|UPDATE|DELETE$/i) {
+                $self->_back;
+            }
+            if ($self->{ '_is_in_create' } <= 1) {
+                my $next_tok = quotemeta($self->_next_token);
+                $self->_new_line
+                    if (defined $self->_next_token
+                    and $self->_next_token !~ /^AS|THEN|INTO|BETWEEN$/i
+                    and ($self->_next_token !~ /^AND|OR$/i or !$self->{ '_is_in_if' })
+                    and $self->_next_token ne ')'
+                    and $self->_next_token !~ /^:/
+                    and $self->_next_token ne ';'
+                    and $self->_next_token ne ','
+                    and $self->_next_token ne '||'
+                    and ($self->_is_keyword($self->_next_token) or $self->_is_function($self->_next_token))
+                    and !exists  $self->{ 'dict' }->{ 'symbols' }{ $next_tok }
+                );
+            }
+        }
+
+        elsif ( $token eq ',' ) {
+            my $add_newline = 0;
+            $add_newline = 1 if ( !$self->{ 'no_break' }
+                               && !$self->{ '_is_in_function' }
+                               && ($self->{ 'comma_break' } || $self->{ '_current_sql_stmt' } ne 'INSERT')
+                               && ($self->{ '_current_sql_stmt' } ne 'RAISE')
+                               && ($self->{ '_current_sql_stmt' } !~ /^FUNCTION|PROCEDURE$/ || $self->{ '_fct_code_delimiter' } ne '')
+                               && !$self->{ '_is_in_where' }
+                               && !$self->{ '_is_in_index' }
+                               && $self->{ '_current_sql_stmt' } !~ /^(GRANT|REVOKE)$/
+                               && $self->_next_token !~ /^('$|\-\-)/i
+			       && !$self->{ '_parenthesis_function_level' }
+                    );
+
+            if ($self->{ '_is_in_with' } >= 1 && !$self->{ '_parenthesis_level' }) {
+                    $add_newline = 1;
+            }
+            $self->_new_line if ($add_newline && $self->{ 'comma' } eq 'start');
+            $self->_add_token( $token );
+            $self->_new_line if ($add_newline && $self->{ 'comma' } eq 'end');
+        }
+
+        elsif ( $token eq ';' or $token =~ /^\\(?:g|crosstabview|watch)/ ) { # statement separator or executing psql meta command (prefix 'g' includes all its variants)
+	    # Initialize most of statement related variables
+            $self->{ '_has_from' } = 0;
+            $self->{ '_is_in_where' } = 0;
+            $self->{ '_is_in_from' } = 0;
+	    $self->{ '_is_in_join' } = 0;
+            $self->{ '_is_in_create' } = 0;
+            $self->{ '_is_in_type' } = 0;
+            $self->{ '_is_in_function' } = 0;
+            $self->{ '_is_in_index' } = 0;
+            $self->{ '_is_in_if' } = 0;
+            $self->{ '_current_sql_stmt' } = '';
+            $self->{ '_is_in_with' } = 0;
+	    $self->{ '_has_order_by' } = 0;
+            $self->{ '_has_over_in_join' } = 0;
+            $self->{ '_parenthesis_level' } = 0;
+	    $self->{ '_parenthesis_function_level' } = 0;
+            $self->_add_token($token);
+            $self->{ 'break' } = "\n" unless ( $self->{ 'spaces' } != 0 );
+            $self->_new_line;
+            # Add an additional newline after ; when we are not in a function
+            if ($self->{ '_is_in_block' } == -1 and !$self->{ '_is_in_declare' } and !$self->{ '_fct_code_delimiter' }) {
+                $self->{ '_new_line' } = 0;
+                $self->_new_line;
+            }
+            # End of statement; remove all indentation when we are not in a BEGIN/END block
+            if (!$self->{ '_is_in_declare' } && $self->{ '_is_in_block' } == -1) {
+                @{ $self->{ '_level_stack' } } = ();
+                $self->{ '_level' } = 0;
+                $self->{ 'break' } = ' ' unless ( $self->{ 'spaces' } != 0 );
+            } else {
+                if ($#{ $self->{ '_level_stack' } } == -1) {
+                        $self->{ '_level' } = ($self->{ '_is_in_declare' }) ? 1 : ($self->{ '_is_in_block' }+1);
+                } else {
+                        $self->{ '_level' } = $self->{ '_level_stack' }[-1];
+                }
+            }
+        }
+        elsif ($token =~ /^FOR$/i) {
+            if ($self->_next_token =~ /^(UPDATE|KEY|NO)$/i) {
+                $self->_back;
+                $self->_new_line;
+            }
+            $self->_add_token( $token );
+            if ($self->_next_token =~ /^SELECT$/i) {
+                $self->_new_line;
+                $self->_over;
+            }
+        }
+
+        elsif ( $token =~ /^(?:FROM|WHERE|SET|RETURNING|HAVING|VALUES)$/i ) {
+
+            $self->{ 'no_break' } = 0;
+
+            if (uc($last) eq 'DISTINCT' and $token =~ /^FROM$/i) {
+                $self->_add_token( $token );
+                $last = $token;
+                next;
+            }
+            if (($token =~ /^FROM$/i) && $self->{ '_has_from' } && !$self->{ '_is_in_function' }) {
+                $self->{ '_has_from' } = 0;
+            }
+            if ($token =~ /^FROM$/i) {
+                $self->{ '_is_in_from' }++ if (!$self->{ '_is_in_function' });
+            }
+            if ($token =~ /^WHERE$/i) {
+		$self->_back() if ($self->{ '_has_over_in_join' });
+                $self->{ '_is_in_where' }++;
+                $self->{ '_is_in_from' }-- if ($self->{ '_is_in_from' });
+	        $self->{ '_is_in_join' } = 0;
+		$self->{ '_has_over_in_join' } = 0;
+            } elsif (!$self->{ '_is_in_function' }) {
+                $self->{ '_is_in_where' }-- if ($self->{ '_is_in_where' });
+            }
+
+            if ($token =~ /^SET$/i and $self->{ '_is_in_create' }) {
+                # Add newline before SET statement in function header
+                $self->_new_line;
+            } elsif ($token =~ /^WHERE$/i and $self->{ '_current_sql_stmt' } eq 'DELETE') {
+                $self->_new_line;
+                $self->_add_token( $token );
+                $self->_over;
+                $last = $token;
+		$self->{ '_is_in_join' } = 0;
+                next;
+            } elsif ($token !~ /^FROM$/i or (!$self->{ '_is_in_function' } and $self->{ '_current_sql_stmt' } ne 'DELETE')) {
+                if ($token !~ /^SET$/i or !$self->{ '_is_in_index' }) {
+                    $self->_back;
+                    $self->_new_line;
+                }
+            } else {
+                $self->_add_token( $token );
+                $last = $token;
+                next;
+            }
+            if ($token =~ /^VALUES$/i and ($self->{ '_current_sql_stmt' } eq 'INSERT' or $last eq '(')) {
+                $self->_over;
+            }
+            $self->_add_token( $token );
+            if ($token =~ /^VALUES$/i and $last eq '(') {
+                $self->_over;
+            }
+            elsif ( $token =~ /^SET$/i && $self->{ '_current_sql_stmt' } eq 'UPDATE' ) {
+                    $self->_new_line;
+                    $self->_over;
+            }
+            elsif ( $token !~ /^SET$/i || $self->{ '_current_sql_stmt' } eq 'UPDATE' ) {
+                if (defined $self->_next_token and $self->_next_token ne '(' and ($self->_next_token !~ /^(UPDATE|KEY|NO)$/i || uc($token) eq 'WHERE')) {
+                    $self->_new_line;
+                    $self->_over;
+                }
+            }
+        }
+
+        # Add newline before INSERT and DELETE if last token was AS (prepared statement)
+        elsif (defined $last and $token =~ /^INSERT|DELETE$/i and uc($last) eq 'AS') {
+                $self->_new_line;
+                $self->_add_token( $token );
+        }
+
+        elsif ( $self->{ '_current_sql_stmt' } !~ /^(GRANT|REVOKE)$/ and $token =~ /^(?:SELECT|PERFORM|UPDATE|DELETE)$/i ) {
+            $self->{ 'no_break' } = 0;
+
+            if ($token =~ /^UPDATE$/i and $last =~ /^(FOR|KEY)$/i) {
+                $self->_add_token( $token );
+            } elsif ($token !~ /^DELETE$/i) {
+                $self->_new_line;
+                $self->_add_token( $token );
+                $self->_new_line;
+                $self->_over;
+            } else {
+                $self->_add_token( $token );
+            }
+        }
+
+        elsif ( $token =~ /^(?:GROUP|ORDER|LIMIT|EXCEPTION)$/i ) {
+	    $self->{ '_is_in_join' } = 0;
+            if ($token !~ /^EXCEPTION$/i) {
+                $self->_back;
+            } else {
+                $self->{ '_level' } = pop( @{ $self->{ '_level_stack' } } ) || 0;
+            }
+            $self->_new_line;
+            $self->_add_token( $token );
+            # Store current indent position to print END at the right level
+            if ($token =~ /^EXCEPTION$/i) {
+                push @{ $self->{ '_level_stack' } }, $self->{ '_level' };
+                $self->_over;
+            }
+            $self->{ '_is_in_where' }-- if ($self->{ '_is_in_where' });
+        }
+
+        elsif ( $token =~ /^(?:BY)$/i and $last !~ /^(INCREMENT|OWNED)$/ ) {
+            $self->_add_token( $token );
+            $self->_new_line;
+            $self->_over;
+        }
+
+        elsif ( $token =~ /^(?:CASE)$/i ) {
+            $self->_add_token( $token );
+            # Store current indent position to print END at the right level
+            push @{ $self->{ '_level_stack' } }, $self->{ '_level' };
+            # Mark next WHEN statement as first element of a case
+            # to force indentation only after this element
+            $self->{ '_first_when_in_case' } = 1;
+            $self->{ '_is_in_case' }++;
+        }
+
+        elsif ( $token =~ /^(?:WHEN)$/i ) {
+            $self->_back if (!$self->{ '_first_when_in_case' } and defined $last and uc($last) ne 'CASE');
+            $self->_new_line if (not defined $last or uc($last) ne 'CASE');
+            $self->_add_token( $token );
+            $self->_over;
+            $self->{ '_first_when_in_case' } = 0;
+        }
+
+        elsif ( $token =~ /^(?:IF|LOOP)$/i ) {
+            $self->_add_token( $token );
+            if (defined $self->_next_token and $self->_next_token ne ';') {
+                $self->_new_line if ($token =~ /^LOOP$/i);
+                $self->_over;
+                push @{ $self->{ '_level_stack' } }, $self->{ '_level' };
+                if ($token =~ /^IF$/i) {
+                    $self->{ '_is_in_if' } = 1;
+                }
+            }
+        }
+
+        elsif ($token =~ /^THEN$/i) {
+            $self->_add_token( $token );
+            $self->_new_line;
+            $self->{ '_is_in_if' } = 0;
+        }
+
+        elsif ( $token =~ /^(?:ELSE|ELSIF)$/i ) {
+            $self->_back;
+            $self->_new_line;
+            $self->_add_token( $token );
+            $self->_new_line if ($token !~ /^ELSIF$/i);
+            $self->_over;
+        }
+
+        elsif ( $token =~ /^(?:END)$/i ) {
+            $self->{ '_first_when_in_case' } = 0;
+	    if ($self->{ '_is_in_case' }) {
+		$self->{ '_is_in_case' }--;
+		$self->_back;
+	    }
+            # When we are not in a function code block (0 is the main begin/end block of a function)
+            elsif ($self->{ '_is_in_block' } == -1) {
+                # END is closing a create function statement so reset position to begining
+                if ($self->_next_token !~ /^(IF|LOOP|CASE|INTO|FROM|END|ELSE|AND|OR|WHEN|AS|,)$/i) {
+                    @{ $self->{ '_level_stack' } } = ();
+                    $self->{ '_level' } = 0;
+                    $self->{ 'break' } = ' ' unless ( $self->{ 'spaces' } != 0 );
+                } else {
+                    # otherwise back to last level stored at CASE keyword
+                    $self->{ '_level' } = pop( @{ $self->{ '_level_stack' } } ) || 0;
+                }
+            # We are in code block
+            } else {
+                # decrease the block level if this is a END closing a BEGIN block
+                if ($self->_next_token !~ /^(IF|LOOP|CASE|INTO|FROM|END|ELSE|AND|OR|WHEN|AS|,)$/i) {
+                    $self->{ '_is_in_block' }--;
+                }
+                # Go back to level stored with IF/LOOP/BEGIN/EXCEPTION block
+                $self->{ '_level' } = pop( @{ $self->{ '_level_stack' } } ) || 0;
+                $self->_back if ($self->_next_token =~ /^(IF|LOOP|CASE|INTO|FROM|END|ELSE|AND|OR|WHEN|AS|,)$/i);
+            }
+            $self->_new_line;
+            $self->_add_token( $token );
+        }
+
+        elsif ( $token =~ /^(?:UNION|INTERSECT|EXCEPT)$/i ) {
+            $self->{ 'no_break' } = 0;
+	    if ($self->{ '_is_in_join' }) {
+		$self->_back;
+		$self->{ '_is_in_join' } = 0;
+	    }
+	    $self->_back unless defined $last and $last eq '(';
+            $self->_new_line;
+            $self->_add_token( $token );
+            $self->_new_line if ( defined $self->_next_token and $self->_next_token ne '(' and $self->_next_token !~ /^ALL$/i );
+            $self->{ '_is_in_where' }-- if ($self->{ '_is_in_where' });
+	    $self->{ '_is_in_from' } = 0;
+        }
+
+        elsif ( $token =~ /^(?:LEFT|RIGHT|FULL|INNER|OUTER|CROSS|NATURAL)$/i ) {
+            $self->{ 'no_break' } = 0;
+	    if (!$self->{ '_is_in_join' } and ($last and $last ne ')') ) {
+		$self->_back;
+	    }
+	    if ($self->{ '_has_over_in_join' }) {
+		$self->{ '_has_over_in_join' } = 0;
+		$self->_back;
+	    }
+
+            if ( $token =~ /(?:LEFT|RIGHT|FULL|CROSS|NATURAL)$/i ) {
+                $self->_new_line;
+		$self->_over if ( $self->{ '_level' } == 0 );
+            }
+            if ( ($token =~ /(?:INNER|OUTER)$/i) && ($last !~ /(?:LEFT|RIGHT|CROSS|NATURAL|FULL)$/i) ) {
+                $self->_new_line;
+                $self->_over if (!$self->{ '_is_in_join' });
+            } 
+            $self->_add_token( $token );
+        }
+
+        elsif ( $token =~ /^(?:JOIN)$/i ) {
+            $self->{ 'no_break' } = 0;
+            if ( not defined $last or $last !~ /^(?:LEFT|RIGHT|FULL|INNER|OUTER|CROSS|NATURAL)$/i ) {
+                $self->_new_line;
+		$self->_back if ($self->{ '_has_over_in_join' });
+		$self->{ '_has_over_in_join' } = 0;
+            }
+            $self->_add_token( $token );
+	    $self->{ '_is_in_join' } = 1;
+        }
+
+        elsif ( $token =~ /^(?:AND|OR)$/i ) {
+	    # Try to detect AND in BETWEEN clause to prevent newline insert
+            if (uc($token) eq 'AND' and $self->_next_token() =~ /^\d+$/){
+	        $self->_add_token( $token );
+		next;
+	    }
+            $self->{ 'no_break' } = 0;
+            if ($self->{ '_is_in_join' }) {
+		$self->_over;
+		$self->{ '_has_over_in_join' } = 1;
+	    }
+	    $self->{ '_is_in_join' } = 0;
+            if ( !$self->{ '_is_in_if' } and !$self->{ '_is_in_index' } and (!$last or $last !~ /^(?:CREATE)$/i) ) {
+                $self->_new_line;
+            }
+            $self->_add_token( $token );
+        }
+
+        elsif ( $token =~ /^--/ ) {
+            if ( !$self->{ 'no_comments' } ) {
+                $self->_add_token( $token );
+                $self->{ 'break' } = "\n" unless ( $self->{ 'spaces' } != 0 );
+                $self->_new_line;
+                $self->{ 'break' } = ' ' unless ( $self->{ 'spaces' } != 0 );
+            } else {
+                $self->_new_line;
+            }
+        }
+
+        elsif ( $token =~ /^\/\*.*\*\/$/s ) {
+            if ( !$self->{ 'no_comments' } ) {
+                $token =~ s/\n[\s\t]+\*/\n\*/gs;
+                $self->_new_line;
+                $self->_add_token( $token );
+                $self->{ 'break' } = "\n" unless ( $self->{ 'spaces' } != 0 );
+                $self->_new_line;
+                $self->{ 'break' } = " " unless ( $self->{ 'spaces' } != 0 );
+            }
+        }
+
+        elsif ($token =~ /^USING$/i) {
+            if (!$self->{ '_is_in_from' }) {
+                $self->_new_line;
+            } else {
+                # USING from join clause disable line break
+                $self->{ 'no_break' } = 1;
+		$self->{ '_is_in_function' }++;
+            }
+            $self->_add_token($token);
+        }
+        elsif ($token =~ /^\\\S/) { # treat everything starting with a \ and at least one character as psql meta command. 
+            $self->_add_token( $token );
+            $self->_new_line;
+        }
+
+        elsif ($token =~ /^ADD$/i && ($self->{ '_current_sql_stmt' } eq 'SEQUENCE' || $self->{ '_current_sql_stmt' } eq 'ALTER')) {
+            $self->_new_line;
+            $self->_over;
+            $self->_add_token($token);
+        }
+
+        elsif ($token =~ /^INCREMENT$/i && $self->{ '_current_sql_stmt' } eq 'SEQUENCE') {
+            $self->_new_line;
+            $self->_add_token($token);
+        }
+
+        elsif ($token =~ /^NO$/i and $self->_next_token =~ /^(MINVALUE|MAXVALUE)$/i) {
+            $self->_new_line;
+            $self->_add_token($token);
+        }
+
+        elsif (uc($last) ne 'NO' and $token =~ /^(MINVALUE|MAXVALUE)$/i) {
+            $self->_new_line;
+            $self->_add_token($token);
+        }
+
+        elsif ($token =~ /^CACHE$/i) {
+            $self->_new_line;
+            $self->_add_token($token);
+        }
+
+        else {
+             if ($last =~ /^(?:SEQUENCE)$/i and $self->_next_token !~ /^OWNED$/i) {
+                 $self->_add_token( $token );
+                 $self->_new_line;
+                 $self->_over;
+             }
+             else {
+		if (defined $last && $last eq ')' && (!defined $self->_next_token || $self->_next_token ne ';')) {
+		    if (!$self->{ '_parenthesis_level' } && $self->{ '_is_in_from' }) {
+			    $self->{ '_level' } = pop(@{ $self->{ '_level_parenthesis' } }) || 1;
+		    }
+	        }
+                 $self->_add_token( $token, $last );
+            }
+        }
+
+        $last = $token;
+        $pos++;
+    }
+
+    $self->_new_line;
+
+    return;
 }
 
-sub IsLeapYear
-{
-	return ((($_[0] & 3) == 0) && (($_[0] % 100 != 0) || ($_[0] % 400 == 0)));
-} 
+sub _add_token {
+    my ( $self, $token, $last_token ) = @_;
 
-####
-# Display calendar
-####
-sub get_calendar
-{
-	my ($year, $month) = @_;
+    if ( $self->{ 'wrap' } ) {
+        my $wrap;
+        if ( $self->_is_keyword( $token ) ) {
+            $wrap = $self->{ 'wrap' }->{ 'keywords' };
+        }
+        elsif ( $self->_is_constant( $token ) ) {
+            $wrap = $self->{ 'wrap' }->{ 'constants' };
+        }
 
-	my $str = "<table class=\"table table-striped table-hover table-condensed\">\n";
-	my @wday = qw(Su Mo Tu We Th Fr Sa);
-	my @std_day = qw(Su Mo Tu We Th Fr Sa);
-	if ($week_start_monday) {
-		@wday = qw(Mo Tu We Th Fr Sa Su);
-		@std_day = qw(Mo Tu We Th Fr Sa Su);
-	}
-	my %day_lbl = ();
-	for (my $i = 0; $i <= $#wday; $i++) {
-		$day_lbl{$wday[$i]} = $wday[$i];
-	}
-	$str .= "<thead><tr><td>&nbsp;</td>";
-	map { $str .= '<th>' . $day_lbl{$_} . '</th>'; } @wday;
-	$str .= "</tr></thead>\n<tbody>\n";
-	my @currow = ('','','','','','','');
-	my $d = '';
-	my $wd = 0;
-	my $wn = 0;
-	my $week = '';
-	for $d ("01" .. "31") {
-		last if (($d == 31) && grep(/^$month$/, '04','06','09','11'));
-		last if (($d == 30) && ($month eq '02'));
-		last if (($d == 29) && ($month eq '02') && !&IsLeapYear($year));
-		$wd = &get_day_of_week($year,$month,$d);
-		$wn =  &get_week_number($year,$month,$d);
-		next if ($wn == -1);
-		if ( !-e "$outdir/$year/$month/$d/index.html" ) {
-			$currow[$wd] = "<td>$d</td>";
-		} else {
-			$currow[$wd] = "<td><a href=\"$year/$month/$d/index.html\" target=\"new\">$d</a></td>";
-		}
-		if ($wd == 6) {
-			$week = sprintf("%02d", $wn);
-			if (-e "$outdir/$year/week-$week/index.html") {
-				$week = "<th><a href=\"$year/week-$week/index.html\" target=\"new\">$week</a>&nbsp;</th>";
-			} else {
-				$week = "<th>$week</th>";
+        if ( $wrap ) {
+            $token = $wrap->[ 0 ] . $token . $wrap->[ 1 ];
+        }
+    }
+
+    my $last_is_dot = defined( $last_token ) && $last_token eq '.';
+
+    my $sp = $self->_indent;
+
+    if ( !$self->_is_punctuation( $token ) and !$last_is_dot) {
+        if ( (!defined($last_token) || $last_token ne '(') && $token ne ')' && ($token !~ /^::/) ) {
+            $self->{ 'content' } .= $sp if ($token ne ')'
+                                            && defined($last_token)
+                                            && $last_token ne '::' 
+                                            && ($token ne '(' || !$self->_is_function( $last_token ) || $self->{ '_is_in_type' })
+                );
+            $self->{ 'content' } .= $sp if (!defined($last_token) && $token);
+        } elsif ( $self->{ '_is_in_create' } == 2 && defined($last_token)) {
+            $self->{ 'content' } .= $sp if ($last_token ne '::' and ($last_token ne '(' || !$self->{ '_is_in_index' }));
+	} elsif (defined $last_token) {
+            $self->{ 'content' } .= $sp if ($last_token eq '(' && $self->{ '_is_in_type' });
+        }
+	if ($self->_is_comment($token)) {
+		my @lines = split(/\n/, $token);
+		for (my $i = 1; $i <= $#lines; $i++) {
+			if ($lines[$i] =~ /^\s*\*/) {
+				$lines[$i] =~ s/^\s*\*/$sp */;
+			} elsif ($lines[$i] =~ /^\s+[^\*]/) {
+				$lines[$i] =~ s/^\s+/$sp /;
 			}
-			map { $_ = "<td>&nbsp;</td>" if ($_ eq ''); } @currow;
-			$str .= "<tr>$week" . join('', @currow) . "</tr>\n";
-			@currow = ('','','','','','','');
 		}
-	} 
-	if ( ($wd != 6) || ($currow[0] ne '') ) {
-		$week = sprintf("%02d", $wn);
-		if (-e "$outdir/$year/week-$week/index.html") {
-			$week = "<th><a href=\"$year/week-$week/index.html\" target=\"new\">$week</a>&nbsp;</th>";
-		} else {
-			$week = "<th>$week</th>";
-		}
-		map { $_ = "<td>&nbsp;</td>" if ($_ eq ''); } @currow;
-		$str .= "<tr>$week" . join('', @currow) . "</tr>\n";
-		@currow = ('','','','','','','');
+		$token = join("\n", @lines);
+	} else {
+		$token =~ s/\n/\n$sp/gs;
 	}
-	$str .=  "</tbody>\n</table>\n";
+    }
 
-	my %month_name = (
-		'01' => 'January', '02' => 'February', '03' => 'March', '04' => 'April',
-		'05' => 'May', '06' => 'June', '07' => 'July', '08' => 'August',
-		'09' => 'September', '10' => 'October', '11' => 'November', '12' => 'December'
-	);
-	return qq{
-              <div class="panel panel-default">
-                <div class="panel-heading">
-                <i class="fa fa-cogs fa-2x pull-left fa-border"></i>&nbsp;<h2>$month_name{$month}</h2>
-                </div>
-                <div class="panel-body">
-		$str
-                </div>
-              </div>
-};
+    #lowercase/uppercase keywords
+    if ( $self->{ 'uc_keywords' } && $self->_is_keyword( $token ) ) {
+        $token = lc( $token )            if ( $self->{ 'uc_keywords' } == 1 );
+        $token = uc( $token )            if ( $self->{ 'uc_keywords' } == 2 );
+        $token = ucfirst( lc( $token ) ) if ( $self->{ 'uc_keywords' } == 3 );
+    }
+
+    # lowercase/uppercase functions
+    if ( $self->{ 'uc_functions' } && ( my $fct = $self->_is_function( $token ) ) ) {
+        $token =~ s/$fct/\L$fct\E/i if ( $self->{ 'uc_functions' } == 1 );
+        $token =~ s/$fct/\U$fct\E/i if ( $self->{ 'uc_functions' } == 2 );
+        $fct = ucfirst( lc( $fct ) );
+        $token =~ s/$fct/$fct/i if ( $self->{ 'uc_functions' } == 3 );
+    }
+
+    # Add formatting for HTML output
+    if ( $self->{ 'colorize' } && $self->{ 'format' } eq 'html' ) {
+	$token = $self->highlight_code($token, $last_token, $self->_next_token);
+    }
 
+    $self->{ 'content' } .= $token;
+    $self->{ 'content' } =~ s/\(\s+\(/\(\(/gs;
+
+    # This can't be the beginning of a new line anymore.
+    $self->{ '_new_line' } = 0;
 }
 
-sub _gethostbyaddr
-{
-	my $ip = shift;
+sub _over {
+    my ( $self ) = @_;
 
-	my $host = undef;
-	unless(exists $CACHE_DNS{$ip}) {
-		eval {
-			local $SIG{ALRM} = sub { die "DNS lookup timeout.\n"; };
-			alarm($DNSLookupTimeout);
-			$host = gethostbyaddr(inet_aton($ip), AF_INET);
-			alarm(0);
-		};
-		if ($@) {
-			$CACHE_DNS{$ip} = undef;
-			#printf "_gethostbyaddr timeout : %s\n", $ip;
-		}
-		else {
-			$CACHE_DNS{$ip} = $host;
-			#printf "_gethostbyaddr success : %s (%s)\n", $ip, $host;
-		}
-	}
+    ++$self->{ '_level' };
+}
 
-	return $CACHE_DNS{$ip} || $ip;
+sub _back {
+    my ( $self ) = @_;
 
+    --$self->{ '_level' } if ( $self->{ '_level' } > 0 );
 }
 
-sub localdie
+sub _indent {
+    my ( $self ) = @_;
+
+    if ( $self->{ '_new_line' } ) {
+        return $self->{ 'space' } x ( $self->{ 'spaces' } * $self->{ '_level' } );
+    }
+    else {
+        return $self->{ 'space' };
+    }
+}
+
+sub _new_line {
+    my ( $self ) = @_;
+
+    $self->{ 'content' } .= $self->{ 'break' } unless ( $self->{ '_new_line' } );
+    $self->{ '_new_line' } = 1;
+}
+
+sub _next_token {
+    my ( $self ) = @_;
+
+    return @{ $self->{ '_tokens' } } ? $self->{ '_tokens' }->[ 0 ] : undef;
+}
+
+sub _token {
+    my ( $self ) = @_;
+
+    return shift @{ $self->{ '_tokens' } };
+}
+
+sub _is_keyword {
+    my ( $self, $token ) = @_;
+
+    return ~~ grep { $_ eq uc( $token ) } @{ $self->{ 'keywords' } };
+}
+
+sub _is_comment {
+    my ( $self, $token ) = @_;
+
+    return 1 if ( $token =~ m#^((?:--)[\ \t\S]*|/\*[\ \t\r\n\S]*?\*/)$#s );
+
+    return 0;
+}
+
+sub _is_function {
+    my ( $self, $token ) = @_;
+
+    my @ret = grep( $token =~ /\b[\.]*$_$/i, @{ $self->{ 'functions' } } );
+
+    return $ret[ 0 ];
+}
+
+sub add_keywords {
+    my $self = shift;
+
+    for my $keyword ( @_ ) {
+        push @{ $self->{ 'keywords' } }, ref( $keyword ) ? @{ $keyword } : $keyword;
+    }
+}
+
+sub add_functions {
+    my $self = shift;
+
+    for my $function ( @_ ) {
+        push @{ $self->{ 'functions' } }, ref( $function ) ? @{ $function } : $function;
+    }
+}
+
+sub add_rule {
+    my ( $self, $format, $token ) = @_;
+
+    my $rules = $self->{ 'rules' }  ||= {};
+    my $group = $rules->{ $format } ||= [];
+
+    push @{ $group }, ref( $token ) ? @{ $token } : $token;
+}
+
+sub _get_rule {
+    my ( $self, $token ) = @_;
+
+    values %{ $self->{ 'rules' } };    # Reset iterator.
+
+    while ( my ( $rule, $list ) = each %{ $self->{ 'rules' } } ) {
+        return $rule if ( grep { uc( $token ) eq uc( $_ ) } @$list );
+    }
+
+    return;
+}
+
+sub _process_rule {
+    my ( $self, $rule, $token ) = @_;
+
+    my $format = {
+        break => sub { $self->_new_line },
+        over  => sub { $self->_over },
+        back  => sub { $self->_back },
+        token => sub { $self->_add_token( $token ) },
+        push  => sub { push @{ $self->{ '_level_stack' } }, $self->{ '_level' } },
+        pop   => sub { $self->{ '_level' } = pop( @{ $self->{ '_level_stack' } } ) || 0 },
+        reset => sub { $self->{ '_level' } = 0; @{ $self->{ '_level_stack' } } = (); },
+    };
+
+    for ( split /-/, lc $rule ) {
+        &{ $format->{ $_ } } if ( $format->{ $_ } );
+    }
+}
+
+sub _is_constant {
+    my ( $self, $token ) = @_;
+
+    return ( $token =~ /^\d+$/ or $token =~ /^(['"`]).*\1$/ );
+}
+
+sub _is_punctuation {
+    my ( $self, $token ) = @_;
+    if  ($self->{ 'comma' } eq 'start' and $token eq ',') {
+	return 0;
+    }
+    return ( $token =~ /^[,;.]$/ );
+}
+
+sub _generate_anonymized_string {
+    my $self = shift;
+    my ( $before, $original, $after ) = @_;
+
+    # Prevent dates from being anonymized
+    return $original if $original =~ m{\A\d\d\d\d[/:-]\d\d[/:-]\d\d\z};
+    return $original if $original =~ m{\A\d\d[/:-]\d\d[/:-]\d\d\d\d\z};
+
+    # Prevent dates format like DD/MM/YYYY HH24:MI:SS from being anonymized
+    return $original if $original =~ m{
+        \A
+        (?:FM|FX|TM)?
+        (?:
+            HH | HH12 | HH24
+            | MI
+            | SS
+            | MS
+            | US
+            | SSSS
+            | AM | A\.M\. | am | a\.m\.
+            | PM | P\.M\. | pm | p\.m\.
+            | Y,YYY | YYYY | YYY | YY | Y
+            | IYYY | IYY | IY | I
+            | BC | B\.C\. | bc | b\.c\.
+            | AD | A\.D\. | ad | a\.d\.
+            | MONTH | Month | month | MON | Mon | mon | MM
+            | DAY | Day | day | DY | Dy | dy | DDD | DD | D
+            | W | WW | IW
+            | CC
+            | J
+            | Q
+            | RM | rm
+            | TZ | tz
+            | [\s/:-]
+        )+
+        (?:TH|th|SP)?
+        \z
+    };
+
+    # Prevent interval from being anonymized
+
+    return $original if ($before && ($before =~ /interval/i));
+    return $original if ($after && ($after =~ /^\)*::interval/i));
+
+    # Shortcut
+    my $cache = $self->{ '_anonymization_cache' };
+
+    # Range of characters to use in anonymized strings
+    my @chars = ( 'A' .. 'Z', 0 .. 9, 'a' .. 'z', '-', '_', '.' );
+
+    unless ( $cache->{ $original } ) {
+
+        # Actual anonymized version generation
+        $cache->{ $original } = join( '', map { $chars[ rand @chars ] } 1 .. 10 );
+    }
+
+    return $cache->{ $original };
+}
+
+sub anonymize {
+    my $self  = shift;
+    my $query = $self->query;
+
+    return if ( !$query );
+
+    # Variable to hold anonymized versions, so we can provide the same value
+    # for the same input, within single query.
+    $self->{ '_anonymization_cache' } = {};
+
+    # Remove comments
+    $query =~ s/\/\*(.*?)\*\///gs;
+
+    # Clean query
+    $query =~ s/\\'//gs;
+    $query =~ s/('')+/\$EMPTYSTRING\$/gs;
+
+    # Anonymize each values
+    $query =~ s{
+        ([^\s\']+[\s\(]*)       # before
+        '([^']*)'               # original
+        ([\)]*::\w+)?           # after
+    }{$1 . "'" . $self->_generate_anonymized_string($1, $2, $3) . "'" . ($3||'')}xeg;
+
+    $query =~ s/\$EMPTYSTRING\$/''/gs;
+
+    $self->query( $query );
+}
+
+sub set_defaults {
+    my $self = shift;
+    $self->set_dicts();
+
+    # Set some defaults.
+    $self->{ 'query' }        = '';
+    $self->{ 'spaces' }       = 4;
+    $self->{ 'space' }        = ' ';
+    $self->{ 'break' }        = "\n";
+    $self->{ 'wrap' }         = {};
+    $self->{ 'rules' }        = {};
+    $self->{ 'uc_keywords' }  = 0;
+    $self->{ 'uc_functions' } = 0;
+    $self->{ 'no_comments' }  = 0;
+    $self->{ 'placeholder' }  = '';
+    $self->{ 'keywords' }     = $self->{ 'dict' }->{ 'pg_keywords' };
+    $self->{ 'functions' }    = $self->{ 'dict' }->{ 'pg_functions' };
+    $self->{ 'separator' }    = '';
+    $self->{ 'comma' }        = 'end';
+    $self->{ 'format' }       = 'text';
+    $self->{ 'colorize' }     = 1;
+
+    return;
+}
+
+sub format {
+    my $self  = shift;
+    my $format  = shift;
+
+    if ( grep(/^$format$/i, 'text', 'html') ) {
+        $self->{ 'format' } = lc($format);
+	return 1;
+    }
+    return 0;
+}
+
+sub set_dicts {
+    my $self = shift;
+
+    # First load it all as "my" variables, to make it simpler to modify/map/grep/add
+    # Afterwards, when everything is ready, put it in $self->{'dict'}->{...}
+
+    my @pg_keywords = map { uc } qw( 
+        ADD AFTER ALL ALTER ANALYSE ANALYZE AND ANY ARRAY AS ASC ASYMMETRIC AUTHORIZATION AUTO_INCREMENT
+        BACKWARD BEFORE BEGIN BERNOULLI BETWEEN BINARY BOTH BY BY CACHE CASCADE CASE CAST CHECK CHECKPOINT
+        CLOSE CLUSTER COLLATE COLLATION COLUMN COMMENT COMMIT COMMITTED CONCURRENTLY CONFLICT CONSTRAINT
+        CONSTRAINT CONTINUE COPY COST CREATE CROSS CUBE CURRENT_DATE CURRENT_ROLE CURRENT_TIME CURRENT_TIMESTAMP
+        CURRENT_USER CURSOR CYCLE DATABASE DEALLOCATE DECLARE DEFAULT DEFERRABLE DEFERRED DEFINER DELETE DELIMITER
+        DESC DISTINCT DO DOMAIN DROP EACH ELSE ENCODING END EXCEPT EXCLUDING EXECUTE EXISTS EXPLAIN EXTENSION FALSE
+        FETCH FIRST FOR FOREIGN FORWARD FREEZE FROM FULL FUNCTION GRANT GROUP GROUPING HAVING IF ILIKE IMMUTABLE IN
+        INCLUDING INCREMENT INDEX INHERITS INITIALLY INNER INOUT INSERT INSTEAD INTERSECT INTO INVOKER IS ISNULL
+        ISOLATION JOIN KEY LANGUAGE LAST LATERAL LC_COLLATE LC_CTYPE LEADING LEAKPROOF LEFT LIKE LIMIT LISTEN LOAD
+        LOCALTIME LOCALTIMESTAMP LOCATION LOCK LOCKED LOGGED LOGIN LOOP MAPPING MAXVALUE MINVALUE MOVE NATURAL NEXT
+        NO NOCREATEDB NOCREATEROLE NOSUPERUSER NOT NOTIFY NOTNULL NOWAIT NULL OIDS ON ONLY OPEN OPERATOR OR ORDER
+        OUTER OVER OVERLAPS OWNER PARTITION PASSWORD PERFORM PLACING POLICY PRECEDING PREPARE PRIMARY PROCEDURE
+        REASSIGN RECURSIVE REFERENCES REINDEX RENAME REPEATABLE REPLACE REPLICA RESET RESTART RETURN RETURNING
+        RETURNS RETURNS REVOKE RIGHT ROLE ROLLBACK ROLLUP ROWS RULE SAVEPOINT SCHEMA SCROLL SECURITY SELECT SEQUENCE
+        SEQUENCE SERIALIZABLE SERVER SESSION_USER SET SETOF SETS SHOW SIMILAR SKIP SNAPSHOT SOME STABLE START STRICT
+        SYMMETRIC SYSTEM TABLE TABLESAMPLE TABLESPACE TEMPLATE TEMPORARY THEN TO TRAILING TRANSACTION TRIGGER TRUE
+        TRUNCATE TYPE UNBOUNDED UNCOMMITTED UNION UNIQUE UNLISTEN UNLOCK UNLOGGED UPDATE USER USING VACUUM VALUES
+        VARIADIC VERBOSE VIEW VOLATILE WHEN WHERE WINDOW WITH XOR ZEROFILL
+        );
+
+    my @sql_keywords = map { uc } qw(
+        ABORT ABSOLUTE ACCESS ACTION ADMIN AGGREGATE ALSO ALWAYS ASSERTION ASSIGNMENT AT ATTRIBUTE BIGINT BOOLEAN
+        CALLED CASCADED CATALOG CHAIN CHANGE CHARACTER CHARACTERISTICS COLUMNS COMMENTS CONFIGURATION
+        CONNECTION CONSTRAINTS CONTENT CONVERSION CSV CURRENT DATA DATABASES DAY DEC DECIMAL DEFAULTS DELAYED
+        DELIMITERS DESCRIBE DICTIONARY DISABLE DISCARD DOCUMENT DOUBLE ENABLE ENCLOSED ENCRYPTED ENUM ESCAPE ESCAPED
+        EXCLUDE EXCLUSIVE EXTERNAL FIELD FIELDS FLOAT FLUSH FOLLOWING FORCE FUNCTIONS GLOBAL GRANTED GREATEST HANDLER
+        HEADER HOLD HOUR IDENTIFIED IDENTITY IGNORE IMMEDIATE IMPLICIT INDEXES INFILE INHERIT INLINE INPUT INSENSITIVE
+        INT INTEGER KEYS KILL LABEL LARGE LEAST LEVEL LINES LOCAL LOW_PRIORITY MATCH MINUTE MODE MODIFY MONTH NAMES
+        NATIONAL NCHAR NONE NOTHING NULLIF NULLS OBJECT OF OFF OPERATOR OPTIMIZE OPTION OPTIONALLY OPTIONS OUT OUTFILE
+        OWNED PARSER PARTIAL PASSING PLANS PRECISION PREPARED PRESERVE PRIOR PRIVILEGES PROCEDURAL QUOTE RANGE READ
+        REAL RECHECK REF REGEXP RELATIVE RELEASE RESTRICT RLIKE ROW SEARCH SECOND SEQUENCES SESSION SHARE SIMPLE
+        SMALLINT SONAME STANDALONE STATEMENT STATISTICS STATUS STORAGE STRAIGHT_JOIN SYSID TABLES TEMP TERMINATED
+        TREAT TRUSTED TYPES UNENCRYPTED UNKNOWN UNSIGNED UNTIL USE VALID VALIDATE VALIDATOR VALUE VARIABLES VARYING
+        WHITESPACE WITHOUT WORK WRAPPER WRITE XMLATTRIBUTES YEAR YES ZONE
+        );
+
+    my @redshift_keywords =  map { uc } qw(
+        AES128 AES256 ALLOWOVERWRITE BACKUP BLANKSASNULL BYTEDICT BZIP2 CREDENTIALS CURRENT_USER_ID DEFLATE DEFRAG
+        DELTA DELTA32K DISABLE DISTKEY EMPTYASNULL ENABLE ENCODE ENCRYPT ENCRYPTION EXPLICIT GLOBALDICT256
+        GLOBALDICT64K GZIP INTERLEAVED LUN LUNS LZO LZOP MINUS MOSTLY13 MOSTLY32 MOSTLY8 NEW OFFLINE OFFSET OID OLD
+        PARALLEL PERCENT PERMISSIONS RAW READRATIO RECOVER REJECTLOG RESORT RESPECT RESTORE SORTKEY SYSDATE TAG TDES
+        TEXT255 TEXT32K TIMESTAMP TOP TRUNCATECOLUMNS WALLET
+        );
+
+    for my $k ( @pg_keywords ) {
+        next if grep { $k eq $_ } @sql_keywords;
+        push @sql_keywords, $k;
+    }
+
+    for my $k ( @redshift_keywords ) {
+        next if grep { $k eq $_ } @sql_keywords;
+        push @sql_keywords, $k;
+    }
+
+    my @pg_functions = map { lc } qw(
+        ascii age bit_length btrim cast char_length character_length coalesce convert chr current_date current_time current_timestamp
+        count decode date_part date_trunc encode extract get_byte get_bit initcap isfinite interval justify_hours justify_days
+        lower length lpad ltrim localtime localtimestamp md5 now octet_length overlay position pg_client_encoding
+        quote_ident quote_literal repeat replace rpad rtrim substring split_part strpos substr set_byte set_bit
+        trim to_ascii to_hex translate to_char to_date to_timestamp to_number timeofday upper
+        abbrev abs abstime abstimeeq abstimege abstimegt abstimein abstimele
+        abstimelt abstimene abstimeout abstimerecv abstimesend aclcontains acldefault
+        aclexplode aclinsert aclitemeq aclitemin aclitemout aclremove acos
+        any_in any_out anyarray_in anyarray_out anyarray_recv anyarray_send anyelement_in
+        anyelement_out anyenum_in anyenum_out anynonarray_in anynonarray_out anyrange_in anyrange_out
+        anytextcat area areajoinsel areasel armor array_agg array_agg_finalfn
+        array_agg_transfn array_append array_cat array_dims array_eq array_fill array_ge
+        array_gt array_in array_larger array_le array_length array_lower array_lt
+        array_ndims array_ne array_out array_prepend array_recv array_send array_smaller
+        array_to_json array_to_string array_typanalyze array_upper arraycontained arraycontains arraycontjoinsel
+        arraycontsel arrayoverlap ascii_to_mic ascii_to_utf8 asin atan atan2
+        avg big5_to_euc_tw big5_to_mic big5_to_utf8 bit bit_and bit_in
+        bit_or bit_out bit_recv bit_send bitand bitcat bitcmp
+        biteq bitge bitgt bitle bitlt bitne bitnot
+        bitor bitshiftleft bitshiftright bittypmodin bittypmodout bitxor bool
+        bool_and bool_or booland_statefunc booleq boolge boolgt boolin
+        boolle boollt boolne boolor_statefunc boolout boolrecv boolsend
+        box box_above box_above_eq box_add box_below box_below_eq box_center
+        box_contain box_contain_pt box_contained box_distance box_div box_eq box_ge
+        box_gt box_in box_intersect box_le box_left box_lt box_mul
+        box_out box_overabove box_overbelow box_overlap box_overleft box_overright box_recv
+        box_right box_same box_send box_sub bpchar bpchar_larger bpchar_pattern_ge
+        bpchar_pattern_gt bpchar_pattern_le bpchar_pattern_lt bpchar_smaller bpcharcmp bpchareq bpcharge
+        bpchargt bpchariclike bpcharicnlike bpcharicregexeq bpcharicregexne bpcharin bpcharle
+        bpcharlike bpcharlt bpcharne bpcharnlike bpcharout bpcharrecv bpcharregexeq
+        bpcharregexne bpcharsend bpchartypmodin bpchartypmodout broadcast btabstimecmp btarraycmp
+        btbeginscan btboolcmp btbpchar_pattern_cmp btbuild btbuildempty btbulkdelete btcanreturn
+        btcharcmp btcostestimate btendscan btfloat48cmp btfloat4cmp btfloat4sortsupport btfloat84cmp
+        btfloat8cmp btfloat8sortsupport btgetbitmap btgettuple btinsert btint24cmp btint28cmp
+        btint2cmp btint2sortsupport btint42cmp btint48cmp btint4cmp btint4sortsupport btint82cmp
+        btint84cmp btint8cmp btint8sortsupport btmarkpos btnamecmp btnamesortsupport btoidcmp
+        btoidsortsupport btoidvectorcmp btoptions btrecordcmp btreltimecmp btrescan btrestrpos
+        bttext_pattern_cmp bttextcmp bttidcmp bttintervalcmp btvacuumcleanup bytea_string_agg_finalfn bytea_string_agg_transfn
+        byteacat byteacmp byteaeq byteage byteagt byteain byteale
+        bytealike bytealt byteane byteanlike byteaout bytearecv byteasend
+        cash_cmp cash_div_cash cash_div_flt4 cash_div_flt8 cash_div_int2 cash_div_int4 cash_eq
+        cash_ge cash_gt cash_in cash_le cash_lt cash_mi cash_mul_flt4
+        cash_mul_flt8 cash_mul_int2 cash_mul_int4 cash_ne cash_out cash_pl cash_recv
+        cash_send cash_words cashlarger cashsmaller cbrt ceil ceiling
+        center char chareq charge chargt charin charle
+        charlt charne charout charrecv charsend cideq cidin
+        cidout cidr cidr_in cidr_out cidr_recv cidr_send cidrecv
+        cidsend circle circle_above circle_add_pt circle_below circle_center circle_contain
+        circle_contain_pt circle_contained circle_distance circle_div_pt circle_eq circle_ge circle_gt
+        circle_in circle_le circle_left circle_lt circle_mul_pt circle_ne circle_out
+        circle_overabove circle_overbelow circle_overlap circle_overleft circle_overright circle_recv circle_right
+        circle_same circle_send circle_sub_pt clock_timestamp close_lb close_ls close_lseg
+        close_pb close_pl close_ps close_sb close_sl col_description concat
+        concat_ws contjoinsel contsel convert_from convert_to corr cos
+        cot covar_pop covar_samp crypt cstring_in cstring_out cstring_recv
+        cstring_send cume_dist current_database current_query current_schema current_schemas current_setting
+        current_user currtid currtid2 currval date date_cmp date_cmp_timestamp date_cmp_timestamptz date_eq
+        date_eq_timestamp date_eq_timestamptz date_ge date_ge_timestamp date_ge_timestamptz date_gt date_gt_timestamp
+        date_gt_timestamptz date_in date_larger date_le date_le_timestamp date_le_timestamptz date_lt
+        date_lt_timestamp date_lt_timestamptz date_mi date_mi_interval date_mii date_ne date_ne_timestamp
+        date_ne_timestamptz date_out date_pl_interval date_pli date_recv date_send date_smaller
+        date_sortsupport daterange daterange_canonical daterange_subdiff datetime_pl datetimetz_pl
+        dblink_connect_u dblink_connect dblink_disconnect dblink_exec dblink_open dblink_fetch dblink_close
+        dblink_get_connections dblink_error_message dblink_send_query dblink_is_busy dblink_get_notify dblink_get_result
+        dblink_cancel_query dblink_get_pkey dblink_build_sql_insert dblink_build_sql_delete dblink_build_sql_update dblink
+
+        dcbrt dearmor decrypt decrypt_iv degrees dense_rank dexp diagonal
+        diameter digest dispell_init dispell_lexize dist_cpoly dist_lb dist_pb
+        dist_pc dist_pl dist_ppath dist_ps dist_sb dist_sl div
+        dlog1 dlog10 domain_in domain_recv dpow dround dsimple_init
+        dsimple_lexize dsnowball_init dsnowball_lexize dsqrt dsynonym_init dsynonym_lexize dtrunc
+        elem_contained_by_range encrypt encrypt_iv enum_cmp enum_eq enum_first enum_ge
+        enum_gt enum_in enum_larger enum_last enum_le enum_lt enum_ne
+        enum_out enum_range enum_recv enum_send enum_smaller eqjoinsel eqsel
+        euc_cn_to_mic euc_cn_to_utf8 euc_jis_2004_to_shift_jis_2004 euc_jis_2004_to_utf8 euc_jp_to_mic euc_jp_to_sjis euc_jp_to_utf8
+        euc_kr_to_mic euc_kr_to_utf8 euc_tw_to_big5 euc_tw_to_mic euc_tw_to_utf8 every exp
+        factorial family fdw_handler_in fdw_handler_out first_value float4 float48div
+        float48eq float48ge float48gt float48le float48lt float48mi float48mul
+        float48ne float48pl float4_accum float4abs float4div float4eq float4ge
+        float4gt float4in float4larger float4le float4lt float4mi float4mul
+        float4ne float4out float4pl float4recv float4send float4smaller float4um
+        float4up float8 float84div float84eq float84ge float84gt float84le
+        float84lt float84mi float84mul float84ne float84pl float8_accum float8_avg
+        float8_corr float8_covar_pop float8_covar_samp float8_regr_accum float8_regr_avgx float8_regr_avgy float8_regr_intercept
+        float8_regr_r2 float8_regr_slope float8_regr_sxx float8_regr_sxy float8_regr_syy float8_stddev_pop float8_stddev_samp
+        float8_var_pop float8_var_samp float8abs float8div float8eq float8ge float8gt
+        float8in float8larger float8le float8lt float8mi float8mul float8ne
+        float8out float8pl float8recv float8send float8smaller float8um float8up
+        floor flt4_mul_cash flt8_mul_cash fmgr_c_validator fmgr_internal_validator fmgr_sql_validator format
+        format_type gb18030_to_utf8 gbk_to_utf8 gen_random_bytes gen_salt generate_series generate_subscripts
+        get_current_ts_config getdatabaseencoding getpgusername gin_cmp_prefix gin_cmp_tslexeme gin_extract_tsquery gin_extract_tsvector
+        gin_tsquery_consistent ginarrayconsistent ginarrayextract ginbeginscan ginbuild ginbuildempty ginbulkdelete
+        gincostestimate ginendscan gingetbitmap gininsert ginmarkpos ginoptions ginqueryarrayextract
+        ginrescan ginrestrpos ginvacuumcleanup gist_box_compress gist_box_consistent gist_box_decompress gist_box_penalty
+        gist_box_picksplit gist_box_same gist_box_union gist_circle_compress gist_circle_consistent gist_point_compress gist_point_consistent
+        gist_point_distance gist_poly_compress gist_poly_consistent gistbeginscan gistbuild gistbuildempty gistbulkdelete
+        gistcostestimate gistendscan gistgetbitmap gistgettuple gistinsert gistmarkpos gistoptions
+        gistrescan gistrestrpos gistvacuumcleanup gtsquery_compress gtsquery_consistent gtsquery_decompress gtsquery_penalty
+        gtsquery_picksplit gtsquery_same gtsquery_union gtsvector_compress gtsvector_consistent gtsvector_decompress gtsvector_penalty
+        gtsvector_picksplit gtsvector_same gtsvector_union gtsvectorin gtsvectorout has_any_column_privilege has_column_privilege
+        has_database_privilege has_foreign_data_wrapper_privilege has_function_privilege has_language_privilege has_schema_privilege
+        has_sequence_privilege has_server_privilege has_table_privilege has_tablespace_privilege has_type_privilege hash_aclitem
+        hash_array hash_numeric hash_range hashbeginscan hashbpchar hashbuild hashbuildempty hashbulkdelete hashchar hashcostestimate
+        hashendscan hashenum hashfloat4 hashfloat8 hashgetbitmap hashgettuple hashinet
+        hashinsert hashint2 hashint2vector hashint4 hashint8 hashmacaddr hashmarkpos
+        hashname hashoid hashoidvector hashoptions hashrescan hashrestrpos hashtext
+        hashvacuumcleanup hashvarlena height hmac host hostmask iclikejoinsel
+        iclikesel icnlikejoinsel icnlikesel icregexeqjoinsel icregexeqsel icregexnejoinsel icregexnesel
+        inet_client_addr inet_client_port inet_in inet_out inet_recv inet_send inet_server_addr
+        inet_server_port inetand inetmi inetmi_int8 inetnot inetor inetpl
+        int2 int24div int24eq int24ge int24gt int24le int24lt
+        int24mi int24mul int24ne int24pl int28div int28eq int28ge
+        int28gt int28le int28lt int28mi int28mul int28ne int28pl
+        int2_accum int2_avg_accum int2_mul_cash int2_sum int2abs int2and int2div
+        int2eq int2ge int2gt int2in int2larger int2le int2lt
+        int2mi int2mod int2mul int2ne int2not int2or int2out
+        int2pl int2recv int2send int2shl int2shr int2smaller int2um
+        int2up int2vectoreq int2vectorin int2vectorout int2vectorrecv int2vectorsend int2xor
+        int4 int42div int42eq int42ge int42gt int42le int42lt
+        int42mi int42mul int42ne int42pl int48div int48eq int48ge
+        int48gt int48le int48lt int48mi int48mul int48ne int48pl
+        int4_accum int4_avg_accum int4_mul_cash int4_sum int4abs int4and int4div
+        int4eq int4ge int4gt int4in int4inc int4larger int4le
+        int4lt int4mi int4mod int4mul int4ne int4not int4or
+        int4out int4pl int4range int4range_canonical int4range_subdiff int4recv int4send
+        int4shl int4shr int4smaller int4um int4up int4xor int8
+        int82div int82eq int82ge int82gt int82le int82lt int82mi
+        int82mul int82ne int82pl int84div int84eq int84ge int84gt
+        int84le int84lt int84mi int84mul int84ne int84pl int8_accum
+        int8_avg int8_avg_accum int8_sum int8abs int8and int8div int8eq
+        int8ge int8gt int8in int8inc int8inc_any int8inc_float8_float8 int8larger
+        int8le int8lt int8mi int8mod int8mul int8ne int8not
+        int8or int8out int8pl int8pl_inet int8range int8range_canonical int8range_subdiff
+        int8recv int8send int8shl int8shr int8smaller int8um int8up
+        int8xor integer_pl_date inter_lb inter_sb inter_sl internal_in internal_out
+        interval_accum interval_avg interval_cmp interval_div interval_eq interval_ge interval_gt
+        interval_hash interval_in interval_larger interval_le interval_lt interval_mi interval_mul
+        interval_ne interval_out interval_pl interval_pl_date interval_pl_time interval_pl_timestamp interval_pl_timestamptz
+        interval_pl_timetz interval_recv interval_send interval_smaller interval_transform interval_um intervaltypmodin
+        intervaltypmodout intinterval isclosed isempty ishorizontal iso8859_1_to_utf8 iso8859_to_utf8
+        iso_to_koi8r iso_to_mic iso_to_win1251 iso_to_win866 isopen isparallel isperp
+        isvertical johab_to_utf8 json_array_elements jsonb_array_elements json_array_elements_text jsonb_array_elements_text
+        json_array_length jsonb_array_length json_build_array json_build_object json_each jsonb_each json_each_text
+        jsonb_each_text json_extract_path jsonb_extract_path json_extract_path_text jsonb_extract_path_text json_in json_object
+        json_object_keys jsonb_object_keys json_out json_populate_record jsonb_populate_record json_populate_recordset jsonb_pretty
+        jsonb_populate_recordset json_recv json_send jsonb_set json_typeof jsonb_typeof json_to_record jsonb_to_record json_to_recordset
+        jsonb_to_recordset justify_interval koi8r_to_iso koi8r_to_mic koi8r_to_utf8 koi8r_to_win1251 koi8r_to_win866 koi8u_to_utf8
+        lag language_handler_in language_handler_out last_value lastval latin1_to_mic latin2_to_mic latin2_to_win1250
+        latin3_to_mic latin4_to_mic lead like_escape likejoinsel
+        likesel line line_distance line_eq line_horizontal line_in line_interpt
+        line_intersect line_out line_parallel line_perp line_recv line_send line_vertical
+        ln lo_close lo_creat lo_create lo_export lo_import lo_lseek
+        lo_open lo_tell lo_truncate lo_unlink log loread lower_inc
+        lower_inf lowrite lseg lseg_center lseg_distance lseg_eq lseg_ge
+        lseg_gt lseg_horizontal lseg_in lseg_interpt lseg_intersect lseg_le lseg_length
+        lseg_lt lseg_ne lseg_out lseg_parallel lseg_perp lseg_recv lseg_send
+        lseg_vertical macaddr_and macaddr_cmp macaddr_eq macaddr_ge macaddr_gt macaddr_in
+        macaddr_le macaddr_lt macaddr_ne macaddr_not macaddr_or macaddr_out macaddr_recv
+        macaddr_send makeaclitem masklen max mic_to_ascii mic_to_big5 mic_to_euc_cn
+        mic_to_euc_jp mic_to_euc_kr mic_to_euc_tw mic_to_iso mic_to_koi8r mic_to_latin1 mic_to_latin2
+        mic_to_latin3 mic_to_latin4 mic_to_sjis mic_to_win1250 mic_to_win1251 mic_to_win866 min
+        mktinterval mod money mul_d_interval name nameeq namege
+        namegt nameiclike nameicnlike nameicregexeq nameicregexne namein namele
+        namelike namelt namene namenlike nameout namerecv nameregexeq
+        nameregexne namesend neqjoinsel neqsel netmask network network_cmp
+        network_eq network_ge network_gt network_le network_lt network_ne network_sub
+        network_subeq network_sup network_supeq nextval nlikejoinsel nlikesel notlike
+        npoints nth_value ntile numeric numeric_abs numeric_accum numeric_add
+        numeric_avg numeric_avg_accum numeric_cmp numeric_div numeric_div_trunc numeric_eq numeric_exp
+        numeric_fac numeric_ge numeric_gt numeric_in numeric_inc numeric_larger numeric_le
+        numeric_ln numeric_log numeric_lt numeric_mod numeric_mul numeric_ne numeric_out
+        numeric_power numeric_recv numeric_send numeric_smaller numeric_sqrt numeric_stddev_pop numeric_stddev_samp
+        numeric_sub numeric_transform numeric_uminus numeric_uplus numeric_var_pop numeric_var_samp numerictypmodin
+        numerictypmodout numnode numrange numrange_subdiff obj_description oid oideq
+        oidge oidgt oidin oidlarger oidle oidlt oidne
+        oidout oidrecv oidsend oidsmaller oidvectoreq oidvectorge oidvectorgt
+        oidvectorin oidvectorle oidvectorlt oidvectorne oidvectorout oidvectorrecv oidvectorsend
+        oidvectortypes on_pb on_pl on_ppath on_ps on_sb on_sl
+        opaque_in opaque_out overlaps path path_add path_add_pt path_center
+        path_contain_pt path_distance path_div_pt path_in path_inter path_length path_mul_pt
+        path_n_eq path_n_ge path_n_gt path_n_le path_n_lt path_npoints path_out
+        path_recv path_send path_sub_pt pclose percent_rank pg_advisory_lock pg_advisory_lock_shared
+        pg_advisory_unlock pg_advisory_unlock_all pg_advisory_unlock_shared pg_advisory_xact_lock pg_advisory_xact_lock_shared
+        pg_available_extension_versions pg_available_extensions pg_backend_pid pg_cancel_backend pg_char_to_encoding pg_collation_for
+        pg_collation_is_visible pg_column_size pg_conf_load_time pg_conversion_is_visible pg_create_restore_point pg_current_xlog_insert_location
+        pg_current_xlog_location pg_cursor pg_database_size pg_describe_object pg_encoding_max_length pg_encoding_to_char pg_export_snapshot
+        pg_extension_config_dump pg_extension_update_paths pg_function_is_visible pg_get_constraintdef pg_get_expr pg_get_function_arguments
+        pg_get_function_identity_arguments pg_get_function_result pg_get_functiondef pg_get_indexdef pg_get_keywords
+        pg_get_ruledef pg_get_serial_sequence pg_get_triggerdef pg_get_userbyid pg_get_viewdef pg_has_role pg_indexes_size
+        pg_is_in_recovery pg_is_other_temp_schema pg_is_xlog_replay_paused pg_last_xact_replay_timestamp pg_last_xlog_receive_location
+        pg_last_xlog_replay_location pg_listening_channels pg_lock_status pg_ls_dir pg_my_temp_schema pg_node_tree_in pg_node_tree_out
+        pg_node_tree_recv pg_node_tree_send pg_notify pg_opclass_is_visible pg_operator_is_visible pg_opfamily_is_visible pg_options_to_table
+        pg_postmaster_start_time pg_prepared_statement pg_prepared_xact pg_read_binary_file pg_read_file pg_relation_filenode pg_relation_filepath
+        pg_relation_size pg_reload_conf pg_rotate_logfile pg_sequence_parameters pg_show_all_settings pg_size_pretty pg_sleep pg_start_backup
+        pg_stat_clear_snapshot pg_stat_file pg_stat_get_activity pg_stat_get_analyze_count pg_stat_get_autoanalyze_count pg_stat_get_autovacuum_count
+        pg_stat_get_backend_activity pg_stat_get_backend_activity_start pg_stat_get_backend_client_addr pg_stat_get_backend_client_port
+        pg_stat_get_backend_dbid pg_stat_get_backend_idset pg_stat_get_backend_pid pg_stat_get_backend_start pg_stat_get_backend_userid
+        pg_stat_get_backend_waiting pg_stat_get_backend_xact_start pg_stat_get_bgwriter_buf_written_checkpoints pg_stat_get_bgwriter_buf_written_clean
+        pg_stat_get_bgwriter_maxwritten_clean pg_stat_get_bgwriter_requested_checkpoints pg_stat_get_bgwriter_stat_reset_time
+        pg_stat_get_bgwriter_timed_checkpoints pg_stat_get_blocks_fetched pg_stat_get_blocks_hit pg_stat_get_buf_alloc pg_stat_get_buf_fsync_backend
+        pg_stat_get_buf_written_backend pg_stat_get_checkpoint_sync_time pg_stat_get_checkpoint_write_time pg_stat_get_db_blk_read_time
+        pg_stat_get_db_blk_write_time pg_stat_get_db_blocks_fetched pg_stat_get_db_blocks_hit pg_stat_get_db_conflict_all pg_stat_get_db_conflict_bufferpin
+        pg_stat_get_db_conflict_lock pg_stat_get_db_conflict_snapshot pg_stat_get_db_conflict_startup_deadlock pg_stat_get_db_conflict_tablespace
+        pg_stat_get_db_deadlocks pg_stat_get_db_numbackends pg_stat_get_db_stat_reset_time pg_stat_get_db_temp_bytes pg_stat_get_db_temp_files
+        pg_stat_get_db_tuples_deleted pg_stat_get_db_tuples_fetched pg_stat_get_db_tuples_inserted pg_stat_get_db_tuples_returned pg_stat_get_db_tuples_updated
+        pg_stat_get_db_xact_commit pg_stat_get_db_xact_rollback pg_stat_get_dead_tuples pg_stat_get_function_calls pg_stat_get_function_self_time
+        pg_stat_get_function_total_time pg_stat_get_last_analyze_time pg_stat_get_last_autoanalyze_time pg_stat_get_last_autovacuum_time
+        pg_stat_get_last_vacuum_time pg_stat_get_live_tuples pg_stat_get_numscans pg_stat_get_tuples_deleted pg_stat_get_tuples_fetched
+        pg_stat_get_tuples_hot_updated pg_stat_get_tuples_inserted pg_stat_get_tuples_returned pg_stat_get_tuples_updated pg_stat_get_vacuum_count
+        pg_stat_get_wal_senders pg_stat_get_xact_blocks_fetched pg_stat_get_xact_blocks_hit pg_stat_get_xact_function_calls pg_stat_get_xact_function_self_time
+        pg_stat_get_xact_function_total_time pg_stat_get_xact_numscans pg_stat_get_xact_tuples_deleted pg_stat_get_xact_tuples_fetched
+        pg_stat_get_xact_tuples_hot_updated pg_stat_get_xact_tuples_inserted pg_stat_get_xact_tuples_returned pg_stat_get_xact_tuples_updated pg_stat_reset
+        pg_stat_reset_shared pg_stat_reset_single_function_counters pg_stat_reset_single_table_counters pg_stop_backup pg_switch_xlog pg_table_is_visible
+        pg_table_size pg_tablespace_databases pg_tablespace_location pg_tablespace_size pg_terminate_backend pg_timezone_abbrevs pg_timezone_names
+        pg_total_relation_size pg_trigger_depth pg_try_advisory_lock pg_try_advisory_lock_shared pg_try_advisory_xact_lock pg_try_advisory_xact_lock_shared
+        pg_ts_config_is_visible pg_ts_dict_is_visible pg_ts_parser_is_visible pg_ts_template_is_visible
+        pg_type_is_visible pg_typeof pg_xact_commit_timestamp pg_last_committed_xact pg_xlog_location_diff pg_xlog_replay_pause pg_xlog_replay_resume pg_xlogfile_name pg_xlogfile_name_offset
+        pgp_key_id pgp_pub_decrypt pgp_pub_decrypt_bytea pgp_pub_encrypt pgp_pub_encrypt_bytea pgp_sym_decrypt pgp_sym_decrypt_bytea
+        pgp_sym_encrypt pgp_sym_encrypt_bytea pi plainto_tsquery plpgsql_call_handler plpgsql_inline_handler plpgsql_validator
+        point point_above point_add point_below point_distance point_div point_eq
+        point_horiz point_in point_left point_mul point_ne point_out point_recv
+        point_right point_send point_sub point_vert poly_above poly_below poly_center
+        poly_contain poly_contain_pt poly_contained poly_distance poly_in poly_left poly_npoints
+        poly_out poly_overabove poly_overbelow poly_overlap poly_overleft poly_overright poly_recv
+        poly_right poly_same poly_send polygon popen positionjoinsel positionsel
+        postgresql_fdw_validator pow power prsd_end prsd_headline prsd_lextype prsd_nexttoken
+        prsd_start pt_contained_circle pt_contained_poly querytree
+        quote_nullable radians radius random range_adjacent range_after range_before
+        range_cmp range_contained_by range_contains range_contains_elem range_eq range_ge range_gist_compress
+        range_gist_consistent range_gist_decompress range_gist_penalty range_gist_picksplit range_gist_same range_gist_union range_gt
+        range_in range_intersect range_le range_lt range_minus range_ne range_out
+        range_overlaps range_overleft range_overright range_recv range_send range_typanalyze range_union
+        rank record_eq record_ge record_gt record_in record_le record_lt
+        record_ne record_out record_recv record_send regclass regclassin regclassout
+        regclassrecv regclasssend regconfigin regconfigout regconfigrecv regconfigsend regdictionaryin
+        regdictionaryout regdictionaryrecv regdictionarysend regexeqjoinsel regexeqsel regexnejoinsel regexnesel
+        regexp_matches regexp_replace regexp_split_to_array regexp_split_to_table regoperatorin regoperatorout regoperatorrecv
+        regoperatorsend regoperin regoperout regoperrecv regopersend regprocedurein regprocedureout
+        regprocedurerecv regproceduresend regprocin regprocout regprocrecv regprocsend regr_avgx
+        regr_avgy regr_count regr_intercept regr_r2 regr_slope regr_sxx regr_sxy
+        regr_syy regtypein regtypeout regtyperecv regtypesend reltime reltimeeq
+        reltimege reltimegt reltimein reltimele reltimelt reltimene reltimeout
+        reltimerecv reltimesend reverse round row_number row_to_json
+        scalargtjoinsel scalargtsel scalarltjoinsel scalarltsel
+        session_user set_config set_masklen setseed setval setweight shell_in
+        shell_out shift_jis_2004_to_euc_jis_2004 shift_jis_2004_to_utf8 shobj_description sign similar_escape sin
+        sjis_to_euc_jp sjis_to_mic sjis_to_utf8 slope smgreq smgrin smgrne
+        smgrout spg_kd_choose spg_kd_config spg_kd_inner_consistent spg_kd_picksplit spg_quad_choose spg_quad_config
+        spg_quad_inner_consistent spg_quad_leaf_consistent spg_quad_picksplit spg_text_choose spg_text_config spg_text_inner_consistent spg_text_leaf_consistent
+        spg_text_picksplit spgbeginscan spgbuild spgbuildempty spgbulkdelete spgcanreturn spgcostestimate
+        spgendscan spggetbitmap spggettuple spginsert spgmarkpos spgoptions spgrescan
+        spgrestrpos spgvacuumcleanup sqrt statement_timestamp stddev stddev_pop stddev_samp
+        string_agg string_agg_finalfn string_agg_transfn string_to_array strip sum
+        tan text text_ge text_gt text_larger
+        text_le text_lt text_pattern_ge text_pattern_gt text_pattern_le text_pattern_lt text_smaller
+        textanycat textcat texteq texticlike texticnlike texticregexeq texticregexne
+        textin textlen textlike textne textnlike textout textrecv
+        textregexeq textregexne textsend thesaurus_init thesaurus_lexize tideq tidge
+        tidgt tidin tidlarger tidle tidlt tidne tidout
+        tidrecv tidsend tidsmaller time time_cmp time_eq time_ge
+        time_gt time_hash time_in time_larger time_le time_lt time_mi_interval
+        time_mi_time time_ne time_out time_pl_interval time_recv time_send time_smaller
+        time_transform timedate_pl timemi timenow timepl timestamp timestamp_cmp
+        timestamp_cmp_date timestamp_cmp_timestamptz timestamp_eq timestamp_eq_date timestamp_eq_timestamptz timestamp_ge timestamp_ge_date
+        timestamp_ge_timestamptz timestamp_gt timestamp_gt_date timestamp_gt_timestamptz timestamp_hash timestamp_in timestamp_larger
+        timestamp_le timestamp_le_date timestamp_le_timestamptz timestamp_lt timestamp_lt_date timestamp_lt_timestamptz timestamp_mi
+        timestamp_mi_interval timestamp_ne timestamp_ne_date timestamp_ne_timestamptz timestamp_out timestamp_pl_interval timestamp_recv
+        timestamp_send timestamp_smaller timestamp_sortsupport timestamp_transform timestamptypmodin timestamptypmodout timestamptz
+        timestamptz_cmp timestamptz_cmp_date timestamptz_cmp_timestamp timestamptz_eq timestamptz_eq_date timestamptz_eq_timestamp timestamptz_ge
+        timestamptz_ge_date timestamptz_ge_timestamp timestamptz_gt timestamptz_gt_date timestamptz_gt_timestamp timestamptz_in timestamptz_larger
+        timestamptz_le timestamptz_le_date timestamptz_le_timestamp timestamptz_lt timestamptz_lt_date timestamptz_lt_timestamp timestamptz_mi
+        timestamptz_mi_interval timestamptz_ne timestamptz_ne_date timestamptz_ne_timestamp timestamptz_out timestamptz_pl_interval timestamptz_recv
+        timestamptz_send timestamptz_smaller timestamptztypmodin timestamptztypmodout timetypmodin timetypmodout timetz
+        timetz_cmp timetz_eq timetz_ge timetz_gt timetz_hash timetz_in timetz_larger
+        timetz_le timetz_lt timetz_mi_interval timetz_ne timetz_out timetz_pl_interval timetz_recv
+        timetz_send timetz_smaller timetzdate_pl timetztypmodin timetztypmodout timezone tinterval
+        tintervalct tintervalend tintervaleq tintervalge tintervalgt tintervalin tintervalle
+        tintervalleneq tintervallenge tintervallengt tintervallenle tintervallenlt tintervallenne tintervallt
+        tintervalne tintervalout tintervalov tintervalrecv tintervalrel tintervalsame tintervalsend
+        tintervalstart to_json to_tsquery to_tsvector transaction_timestamp trigger_out trunc ts_debug
+        ts_headline ts_lexize ts_match_qv ts_match_tq ts_match_tt ts_match_vq ts_parse
+        ts_rank ts_rank_cd ts_rewrite ts_stat ts_token_type ts_typanalyze tsmatchjoinsel
+        tsmatchsel tsq_mcontained tsq_mcontains tsquery_and tsquery_cmp tsquery_eq tsquery_ge
+        tsquery_gt tsquery_le tsquery_lt tsquery_ne tsquery_not tsquery_or tsqueryin
+        tsqueryout tsqueryrecv tsquerysend tsrange tsrange_subdiff tstzrange tstzrange_subdiff
+        tsvector_cmp tsvector_concat tsvector_eq tsvector_ge tsvector_gt tsvector_le tsvector_lt
+        tsvector_ne tsvectorin tsvectorout tsvectorrecv tsvectorsend txid_current txid_current_snapshot
+        txid_snapshot_in txid_snapshot_out txid_snapshot_recv txid_snapshot_send txid_snapshot_xip txid_snapshot_xmax txid_snapshot_xmin
+        txid_visible_in_snapshot uhc_to_utf8 unknownin unknownout unknownrecv unknownsend unnest
+        upper_inc upper_inf utf8_to_ascii utf8_to_big5 utf8_to_euc_cn utf8_to_euc_jis_2004 utf8_to_euc_jp
+        utf8_to_euc_kr utf8_to_euc_tw utf8_to_gb18030 utf8_to_gbk utf8_to_iso8859 utf8_to_iso8859_1 utf8_to_johab
+        utf8_to_koi8r utf8_to_koi8u utf8_to_shift_jis_2004 utf8_to_sjis utf8_to_uhc utf8_to_win uuid_cmp
+        uuid_eq uuid_ge uuid_gt uuid_hash uuid_in uuid_le uuid_lt
+        uuid_ne uuid_out uuid_recv uuid_send var_pop var_samp varbit
+        varbit_in varbit_out varbit_recv varbit_send varbit_transform varbitcmp varbiteq
+        varbitge varbitgt varbitle varbitlt varbitne varbittypmodin varbittypmodout
+        varchar varchar_transform varcharin varcharout varcharrecv varcharsend varchartypmodin
+        varchartypmodout variance version void_in void_out void_recv void_send
+        width width_bucket win1250_to_latin2 win1250_to_mic win1251_to_iso win1251_to_koi8r win1251_to_mic
+        win1251_to_win866 win866_to_iso win866_to_koi8r win866_to_mic win866_to_win1251 win_to_utf8 xideq
+        xideqint4 xidin xidout xidrecv xidsend xml xml_in xmlcomment xpath xpath_exists table_to_xmlschema
+        query_to_xmlschema cursor_to_xmlschema table_to_xml_and_xmlschema query_to_xml_and_xmlschema
+        schema_to_xml schema_to_xmlschema schema_to_xml_and_xmlschema database_to_xml database_to_xmlschema xmlroot
+        database_to_xml_and_xmlschema table_to_xml query_to_xmlcursor_to_xml xmlcomment xmlconcat xmlelement xmlforest
+        xml_is_well_formed_content xml_is_well_formed_document xml_is_well_formed xml_out xml_recv xml_send xmlagg xmlpi
+        );
+
+    my @copy_keywords = ( 'STDIN', 'STDOUT' );
+
+    my %symbols = (
+        '='  => '=', '<'  => '&lt;', '>' => '&gt;', '|' => '|', ',' => ',', '.' => '.', '+' => '+', '-' => '-',
+        '*' => '*', '/' => '/', '!=' => '!=', '%' => '%', '<=' => '&lt;=', '>=' => '&gt;=', '<>' => '&lt;&gt;'
+    );
+
+    my @brackets = ( '(', ')' );
+
+    # All setting and modification of dicts is done, can set them now to $self->{'dict'}->{...}
+    $self->{ 'dict' }->{ 'pg_keywords' }   = \@pg_keywords;
+    $self->{ 'dict' }->{ 'sql_keywords' }  = \@sql_keywords;
+    $self->{ 'dict' }->{ 'pg_functions' }  = \@pg_functions;
+    $self->{ 'dict' }->{ 'copy_keywords' } = \@copy_keywords;
+    $self->{ 'dict' }->{ 'symbols' }       = \%symbols;
+    $self->{ 'dict' }->{ 'brackets' }      = \@brackets;
+
+    return;
+}
+
+sub _remove_dynamic_code
+{
+    my ($self, $str, $code_sep) = @_;
+
+    my @dynsep = ();
+    push(@dynsep, $code_sep) if ($code_sep && $code_sep ne "'");
+
+    # Try to auto detect the string separator if none are provided.
+    # Note that default single quote separtor is natively supported.
+    if ($#dynsep == -1) {
+	# if a dollar sign is found after EXECUTE then the following string
+	# until an other dollar is found will be understand as a text delimiter
+	@dynsep = $$str =~ /EXECUTE\s+(\$[^\$\s]*\$)/igs;
+    }
+
+    my $idx = 0;
+    foreach my $sep (@dynsep) {
+        while ($$str =~ s/(\Q$sep\E.*?\Q$sep\E)/TEXTVALUE$idx/s) {
+            $self->{dynamic_code}{$idx} = $1;
+            $idx++;
+        }
+    }
+
+    # Replace any COMMENT constant between single quote 
+    while ($$str =~ s/IS\s+('[^;]+);/IS TEXTVALUE$idx;/s) {
+        $self->{dynamic_code}{$idx} = $1;
+        $idx++;
+    }
+}
+
+sub _restore_dynamic_code
 {
-	my $msg = shift;
+        my ($self, $str) = @_;
 
-	print STDERR "$msg";
-	unlink("$PID_DIR/pgbadger.pid");
+        $$str =~ s/TEXTVALUE(\d+)/$self->{dynamic_code}{$1}/gs;
 
-	exit 1;
 }
 
-sub skip_unwanted_line
+sub _remove_comments
 {
+    my ($self, $content) = @_;
 
-	# Skip unwanted lines
-	if ($#exclude_time >= 0) {
-		my $found = 0;
-		foreach (@exclude_time) {
-			if ($prefix_vars{'t_timestamp'} =~ /$_/) {
-				$found = 1;
-				last;
-			}
-		}
-		return 1 if ($found);
-	}
+    my $idx = 0;
 
-	return 1 if ($from && ($from gt $prefix_vars{'t_timestamp'}));
+    while ($$content =~ s/(\/\*(.*?)\*\/)/PGF_COMMENT${idx}A/s) {
+        $self->{'comments'}{"PGF_COMMENT${idx}A"} = $1;
+        $idx++;
+    }
 
-	if ($to   && ($to lt $prefix_vars{'t_timestamp'})) {
-		return -1;
-	}
+    my @lines = split(/\n/, $$content);
+    for (my $j = 0; $j <= $#lines; $j++) {
+	$lines[$j] //= '';
+        # Extract multiline comments as a single placeholder
+        my $old_j = $j;
+        my $cmt = '';
+        while ($lines[$j] =~ /^(\s*\-\-.*)$/) {
+            $cmt .= "$1\n";
+            $j++;
+        }
+        if ( $j > $old_j ) {
+            chomp($cmt);
+            $lines[$old_j] =~ s/^(\s*\-\-.*)$/PGF_COMMENT${idx}A/;
+            $self->{'comments'}{"PGF_COMMENT${idx}A"} = $cmt;
+            $idx++;
+            $j--;
+            while ($j > $old_j) {
+                delete $lines[$j];
+                $j--;
+            }
+        }
+        if ($lines[$j] =~ s/(\s*\-\-.*)$/PGF_COMMENT${idx}A/) {
+            $self->{'comments'}{"PGF_COMMENT${idx}A"} = $1;
+            chomp($self->{'comments'}{"PGF_COMMENT${idx}A"});
+            $idx++;
+        }
 
-	return 0;
+        # Mysql supports differents kinds of comment's starter
+        if ( ($lines[$j] =~ s/(\s*COMMENT\s+'.*)$/PGF_COMMENT${idx}A/) ||
+        ($lines[$j] =~ s/(\s*\# .*)$/PGF_COMMENT${idx}A/) ) {
+            $self->{'comments'}{"PGF_COMMENT${idx}A"} = $1;
+            chomp($self->{'comments'}{"PGF_COMMENT${idx}A"});
+            # Normalize start of comment
+            $self->{'comments'}{"PGF_COMMENT${idx}A"} =~ s/^(\s*)COMMENT/$1\-\- /;
+            $self->{'comments'}{"PGF_COMMENT${idx}A"} =~ s/^(\s*)\#/$1\-\- /;
+            $idx++;
+        }
+    }
+    $$content = join("\n", @lines);
+
+    # Replace subsequent comment by a single one
+    while ($$content =~ s/(PGF_COMMENT\d+A\s*PGF_COMMENT\d+A)/PGF_COMMENT${idx}A/s) {
+        $self->{'comments'}{"PGF_COMMENT${idx}A"} = $1;
+        $idx++;
+    }
 }
 
+sub _restore_comments
+{
+    my ($self, $content) = @_;
+
+    while ($$content =~ s/(PGF_COMMENT\d+A)[\n]*/$self->{'comments'}{$1}\n/s) { delete $self->{'comments'}{$1}; };
+}
+
+1;
+}
+
+
 __DATA__
 
 WRFILE: jquery.jqplot.min.css
diff -pruN 9.2-1/README 10.0-1/README
--- 9.2-1/README	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/README	2018-09-09 17:18:14.000000000 +0000
@@ -14,21 +14,20 @@ SYNOPSIS
 
     Options:
 
-        -a | --average N       : number of minutes to build the average graphs
-                                 of queries and connections. Default 5 minutes.
-        -A | --histo-average N : number of minutes to build the histogram graphs
+        -a | --average minutes : number of minutes to build the average graphs of
+                                 queries and connections. Default 5 minutes.
+        -A | --histo-average min: number of minutes to build the histogram graphs
                                  of queries. Default 60 minutes.
         -b | --begin datetime  : start date/time for the data to be parsed in log.
-        -B | --bar-graph       : use bar graph instead of line by default.
         -c | --dbclient host   : only report on entries for the given client host.
         -C | --nocomment       : remove comments like /* ... */ from queries.
         -d | --dbname database : only report on entries for the given database.
         -D | --dns-resolv      : client ip addresses are replaced by their DNS name.
                                  Be warned that this can really slow down pgBadger.
         -e | --end datetime    : end date/time for the data to be parsed in log.
-        -f | --format logtype  : possible values: syslog, syslog2, stderr, csv and
-                                 pgbouncer. Use this option when pgBadger is not
-                                 able to auto-detect the log format Default: stderr.
+        -f | --format logtype  : possible values: syslog, syslog2, stderr, jsonlog,
+                                 cvs and pgbouncer. Use this option when pgBadger
+                                 is not able to auto-detect the log format.
         -G | --nograph         : disable graphs on HTML output. Enabled by default.
         -h | --help            : show this message and exit.
         -i | --ident name      : programname used as syslog ident. Default: postgres
@@ -42,7 +41,7 @@ SYNOPSIS
                                  last datetime and line parsed. Useful if you want
                                  to watch errors since last run or if you want one
                                  report per day with a log rotated each week.
-        -L | logfile-list file : file containing a list of log file to parse.
+        -L | --logfile-list file:file containing a list of log file to parse.
         -m | --maxlength size  : maximum length of a query, it will be restricted to
                                  the given size. Default: no truncate
         -M | --no-multiline    : do not collect multiline statement to avoid garbage
@@ -120,6 +119,9 @@ SYNOPSIS
         --exclude-time  regex  : any timestamp matching the given regex will be
                                  excluded from the report. Example: "2013-04-12 .*"
                                  You can use this option multiple times.
+        --include-time  regex  : only timestamps matching the given regex will be
+                                 included in the report. Example: "2013-04-12 .*"
+                                 You can use this option multiple times.
         --exclude-appname name : exclude entries for the specified application name
                                  from report. Example: "pg_dump".
         --exclude-line regex   : pgBadger will start to exclude any log entry that
@@ -135,15 +137,21 @@ SYNOPSIS
         --journalctl command   : command to use to replace PostgreSQL logfile by
                                  a call to journalctl. Basically it might be:
                                     journalctl -u postgresql-9.5
-        --pid-dir dirpath      : set the path of the directory where the pid file
-                                 will be written to be able to run two pgBadger at
-                                 the same time.
+        --pid-dir path         : set the path where the pid file must be stored.
+                                  Default /tmp
+        --pid-file file        : set the name of the pid file to manage concurrent
+                                 execution of pgBadger. Default: pgbadger.pid
         --rebuild              : used to rebuild all html reports in incremental
                                  output directories where there is binary data files.
         --pgbouncer-only       : only show PgBouncer related menu in the header.
-        --start-monday         : in incremental mode, weeks start on sunday. Use
-                                 this option to start on monday.
+        --start-monday         : in incremental mode, calendar's weeks start on
+                                 sunday. Use this option to start on monday.
         --normalized-only      : only dump all normalized query to out.txt
+        --log-timezone +/-XX   : Set the number of hours from GMT of the timezone
+                                 that must be used to adjust date/time read from
+                                 log file before beeing parsed. Using this option
+                                 make more difficult log search with a date/time.
+        --prettify-json        : use it if you want json output to be prettified.
 
     pgBadger is able to parse a remote log file using a passwordless ssh
     connection. Use the -r or --remote-host to set the host ip address or
@@ -170,18 +178,18 @@ SYNOPSIS
                            /var/log/postgresql.log
             cat /var/log/postgres.log | pgbadger -
             # Log prefix with stderr log output
-            pgbadger --prefix '%t [%p]: [%l-1] user=%u,db=%d,client=%h' 
+            perl pgbadger --prefix '%t [%p]: user=%u,database=%d,client=%h' 
                             /pglog/postgresql-2012-08-21*
-            pgbadger --prefix '%m %u@%d %p %r %a : ' /pglog/postgresql.log
+            perl pgbadger --prefix '%m %u@%d %p %r %a : ' /pglog/postgresql.log
             # Log line prefix with syslog log output
-            pgbadger --prefix 'user=%u,db=%d,client=%h,appname=%a' 
+            perl pgbadger --prefix 'user=%u,db=%d,client=%h,appname=%a' 
                             /pglog/postgresql-2012-08-21*
             # Use my 8 CPUs to parse my 10GB file faster, much faster
-            pgbadger -j 8 /pglog/postgresql-9.1-main.log
+            perl pgbadger -j 8 /pglog/postgresql-9.1-main.log
 
     Generate Tsung sessions XML file with select queries only:
 
-        pgbadger -S -o sessions.tsung --prefix '%t [%p]: [%l-1] user=%u,db=%d ' /pglog/postgresql-9.1.log
+        perl pgbadger -S -o sessions.tsung --prefix '%t [%p]: user=%u,db=%d ' /pglog/postgresql-9.1.log
 
     Reporting errors every week by cron job:
 
@@ -226,7 +234,7 @@ SYNOPSIS
         pgbadger -r 192.168.1.159 --journalctl 'journalctl -u postgresql-9.5'
 
     you don't need to specify any log file at command line, but if you have
-    others PostgreSQL log files to parse, you can add them as usual.
+    other PostgreSQL log file to parse, you can add them as usual.
 
     To rebuild all incremental html reports after, proceed as follow:
 
@@ -248,11 +256,12 @@ DESCRIPTION
     library and the FontAwesome webfont for better design. Everything is
     embedded.
 
-    pgBadger is able to autodetect your log file format (syslog, stderr or
-    csvlog). It is designed to parse huge log files as well as gzip
-    compressed files. See a complete list of features below. Supported
-    compressed format are gzip, bzip2 and xz. For the xz format you must
-    have an xz version upper than 5.05 that supports the --robot option.
+    pgBadger is able to autodetect your log file format (syslog, stderr,
+    csvlog or jsonlog) if the file is long enough. It is designed to parse
+    huge log files as well as compressed files. Supported compressed format
+    are gzip, bzip2 and xz. For the xz format you must have an xz version
+    upper than 5.05 that supports the --robot option. For the complete list
+    of features see below.
 
     All charts are zoomable and can be saved as PNG images.
 
@@ -426,22 +435,27 @@ POSTGRESQL CONFIGURATION
     through the log_min_duration_statement directive. See the next chapter
     for more information.
 
-    With 'stderr' log format, log_line_prefix must be at least:
+    pgBadger supports any custom format set into the log_line_prefix
+    directive of your postgresql.conf file as long as it at least specify a
+    time escape sequence (%t, %m or %n) and the process related escape
+    sequence (%p or %c).
+
+    For example, with 'stderr' log format, log_line_prefix must be at least:
 
-            log_line_prefix = '%t [%p]: [%l-1] '
+            log_line_prefix = '%t [%p]: '
 
     Log line prefix could add user, database name, application name and
     client ip address as follows:
 
-            log_line_prefix = '%t [%p]: [%l-1] user=%u,db=%d,app=%a,client=%h '
+            log_line_prefix = '%t [%p]: user=%u,db=%d,app=%a,client=%h '
 
     or for syslog log file format:
 
-            log_line_prefix = 'user=%u,db=%d,app=%aclient=%h '
+            log_line_prefix = 'user=%u,db=%d,app=%a,client=%h '
 
     Log line prefix for stderr output could also be:
 
-            log_line_prefix = '%t [%p]: [%l-1] db=%d,user=%u,app=%a,client=%h '
+            log_line_prefix = '%t [%p]: db=%d,user=%u,app=%a,client=%h '
 
     or for syslog output:
 
@@ -467,12 +481,6 @@ POSTGRESQL CONFIGURATION
 
     but this is not only recommended by pgBadger.
 
-    Note: the session line [%l-1] is just used to match the default prefix
-    for "stderr". The -1 has no real purpose and basically is not used in
-    pgBadger statistics / graphs. You can safely remove them from the
-    log_line_prefix but you will need to set the --prefix command line
-    option accordingly.
-
 log_min_duration_statement, log_duration and log_statement
     If you want the query statistics to include the actual query strings,
     you must set log_min_duration_statement to 0 or more milliseconds.
@@ -489,6 +497,11 @@ log_min_duration_statement, log_duration
     have log_statement set to 'all' nothing will be logged with
     log_line_prefix.
 
+    Warning: Do not enable both log_min_duration_statement, log_duration and
+    log_statement, this will result in wrong counter values. Note that this
+    will also increase drastically the size of your log.
+    log_min_duration_statement should always be preferred.
+
 PARALLEL PROCESSING
     To enable parallel processing you just have to use the -j N option where
     N is the number of cores you want to use.
@@ -611,14 +624,14 @@ JSON FORMAT
 AUTHORS
     pgBadger is an original work from Gilles Darold.
 
-    The pgBadger logo is an original creation of Damien Clochard.
+    The pgBadger logo is an original creation of Damien Cazeils.
 
     The pgBadger v4.x design comes from the "Art is code" company.
 
     This web site is a work of Gilles Darold.
 
-    pgBadger is maintained by Gilles Darold, the good folks at Dalibo, and
-    every one who wants to contribute.
+    pgBadger is maintained by Gilles Darold and every one who wants to
+    contribute.
 
     Many people have contributed to pgBadger, they are all quoted in the
     Changelog file.
@@ -626,7 +639,7 @@ AUTHORS
 LICENSE
     pgBadger is free software distributed under the PostgreSQL Licence.
 
-    Copyright (c) 2012-2017, Dalibo
+    Copyright (c) 2012-2018, Gilles Darold
 
     A modified version of the SQL::Beautify Perl Module is embedded in
     pgBadger with copyright (C) 2009 by Jonas Kramer and is published under
diff -pruN 9.2-1/t/basics.t 10.0-1/t/basics.t
--- 9.2-1/t/basics.t	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/t/basics.t	2018-09-09 17:18:14.000000000 +0000
@@ -0,0 +1,29 @@
+#!/usr/bin/env bats
+# -*- shell-script -*-
+
+@test "Inline help" {
+    ./pgbadger --help
+}
+
+@test "Light log report to stdout" {
+    ./pgbadger -o - t/fixtures/light.postgres.log.bz2
+}
+
+@test "Light log report to HTML" {
+    rm -f out.html
+    ./pgbadger --outdir $BATS_TMPDIR t/fixtures/light.postgres.log.bz2
+    # Assert out.html is not created in PWD.
+    ! test -f out.html
+}
+
+@test "Light log to binary" {
+    ./pgbadger -o t/fixtures/light.postgres.bin t/fixtures/light.postgres.log.bz2
+}
+
+@test "From binary to JSON" {
+    ./pgbadger --outdir $BATS_TMPDIR -o test-out.json \
+               --format binary t/fixtures/light.postgres.bin
+    test -f $BATS_TMPDIR/test-out.json
+    SELECT=$(jq .database_info.postgres.SELECT < $BATS_TMPDIR/test-out.json)
+    test $SELECT -gt 0
+}
diff -pruN 9.2-1/t/consistency.t 10.0-1/t/consistency.t
--- 9.2-1/t/consistency.t	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/t/consistency.t	2018-09-09 17:18:14.000000000 +0000
@@ -0,0 +1,43 @@
+#!/usr/bin/env bats
+# -*- shell-script -*-
+
+setup() {
+    IN=t/fixtures/light.postgres.log.bz2
+    BIN=$BATS_TMPDIR/out.bin
+    OUT=$BATS_TMPDIR/out.json
+    OUT_FROM_BIN=$BATS_TMPDIR/out_from_bin.json
+    # Generate report from plain-text log
+    ./pgbadger $IN -o $OUT
+    # Generate intermediate binary file
+    ./pgbadger $IN  -o $BIN
+    # Generate report from binary file
+    ./pgbadger $BIN --format=binary -o $OUT_FROM_BIN
+}
+
+#
+# Assert that analyzing from a plain-text log and from the intermediate binary file
+# will provide the exact same results
+#
+
+@test "Consistent count" {
+    N=$(jq .database_info.postgres.count < $OUT)
+    test $N -eq 629
+    N=$(jq .database_info.postgres.count < $OUT_FROM_BIN)
+    test $N -eq 629
+}
+
+
+@test "Consistent query_total" {
+    N=$(jq .overall_stat.histogram.query_total < $OUT)
+    test $N -eq 629
+    N=$(jq .overall_stat.histogram.query_total < $OUT_FROM_BIN)
+    test $N -eq 629
+}
+
+
+@test "Consistent peak.write" {
+    N=$(jq '.overall_stat.peak."2017-09-06 08:49:19".write' < $OUT)
+    test $N -eq 1
+    N=$(jq '.overall_stat.peak."2017-09-06 08:49:19".write' < $OUT_FROM_BIN)
+    test $N -eq 1
+}
Binary files 9.2-1/t/fixtures/light.postgres.log.bz2 and 10.0-1/t/fixtures/light.postgres.log.bz2 differ
diff -pruN 9.2-1/t/lint.t 10.0-1/t/lint.t
--- 9.2-1/t/lint.t	1970-01-01 00:00:00.000000000 +0000
+++ 10.0-1/t/lint.t	2018-09-09 17:18:14.000000000 +0000
@@ -0,0 +1,9 @@
+#!/usr/bin/env bats
+
+@test "PERL syntax check" {
+    perl -c pgbadger
+}
+
+@test "pod syntax check" {
+    podchecker doc/*.pod
+}
diff -pruN 9.2-1/tools/README.pgbadger_tools 10.0-1/tools/README.pgbadger_tools
--- 9.2-1/tools/README.pgbadger_tools	2017-07-28 11:45:06.000000000 +0000
+++ 10.0-1/tools/README.pgbadger_tools	2018-09-09 17:18:14.000000000 +0000
@@ -87,5 +87,5 @@ and look at the example searching on exp
 Regards,
 
 --
-Team Dalibo
+Gilles Darold
 
